
#include "OmapApiCLI.h"
#include <atlconv.h>
#define DBG_MEM_ALL_SIZE		0
#define Debug_MESSAGEBOX 1
#include <vector>
using namespace std;
namespace OmapCLI
{
	void* OmMalloc(size_t size)
	{
		if (size == DBG_MEM_ALL_SIZE)
			size = size;
		void* pblob = malloc(size);

		return pblob;
	}
	void* zMalloc(size_t size)
	{
		void* pBuf = OmMalloc(size);
		if (pBuf != NULL)
			memset(pBuf, 0, size);
		return pBuf;
	}
	
	string cast_to_string(String^ str, int len = -1,bool toUtf8 = true)
	{
		if (str == nullptr)
		{
			return "";
		}
		cli::array<byte>^ bys = System::Text::Encoding::UTF8->GetBytes(str);
		int iSize = bys->Length + 1;
		char* pBuf = (char*)zMalloc(iSize);
		for (int i = 0; i < iSize-1;i++)
		{
			pBuf[i] = bys[i];
		}
		pBuf[iSize - 1] = '\0';
		if (len>0&&iSize>len)
		{
			pBuf[len - 1] = '\0';
			Utf8Revise(pBuf);
		}
		string stdStr = pBuf;
		free(pBuf);
		return stdStr;
		/*IntPtr ip = Marshal::StringToHGlobalAnsi(str);
		const char* ch = static_cast<const char*>(ip.ToPointer());

		string stdStr = ch;
		Marshal::FreeHGlobal(ip);
		if (len > 0)
		{
			if ((int)stdStr.length() > len - 1)
			{
				stdStr.at(len - 1) = '\0';
			}
		}
		return stdStr;*/
	}
	String^COmapApiCLI::cast_strUtf8_to_String(char *strUtf8)
	{
		if (strUtf8==nullptr)
		{
			return "";
		}
		int iSize = strlen(strUtf8) + 1;
		cli::array<byte>^ by = gcnew cli::array<byte>(iSize);
		for (int i = 0; i < iSize; i++)
		{
			by[i] = strUtf8[i];
		}
		//by[iSize - 1] = '\0';
		return System::Text::Encoding::UTF8->GetString(by)->TrimEnd('\0');
	}
	tagOApiObjGroupV3 *COmapApiCLI::CLI2Dll(tagOApiObjGroup^ pGroup)
	{
		tagOApiObjGroupV3 *pGroupDll = g_omapApi.NewOmapGroupV3();
		if (pGroupDll == nullptr||pGroup == nullptr)
		{
			if (pGroupDll)
			{
				g_omapApi.FreeOmapObjectV3(pGroupDll, OMAP_OBJ_TYPE_GROUP);
			}
			return nullptr;
		}
		pGroupDll->bAutoLoad = pGroup->bAutoLoad;
		//pGroupDll->bCrypt = pGroup->bCrypt;
		pGroupDll->bGroup = pGroup->bGroup;
		//pGroupDll->bLoadOk = pGroup->bLoadOk;
		pGroupDll->iShowLevel = pGroup->iShowLevel;
		pGroupDll->iShowLevelBak = pGroup->iShowLevelBak;
		pGroupDll->iShowLevelMax = pGroup->iShowLevelMax;
		pGroupDll->bShare = pGroup->bShare;
		pGroupDll->bNotHotId = pGroup->bNotHotId;
		pGroupDll->bReadOnly = pGroup->bReadOnly;
		pGroupDll->bRelate = pGroup->bRelate;
		pGroupDll->bSaveMerge = pGroup->bSaveMerge;
		//pGroupDll->nAllChild = pGroup->nAllChild;
		pGroupDll->nChild = pGroup->nChild;
		pGroupDll->dwBind = pGroup->dwBind;
		pGroupDll->dwBindCheck = pGroup->dwBindCheck;
		pGroupDll->bLink = pGroup->bLink;
		pGroupDll->bLinkAutoCheck = pGroup->bLinkAutoCheck;
		pGroupDll->biChildiOverlay = pGroup->biChildiOverlay;
		string strName = cast_to_string(pGroup->strName, MAX_API_NAME_LEN);
		strcpy_s(pGroupDll->strName, strName.c_str());
		string strLink = cast_to_string(pGroup->strLink, MAX_API_NAME_LEN);
		strcpy_s(pGroupDll->strLink, strLink.c_str());
		return pGroupDll;
	}
	tagOApiMapSignV3 *COmapApiCLI::CLI2Dll(tagOApiMapSign^ pSign)
	{
		tagOApiMapSignV3 *pSignDll = g_omapApi.NewOmapSignV3();
		if (pSignDll == nullptr||pSign == nullptr)
		{
			if (pSignDll)
			{
				g_omapApi.FreeOmapObjectV2(pSignDll, OMAP_OBJ_TYPE_SIGN);
			}
			return nullptr;
		}
		pSignDll->iTime = pSign->iTime;
		pSignDll->lat = pSign->lat;
		pSignDll->lng = pSign->lng;
		pSignDll->iAltitude = pSign->iAltitude;
		string strName = cast_to_string(pSign->strName, MAX_API_NAME_LEN);
		strcpy_s(pSignDll->strName, strName.c_str());
		std::string pStrComment = cast_to_string(pSign->pstrComment);
		int len = pStrComment.length();
		if (len > 0)
		{
			pSignDll->pstrComment = (char*)zMalloc(len + 1);
			strcpy_s(pSignDll->pstrComment, len + 1, pStrComment.c_str());
		}
		pSignDll->bEditMode = pSign->bEditMode;
		pSignDll->iOverlayIdx = pSign->iOverlayIdx;
		pSignDll->bRealLl = pSign->bRealLl;
		pSignDll->iTxtShowSta = pSign->iTxtShowSta;
		pSignDll->iTxtShowStaSet = pSign->iTxtShowStaSet;

		pSignDll->pic.iSignAlignFlag = pSign->pic->iSignAlignFlag;
		pSignDll->pic.iSignPicNum = pSign->pic->iSignPicNum;
		pSignDll->pic.iPicScale = pSign->pic->iPicScale;
		pSignDll->pic.iSignPic = pSign->pic->iSignPic;
		pSignDll->pic.dwSignClr = pSign->pic->dwSignClr;
		pSignDll->pic.iSignPicNumOffx = pSign->pic->iSignPicNumOffx;
		pSignDll->pic.iSignPicNumOffy = pSign->pic->iSignPicNumOffy;
		pSignDll->pic.iSignPicNumClr = pSign->pic->iSignPicNumClr;
		pSignDll->pic.iSignPicNumSize = pSign->pic->iSignPicNumSize;
		pSignDll->iTxtType = pSign->iTxtType;
		pSignDll->iShowLevel = pSign->iShowLevel;
		pSignDll->iShowLevelBak = pSign->iShowLevelBak;
		pSignDll->iShowLevelMax = pSign->iShowLevelMax;
		pSignDll->bTimeUncertain = pSign->bTimeUncertain;
		
		string strFontName = cast_to_string(pSign->ei->strFontName, MAX_API_NAME_LEN);
		strcpy_s(pSignDll->ei.strFontName, strFontName.c_str());
		pSignDll->ei.bShowComment = pSign->ei->bShowComment;
		pSignDll->ei.bCommentAlign = pSign->ei->bCommentAlign;
		pSignDll->ei.bFontZoomWithMap = pSign->ei->bFontZoomWithMap;
		pSignDll->ei.bFontWithBox = pSign->ei->bFontWithBox;
		pSignDll->ei.iFontAlpha = pSign->ei->iFontAlpha;
		pSignDll->ei.bFontEffect = pSign->ei->bFontEffect;
		pSignDll->ei.bFontBkStyle = pSign->ei->bFontBkStyle;
		pSignDll->ei.nFontBindLevel = pSign->ei->nFontBindLevel;
		pSignDll->ei.nFontMaxLevel = pSign->ei->nFontMaxLevel;
		pSignDll->ei.nFontMinLevel = pSign->ei->nFontMinLevel;
		pSignDll->ei.iFontSize = pSign->ei->iFontSize;
		pSignDll->ei.dwFontClr = pSign->ei->dwFontClr;
		pSignDll->ei.dwFontBkClr = pSign->ei->dwFontBkClr;
		pSignDll->ei.fFontRotateAngle = pSign->ei->fFontRotateAngle;
		pSignDll->ei.bNoHotFontEvent = pSign->ei->bNoHotFontEvent;
		
		pSignDll->ei.idExt = pSign->ei->idExt;
		for (int i = 0; i < MAX_API_ID_BAK_CNT;i++)
		{
			pSignDll->ei.idExtBak[i] = pSign->ei->idExtBak[i];
		}
		pSignDll->ei.bExtEditable = pSign->ei->bExtEditable;
		pSignDll->ei.nExtDataLen = pSign->ei->nExtDataLen;
		string strExtTypeName = cast_to_string(pSign->ei->strExtTypeName, 10);
		strcpy_s(pSignDll->ei.strExtTypeName, strExtTypeName.c_str());
		pSignDll->ei.bExtMapShow = pSign->ei->bExtMapShow;
		pSignDll->ei.bExtMapThumb = pSign->ei->bExtMapThumb;
		pSignDll->ei.bExtMapZoom = pSign->ei->bExtMapZoom;
		pSignDll->ei.nExtMapBindLevel = pSign->ei->nExtMapBindLevel;
		pSignDll->ei.nExtMapMaxLevel = pSign->ei->nExtMapMaxLevel;
		pSignDll->ei.nExtMapMinLevel = pSign->ei->nExtMapMinLevel;
		pSignDll->ei.nExtMapAlpha = pSign->ei->nExtMapAlpha;
		pSignDll->ei.fMapRotateAngle = pSign->ei->fMapRotateAngle;
		pSignDll->ei.bNoHotMapEvent = pSign->ei->bNoHotMapEvent;
		pSignDll->ei.nExtMapWidth = pSign->ei->nExtMapWidth;
		pSignDll->ei.nExtMapHeight = pSign->ei->nExtMapHeight;
		pSignDll->ei.fXScale = pSign->ei->fXScale;
		pSignDll->ei.fYScale = pSign->ei->fYScale;
		pSignDll->mse.nRadius = pSign->mse->nRadius;
		pSignDll->mse.dwShowClr = pSign->mse->dwShowClr;

		return pSignDll;
	}
	tagOApiMapTrackV3 *COmapApiCLI::CLI2Dll(tagOApiMapTrack^ pTrack)
	{
		tagOApiMapTrackV3 *pTrackDll = g_omapApi.NewOmapTrackV3();
		if (pTrackDll==nullptr||pTrack == nullptr)
		{
			if (pTrackDll)
			{
				g_omapApi.FreeOmapObjectV2(pTrackDll, OMAP_OBJ_TYPE_TRACK);
			}
			return nullptr;
		}
		string strName = cast_to_string(pTrack->strName, MAX_API_NAME_LEN);
		strcpy_s(pTrackDll->strName, strName.c_str());
		std::string pStrComment = cast_to_string(pTrack->pstrComment);
		int len = pStrComment.length();
		if (len > 0)
		{
			pTrackDll->pstrComment = (char*)zMalloc(len + 1);
			strcpy_s(pTrackDll->pstrComment, len + 1, pStrComment.c_str());
		}
		pTrackDll->iTrackType = pTrack->iTrackType;
		pTrackDll->iOverlayIdx = pTrack->iOverlayIdx;
		pTrackDll->bRealLl = pTrack->bRealLl; 
		pTrackDll->iShowLevel = pTrack->iShowLevel;
		pTrackDll->iShowLevelBak = pTrack->iShowLevelBak;
		pTrackDll->iShowLevelMax = pTrack->iShowLevelMax;
		pTrackDll->bShowName = pTrack->bShowName; 
		pTrackDll->bEdit = pTrack->bEdit;
		pTrackDll->dwAltitudeColor = pTrack->dwAltitudeColor;
		pTrackDll->dwCustom1 = pTrack->dwCustom1;
		pTrackDll->dwCustom2 = pTrack->dwCustom2;
		pTrackDll->iCustomType1 = pTrack->iCustomType1;
		pTrackDll->iCustomType2 = pTrack->iCustomType2;
		pTrackDll->iCustomType3 = pTrack->iCustomType3;
		pTrackDll->iCustomType4 = pTrack->iCustomType4;
		
		
		int iSize = pTrack->pMtp->Length;
		pTrackDll->nMtp = iSize;
		pTrackDll->pMtp = (tagOApiMapTrackPointV1*)zMalloc(sizeof(tagOApiMapTrackPointV1)*iSize);
		for (int i = 0; i < iSize; i++)
		{
			if (pTrack->pMtp[i] == nullptr)
			{
				break;
			}
			pTrackDll->pMtp[i].dCadBulge = pTrack->pMtp[i]->dCadBulge;
			pTrackDll->pMtp[i].iAltitude = pTrack->pMtp[i]->iAltitude;
			pTrackDll->pMtp[i].iCadRet = pTrack->pMtp[i]->iCadRet;
			pTrackDll->pMtp[i].lat = pTrack->pMtp[i]->lat;
			pTrackDll->pMtp[i].lng = pTrack->pMtp[i]->lng;
			pTrackDll->pMtp[i].time = pTrack->pMtp[i]->time;
		}
		
		pTrackDll->mtd.dwLineClr = pTrack->mtd->dwLineClr;
		pTrackDll->mtd.dwCircleClr = pTrack->mtd->dwCircleClr;
		pTrackDll->mtd.iLineWidth = pTrack->mtd->iLineWidth;
		pTrackDll->mtd.iCircleWidth = pTrack->mtd->iCircleWidth;
		pTrackDll->mtd.iLineAlpha = pTrack->mtd->iLineAlpha;
		pTrackDll->mtd.iShowType = pTrack->mtd->iShowType;
		pTrackDll->mtd.iLineType = pTrack->mtd->iLineType;
		pTrackDll->mtd.bClose = pTrack->mtd->bClose;
		
		return pTrackDll;
	}
	tagOApiMapShapeV3 *COmapApiCLI::CLI2Dll(tagOApiMapShape^ pShape)
	{
		tagOApiMapShapeV3 *pShapeDll = g_omapApi.NewOmapShapeV3();
		if (pShapeDll == nullptr || pShape == nullptr)
		{
			if(pShapeDll)
			{
				g_omapApi.FreeOmapObjectV3(pShapeDll, OMAP_OBJ_TYPE_SHAPE);
			}
			return nullptr;
		}
		int iSize = pShape->pMtp->Length;
		pShapeDll->nMtp = iSize;
		pShapeDll->pMtp = (tagOApiMapTrackPointV1*)zMalloc(sizeof(tagOApiMapTrackPointV1)*iSize);
		for (int i = 0; i < iSize; i++)
		{
			if (pShape->pMtp[i] == nullptr)
			{
				break;
			}
			pShapeDll->pMtp[i].dCadBulge = pShape->pMtp[i]->dCadBulge;
			pShapeDll->pMtp[i].iAltitude = pShape->pMtp[i]->iAltitude;
			pShapeDll->pMtp[i].iCadRet = pShape->pMtp[i]->iCadRet;
			pShapeDll->pMtp[i].lat = pShape->pMtp[i]->lat;
			pShapeDll->pMtp[i].lng = pShape->pMtp[i]->lng;
			pShapeDll->pMtp[i].time = pShape->pMtp[i]->time;
		}
		string strName = cast_to_string(pShape->strName, MAX_API_NAME_LEN);
		strcpy_s(pShapeDll->strName, strName.c_str());
		std::string pStrComment = cast_to_string(pShape->pstrComment);
		int len = pStrComment.length();
		if (len > 0)
		{
			pShapeDll->pstrComment = (char*)zMalloc(len + 1);
			strcpy_s(pShapeDll->pstrComment, len + 1, pStrComment.c_str());
		}
		pShapeDll->iShowFlag = pShape->iShowFlag;
		pShapeDll->iOverlayIdx = pShape->iOverlayIdx;
		pShapeDll->bRealLl = pShape->bRealLl;
		pShapeDll->dStartAngle = pShape->dStartAngle;
		pShapeDll->dEndAngle = pShape->dEndAngle;
		pShapeDll->iLineWidth = pShape->iLineWidth;
		pShapeDll->iLineAlpha = pShape->iLineAlpha;
		pShapeDll->iLineType = pShape->iLineType;
		pShapeDll->iAreaAlpha = pShape->iAreaAlpha;
		pShapeDll->bEditMode = pShape->bEditMode;
		pShapeDll->iShowLevel = pShape->iShowLevel;
		pShapeDll->iShowLevelBak = pShape->iShowLevelBak;
		pShapeDll->iShowLevelMax = pShape->iShowLevelMax;
		pShapeDll->iFillType = pShape->iFillType;
		pShapeDll->iFillSubType = pShape->iFillSubType;
		pShapeDll->iOuterRgnIdx = pShape->iOuterRgnIdx;
		pShapeDll->dwLineClr = pShape->dwLineClr;
		pShapeDll->dwAreaClr = pShape->dwAreaClr;

		pShapeDll->dwFillPattern = pShape->dwFillPattern;
		pShapeDll->dwFillChgClr = pShape->dwFillChgClr;
		pShapeDll->fFillRotate = pShape->fFillRotate;
		pShapeDll->fFillScale = pShape->fFillScale;
		pShapeDll->fFillOffsetX = pShape->fFillOffsetX;
		pShapeDll->fFillOffsetY = pShape->fFillOffsetY;
		
		return pShapeDll;
	}
	tagOApiMapDirectionsV3 *COmapApiCLI::CLI2Dll(tagOApiMapDirections^ pDir)
	{
		tagOApiMapDirectionsV3 *pDirDll = g_omapApi.NewOmapDirV3();
		if (pDirDll == nullptr||pDir == nullptr)
		{
			if (pDirDll)
			{
				g_omapApi.FreeOmapObjectV3(pDirDll, OMAP_OBJ_TYPE_DIR);
			}
			return nullptr;
		}
		string strName = cast_to_string(pDir->strName, MAX_API_NAME_LEN);
		strcpy_s(pDirDll->strName, strName.c_str());
		string strTitle = cast_to_string(pDir->strTitle, ARRAY_LEN);
		strcpy_s(pDirDll->strTitle, strTitle.c_str());
		string strDirStart = cast_to_string(pDir->strDirStart, 64);
		strcpy_s(pDirDll->strDirStart, strDirStart.c_str());
		string strDirEnd = cast_to_string(pDir->strDirEnd, 64);
		strcpy_s(pDirDll->strDirEnd, strDirEnd.c_str());
		string strGroup = cast_to_string(pDir->strGroup, 255);
		strcpy_s(pDirDll->strGroup, strGroup.c_str());
		string pStrComment = cast_to_string(pDir->pstrComment);
		int len = pStrComment.length();
		if (len > 0)
		{
			pDirDll->pstrComment = (char*)zMalloc(len + 1);
			strcpy_s(pDirDll->pstrComment, len + 1, pStrComment.c_str());
		}
		pDirDll->bEdit = pDir->bEdit;
		pDirDll->iLineWidth = pDir->iLineWidth;
		pDirDll->iLineAlpha = pDir->iLineAlpha;
		pDirDll->dwLineClr = pDir->dwLineClr;
		pDirDll->iExportFlag = pDir->iExportFlag;
		pDirDll->iOverlayIdx = pDir->iOverlayIdx;
		pDirDll->bRealLl = pDir->bRealLl;
		
		pDirDll->iShowLevel = pDir->iShowLevel;
		pDirDll->iShowLevelBak = pDir->iShowLevelBak;
		pDirDll->iShowLevelMax = pDir->iShowLevelMax;
		
		pDirDll->dirSrh.iDirMode = pDir->dirSrh->iDirMode;
		pDirDll->dirSrh.mpEnd.lat = pDir->dirSrh->mpEnd->lat;
		pDirDll->dirSrh.mpEnd.lng = pDir->dirSrh->mpEnd->lng;
		pDirDll->dirSrh.mpStart.lat = pDir->dirSrh->mpStart->lat;
		pDirDll->dirSrh.mpStart.lng = pDir->dirSrh->mpStart->lng;
		pDirDll->nUnit = pDir->nUnit;
		for (int i = 0; i < MAX_API_DIR_WAYPOINTS;i++)
		{
			if (pDir->dirSrh->mpVia[i]!=nullptr)
			{
				pDirDll->dirSrh.mpVia[i].lat = pDir->dirSrh->mpVia[i]->lat;
				pDirDll->dirSrh.mpVia[i].lng = pDir->dirSrh->mpVia[i]->lng;
			}
		}
		if (pDirDll->nUnit>0)
		{
			pDirDll->punit = (struct tagOApiMapDirectionsUnitV1*)zMalloc(sizeof(tagOApiMapDirectionsUnitV1)*pDirDll->nUnit);
			for (int i = 0; i < pDirDll->nUnit;i++)
			{
				if (pDir->punit[i] == nullptr)
				{
					break;
				}
				pDirDll->punit[i].iType = pDir->punit[i]->iType;
				string strTitle = cast_to_string(pDir->punit[i]->strTitle, ARRAY_LEN);
				strcpy_s(pDirDll->punit[i].strTitle, strTitle.c_str());
				pDirDll->punit[i].nSubCount = MinValue(pDir->punit[i]->nSubCount,ARRAY_NUM);
				if (pDirDll->punit[i].nSubCount>0)
				{
					if (pDirDll->punit[i].nSubCount == pDir->punit[i]->strSubTitle->Length)
					{
						for (int j = 0; j < pDirDll->punit[i].nSubCount; j++)
						{
							if (pDir->punit[i]->strSubTitle[j] == nullptr)
							{
								break;
							}
							string strSubTitle = cast_to_string(pDir->punit[i]->strSubTitle[j], ARRAY_LEN);
							strcpy_s(pDirDll->punit[i].strSubTitle[j], strSubTitle.c_str());
						}
					}
				}
				pDirDll->punit[i].nLl = pDir->punit[i]->nLl;
				if (pDirDll->punit[i].nLl>0)
				{
					if (pDirDll->punit[i].nLl = pDir->punit[i]->llList->Length)
					{
						pDirDll->punit[i].llList = (tagOApiLatLngV1*)zMalloc(sizeof(tagOApiLatLngV1)*pDirDll->punit[i].nLl);
						for (int j = 0; j < pDirDll->punit[i].nLl; j++)
						{
							if (pDir->punit[i]->llList[j] == nullptr)
							{
								break;
							}
							pDirDll->punit[i].llList[j].lat = pDir->punit[i]->llList[j]->lat;
							pDirDll->punit[i].llList[j].lng = pDir->punit[i]->llList[j]->lng;
						}
					}
					
				}
			}
		}
		
		return pDirDll;
	}
	tagOApiObjectSrhReq *COmapApiCLI::CLI2Dll(tagOApiObjectSrhReqCli^ pSrh)
	{
		tagOApiObjectSrhReq *pSrhDll = (tagOApiObjectSrhReq*)zMalloc(sizeof(tagOApiObjectSrhReq));
		if (pSrhDll == nullptr||pSrh == nullptr)
		{
			if (pSrhDll)
			{
				free(pSrhDll);
			}
			return nullptr;
		}
		pSrhDll->bNoCase = pSrh->bNoCase;
		pSrhDll->bNoChild = pSrh->bNoChild;
		pSrhDll->idParent = pSrh->idParent;
		pSrhDll->idShapeSelect = pSrh->idShapeSelect;
		pSrhDll->iMaxCnt = pSrh->iMaxCnt;
		pSrhDll->iObjType = pSrh->iObjType;
		pSrhDll->iReqVer = pSrh->iReqVer;
		pSrhDll->iSrhOpt = pSrh->iSrhOpt;
		pSrhDll->iSrhValue = pSrh->iSrhValue;
		string strSrhTxt = cast_to_string(pSrh->strSrhTxt, MAX_API_NAME_LEN);
		strcpy_s(pSrhDll->strSrhTxt,strSrhTxt.c_str());
		return pSrhDll;
	}
	tagOApiRelatePointV1 *COmapApiCLI::CLI2Dll(tagOApiRelatePoint^ pPoint)
	{
		tagOApiRelatePointV1 *pPointDll = (tagOApiRelatePointV1*)zMalloc(sizeof(tagOApiRelatePointV1));
		if (pPointDll==nullptr||pPoint==nullptr)
		{
			if (pPointDll)
			{
				free(pPointDll);
			}
			return nullptr;
		}
		pPointDll->bReal = pPoint->bReal;
		pPointDll->lat = pPoint->lat;
		pPointDll->lng = pPoint->lng;
		pPointDll->x = pPoint->x;
		pPointDll->y = pPoint->y;
		return pPointDll;
	}
	tagOApiRelatePointV1 *COmapApiCLI::CLI2Dll(cli::array<tagOApiRelatePoint^>^ pPoints)
	{
		if (pPoints==nullptr)
		{
			return nullptr;
		}
		int iSize = pPoints->Length;
		if (iSize==0)
		{
			return nullptr;
		}
		tagOApiRelatePointV1 *pPointsDll = (tagOApiRelatePointV1*)zMalloc(sizeof(tagOApiRelatePointV1)*iSize);
		if (pPointsDll==nullptr)
		{
			return nullptr;
		}
		for (int i = 0; i < iSize;i++)
		{
			if (pPoints[i] == nullptr)
			{
				break;
			}
			pPointsDll[i].bReal = pPoints[i]->bReal;
			pPointsDll[i].lat = pPoints[i]->lat;
			pPointsDll[i].lng = pPoints[i]->lng;
			pPointsDll[i].x = pPoints[i]->x;
			pPointsDll[i].y = pPoints[i]->y;
		}
		return pPointsDll;
	}
	tagOPhotoMapPic *COmapApiCLI::CLI2Dll(cli::array<tagOphotoMapPicCli^>^ pOmps)
	{
		if (pOmps == nullptr)
		{
			return nullptr;
		}
		//pPics->Count;
		int iSize = pOmps->Length;
		if (iSize == 0)
		{
			return nullptr;
		}
		tagOPhotoMapPic *pOmDll = (tagOPhotoMapPic*)zMalloc(sizeof(tagOPhotoMapPic)*iSize);
		if (pOmDll == nullptr)
		{
			return nullptr;
		}
		for (int i = 0; i < iSize; i++)
		{
			if (pOmps[i] == nullptr)
			{
				break;
			}
			pOmDll[i].iAction = pOmps[i]->iAction;
			pOmDll[i].lat = pOmps[i]->lat;
			pOmDll[i].lng = pOmps[i]->lng;
			pOmDll[i].idPic = pOmps[i]->idPic;
			pOmDll[i].iTmp = pOmps[i]->iTmp;
			pOmDll[i].tmPhoto = pOmps[i]->tmPhoto;
		}
		return pOmDll;
	}
	DWORD* COmapApiCLI::CLI2Dll(cli::array<UINT>^ pidList)
	{
		if (pidList == nullptr)
		{
			return nullptr;
		}
		int nIds = pidList->Length;
		if (nIds==0)
		{
			return nullptr;
		}
		DWORD* pIds = (DWORD*)zMalloc(sizeof(DWORD)*nIds);
		for (int i = 0; i < nIds;i++)
		{
			pIds[i] = pidList[i];
		}
		return pIds;
	}
	tagOmapGetMapFile* COmapApiCLI::CLI2Dll(cli::array<tagOmapGetMapFileCli^>^ pMapFiles)
	{
		if (pMapFiles==nullptr)
		{
			return nullptr;
		}
		int nFiles = pMapFiles->Length;
		tagOmapGetMapFile*pMapFileDll = (tagOmapGetMapFile*)zMalloc(sizeof(tagOmapGetMapFile)*nFiles);
		if (pMapFileDll==nullptr)
		{
			return nullptr;
		}
		for (int i = 0; i < nFiles; i++)
		{

			//pMapFileDll[i].bFile = pMapFile[i]->bFile;
			pMapFileDll[i].bImageType = pMapFiles[i]->bImageType;
			pMapFileDll[i].bRealLl = pMapFiles[i]->bRealLl;
			pMapFileDll[i].bSendReq = pMapFiles[i]->bSendReq;
			pMapFileDll[i].height = pMapFiles[i]->height;
			pMapFileDll[i].idMap = pMapFiles[i]->idMap;
			pMapFileDll[i].iFlag = pMapFiles[i]->iFlag;
			//pMapFileDll[i].iHasPic = pMapFiles[i]->iHasPic;
			pMapFileDll[i].iMapLevel = pMapFiles[i]->iMapLevel;
			pMapFileDll[i].iMapType = pMapFiles[i]->iMapType;
			pMapFileDll[i].iPostCnt = pMapFiles[i]->iPostCnt;
			//pMapFileDll[i].iTotalPic = pMapFiles[i]->iTotalPic;
			pMapFileDll[i].iValue = pMapFiles[i]->iValue;
			string strFile = cast_to_string(pMapFiles[i]->strFile);
			strcpy_s(pMapFileDll[i].strFile, strFile.c_str());
			pMapFileDll[i].width = pMapFiles[i]->width;
			pMapFileDll[i].x_lng1 = pMapFiles[i]->x_lng1;
			pMapFileDll[i].y_lat1 = pMapFiles[i]->y_lat1;
			pMapFileDll[i].x_lng2 = pMapFiles[i]->x_lng2;
			pMapFileDll[i].y_lat2 = pMapFiles[i]->y_lat2;
		}
		return pMapFileDll;
	}
	tagOmapReqContour* COmapApiCLI::CLI2Dll(tagOmapReqContourCli^ pCon)
	{
		if (pCon == nullptr)
		{
			return nullptr;
		}
		tagOmapReqContour*pConsDll = (tagOmapReqContour*)zMalloc(sizeof(tagOmapReqContour));
		if (pConsDll == nullptr)
		{
			return nullptr;
		}
		pConsDll->iCheckFlag = pCon->iCheckFlag;
		pConsDll->iPostCnt = pCon->iPostCnt;
		pConsDll->iElevValue = pCon->iElevValue;
		pConsDll->bRealLl = pCon->bRealLl;
		pConsDll->idMap = pCon->idMap;
		pConsDll->iMapLevel = pCon->iMapLevel;
		pConsDll->iValue = pCon->iValue;
		pConsDll->x_lng1 = pCon->x_lng1;
		pConsDll->y_lat1 = pCon->y_lat1;
		pConsDll->x_lng2 = pCon->x_lng2;
		pConsDll->y_lat2 = pCon->y_lat2;
		return pConsDll;
	}
	
	tagOApiPrj* COmapApiCLI::CLI2Dll(tagPrj^ prj)
	{
		if (prj == nullptr)
		{
			return nullptr;
		}
		tagOApiPrj* pPrj = (tagOApiPrj*)zMalloc(sizeof(tagOApiPrj));
	
		pPrj->dAngularUnit = prj->dAngularUnit;
		pPrj->dAzimuth = prj->dAzimuth;
		pPrj->dCentralMeridian = prj->dCentralMeridian;
		pPrj->dFalseEasting = prj->dFalseEasting;
		pPrj->dFalseNorthing = prj->dFalseNorthing;
		pPrj->dInverseFlattening = prj->dInverseFlattening;
		pPrj->dLatitude_Of_1st_Point = prj->dLatitude_Of_1st_Point;
		pPrj->dLatitude_Of_2nd_Point = prj->dLatitude_Of_2nd_Point;
		pPrj->dLatitudeOfCenter = prj->dLatitudeOfCenter;
		pPrj->dLatitudeOfOrigin = prj->dLatitudeOfOrigin;
		pPrj->dLinearUnit = prj->dLinearUnit;
		pPrj->dLongitude_Of_1st_Point = prj->dLongitude_Of_1st_Point;
		pPrj->dLongitude_Of_2nd_Point = prj->dLongitude_Of_2nd_Point;
		pPrj->dLongitudeOfCenter = prj->dLongitudeOfCenter;
		pPrj->dPrimeMeridian = prj->dPrimeMeridian;
		pPrj->dScaleFactor = prj->dScaleFactor;
		pPrj->dSemimajorAxis = prj->dSemimajorAxis;
		pPrj->dSemiminorAxis = prj->dSemiminorAxis;
		pPrj->dStandardParallel_1 = prj->dStandardParallel_1;
		pPrj->dStandardParallel_2 = prj->dStandardParallel_2;
		pPrj->iCoordType = prj->iCoordType;
		pPrj->iPrjType = prj->iPrjType;
		pPrj->iVersion = prj->iVersion;

		string strAngularUnit = cast_to_string(prj->strAngularUnit, sizeof(pPrj->strAngularUnit));
		strcpy_s(pPrj->strAngularUnit, strAngularUnit.c_str());
		string strDatum = cast_to_string(prj->strDatum, sizeof(pPrj->strDatum));
		strcpy_s(pPrj->strDatum, strDatum.c_str());
		string strGeogcs = cast_to_string(prj->strGeogcs, sizeof(pPrj->strGeogcs));
		strcpy_s(pPrj->strGeogcs, strGeogcs.c_str());
		string strLinearUnit = cast_to_string(prj->strLinearUnit, sizeof(pPrj->strLinearUnit));
		strcpy_s(pPrj->strLinearUnit, strLinearUnit.c_str());
		string strPrjName = cast_to_string(prj->strPrjName, sizeof(pPrj->strPrjName));
		strcpy_s(pPrj->strPrjName, strPrjName.c_str());
		string strPrjType = cast_to_string(prj->strPrjType, sizeof(pPrj->strPrjType));
		strcpy_s(pPrj->strPrjType, strPrjType.c_str());
		string strProjection = cast_to_string(prj->strProjection, sizeof(pPrj->strProjection));
		strcpy_s(pPrj->strProjection, strProjection.c_str());
		string strSpheroid = cast_to_string(prj->strSpheroid, sizeof(pPrj->strSpheroid));
		strcpy_s(pPrj->strSpheroid, strSpheroid.c_str());
		return pPrj;
	}

	tagOApiCusShowWnd* COmapApiCLI::CLI2Dll(tagCusShowWnd^ CusShowWnd)
	{
		if (CusShowWnd == nullptr)
		{
			return nullptr;
		}
		int nlen = CusShowWnd->pHtml->Length;

		tagOApiCusShowWnd *pCusShowWnd = (tagOApiCusShowWnd *)OApiZeroMalloc(sizeof(tagOApiCusShowWnd) + nlen + 16);
		pCusShowWnd->pHtml = (char *)(pCusShowWnd + 1);
		pCusShowWnd->idWnd = CusShowWnd->idWnd;
		pCusShowWnd->rectWnd.left = CusShowWnd->rectWnd->left;
		pCusShowWnd->rectWnd.right = CusShowWnd->rectWnd->right;
		pCusShowWnd->rectWnd.top = CusShowWnd->rectWnd->top;
		pCusShowWnd->rectWnd.bottom = CusShowWnd->rectWnd->bottom;

		pCusShowWnd->bCloseEvent = CusShowWnd->bCloseEvent;

		string strDlgTitle = cast_to_string(CusShowWnd->strDlgTitle);
		strcpy(pCusShowWnd->strDlgTitle, strDlgTitle.c_str());


		string strHtml = cast_to_string(CusShowWnd->pHtml);
		strcpy(pCusShowWnd->pHtml, strHtml.c_str());

		pCusShowWnd->nHtml = nlen;

		return pCusShowWnd;
	}

	tagOApiMapObjShowWnd* COmapApiCLI::CLI2Dll(tagMapObjShowWnd^ MapObjShowWnd)
	{
		if (MapObjShowWnd == nullptr)
		{
			return nullptr;
		}

		tagOApiMapObjShowWnd *pObjShowWnd = (tagOApiMapObjShowWnd *)OApiZeroMalloc(sizeof(tagOApiMapObjShowWnd) + MapObjShowWnd->nHtml + 16);
		pObjShowWnd->ptMapWnd.x = MapObjShowWnd->ptMapWnd->x;
		pObjShowWnd->ptMapWnd.y = MapObjShowWnd->ptMapWnd->y;

		pObjShowWnd->sizeObjWnd.cx = MapObjShowWnd->sizeObjWnd->cx;
		pObjShowWnd->sizeObjWnd.cy = MapObjShowWnd->sizeObjWnd->cy;

		pObjShowWnd->idObj = MapObjShowWnd->idObj;
		pObjShowWnd->bCloseType = MapObjShowWnd->bCloseType;
		pObjShowWnd->bCloseEvent = MapObjShowWnd->bCloseEvent;

		

		pObjShowWnd->pHtml = (char *)(pObjShowWnd + 1);
		string strHtml = cast_to_string(MapObjShowWnd->pHtml);
		strcpy(pObjShowWnd->pHtml, strHtml.c_str());

		pObjShowWnd->nHtml = MapObjShowWnd->nHtml;

		return pObjShowWnd;
		
	}

	tagOApiObjGroup^ COmapApiCLI::Dll2CLI(tagOApiObjGroupV2 *pGroupDll)
	{
		tagOApiObjGroup^ pGroup = gcnew tagOApiObjGroup();
		if (pGroupDll == nullptr || pGroup == nullptr)
		{
			return nullptr;
		}
		pGroup->bAutoLoad = pGroupDll->bAutoLoad;
		//pGroup->bCrypt = pGroupDll->bCrypt;
		pGroup->bGroup = pGroupDll->bGroup;
		pGroup->iShowLevel = pGroupDll->iShowLevel;
		pGroup->iShowLevelBak = pGroupDll->iShowLevelBak;
		pGroup->iShowLevel = pGroupDll->iShowLevel;
		pGroup->iShowLevel = pGroupDll->iShowLevel;
		pGroup->bShare = pGroupDll->bShare;
		pGroup->dwBind = pGroupDll->dwBind;
		pGroup->dwBindCheck = pGroupDll->dwBindCheck;
		pGroup->bLink = pGroupDll->bLink;
		pGroup->bLinkAutoCheck = pGroupDll->bLinkAutoCheck;
		pGroup->biChildiOverlay = pGroupDll->biChildiOverlay;
		//pGroup->bLoadOk = pGroupDll->bLoadOk;
		pGroup->bNotHotId = pGroupDll->bNotHotId;
		pGroup->bReadOnly = pGroupDll->bReadOnly;
		pGroup->bRelate = pGroupDll->bRelate;
		pGroup->bSaveMerge = pGroupDll->bSaveMerge;
		//pGroup->nAllChild = pGroupDll->nAllChild;
		pGroup->nChild = pGroupDll->nChild;
		pGroup->strName = cast_strUtf8_to_String(pGroupDll->strName);
		pGroup->strLink = cast_strUtf8_to_String(pGroupDll->strLink);
		return pGroup;
	}
	tagOApiMapSign^ COmapApiCLI::Dll2CLI(tagOApiMapSignV2 *pSignDll)
	{
		tagOApiMapSign^ pSign = gcnew tagOApiMapSign();
		if (pSignDll == nullptr || pSign == nullptr)
		{
			return nullptr;
		}


		pSign->iTime = pSignDll->iTime;
		pSign->lat = pSignDll->lat;
		pSign->lng = pSignDll->lng;
		pSign->iAltitude = pSignDll->iAltitude;
		pSign->strName = cast_strUtf8_to_String(pSignDll->strName);
		if (pSignDll->pstrComment)
		{
			pSign->pstrComment = cast_strUtf8_to_String(pSignDll->pstrComment);
		}
		pSign->bEditMode = pSignDll->bEditMode;
		pSign->iOverlayIdx = pSignDll->iOverlayIdx;
		pSign->bRealLl = pSignDll->bRealLl;
		pSign->iTxtShowSta = pSignDll->iTxtShowSta;
		pSign->iTxtShowStaSet = pSignDll->iTxtShowStaSet;

		pSign->pic->iSignAlignFlag = pSignDll->pic.iSignAlignFlag;
		pSign->pic->iSignPicNum = pSignDll->pic.iSignPicNum;
		pSign->pic->iPicScale = pSignDll->pic.iPicScale;
		pSign->pic->iSignPic = pSignDll->pic.iSignPic;
		pSign->pic->dwSignClr = pSignDll->pic.dwSignClr;
		pSign->pic->iSignPicNumOffx = pSignDll->pic.iSignPicNumOffx;
		pSign->pic->iSignPicNumOffy = pSignDll->pic.iSignPicNumOffy;
		pSign->pic->iSignPicNumClr = pSignDll->pic.iSignPicNumClr;
		pSign->pic->iSignPicNumSize = pSignDll->pic.iSignPicNumSize;
		pSign->iTxtType = pSignDll->iTxtType;
		pSign->iShowLevel = pSignDll->iShowLevel;
		pSign->iShowLevelBak = pSignDll->iShowLevelBak;
		pSign->iShowLevelMax = pSignDll->iShowLevelMax;
		pSign->bTimeUncertain = pSignDll->bTimeUncertain;

		pSign->ei->strFontName = cast_strUtf8_to_String(pSignDll->ei.strFontName);
		pSign->ei->bShowComment = pSignDll->ei.bShowComment;
		pSign->ei->bCommentAlign = pSignDll->ei.bCommentAlign;
		pSign->ei->bFontZoomWithMap = pSignDll->ei.bFontZoomWithMap;
		pSign->ei->bFontWithBox = pSignDll->ei.bFontWithBox;
		pSign->ei->iFontAlpha = pSignDll->ei.iFontAlpha;
		pSign->ei->bFontEffect = pSignDll->ei.bFontEffect;
		pSign->ei->bFontBkStyle = pSignDll->ei.bFontBkStyle;
		pSign->ei->nFontBindLevel = pSignDll->ei.nFontBindLevel;
		pSign->ei->nFontMaxLevel = pSignDll->ei.nFontMaxLevel;
		pSign->ei->nFontMinLevel = pSignDll->ei.nFontMinLevel;
		pSign->ei->iFontSize = pSignDll->ei.iFontSize;
		pSign->ei->dwFontClr = pSignDll->ei.dwFontClr;
		pSign->ei->dwFontBkClr = pSignDll->ei.dwFontBkClr;
		pSign->ei->fFontRotateAngle = pSignDll->ei.fFontRotateAngle;
		pSign->ei->bNoHotFontEvent = pSignDll->ei.bNoHotFontEvent;

		pSign->ei->idExt = pSignDll->ei.idExt;
		for (int i = 0; i < MAX_API_ID_BAK_CNT; i++)
		{
			//pSign->ei->idExtBak[i] = gcnew INT64;
			pSign->ei->idExtBak[i] = pSignDll->ei.idExtBak[i];
		}
		pSign->ei->bExtEditable = pSignDll->ei.bExtEditable;
		pSign->ei->nExtDataLen = pSignDll->ei.nExtDataLen;
		pSign->ei->strExtTypeName = cast_strUtf8_to_String(pSignDll->ei.strExtTypeName);
		pSign->ei->bExtMapShow = pSignDll->ei.bExtMapShow;
		pSign->ei->bExtMapThumb = pSignDll->ei.bExtMapThumb;
		pSign->ei->bExtMapZoom = pSignDll->ei.bExtMapZoom;
		pSign->ei->nExtMapBindLevel = pSignDll->ei.nExtMapBindLevel;
		pSign->ei->nExtMapMaxLevel = pSignDll->ei.nExtMapMaxLevel;
		pSign->ei->nExtMapMinLevel = pSignDll->ei.nExtMapMinLevel;
		pSign->ei->nExtMapAlpha = pSignDll->ei.nExtMapAlpha;
		pSign->ei->fMapRotateAngle = pSignDll->ei.fMapRotateAngle;
		pSign->ei->bNoHotMapEvent = pSignDll->ei.bNoHotMapEvent;
		pSign->ei->nExtMapWidth = pSignDll->ei.nExtMapWidth;
		pSign->ei->nExtMapHeight = pSignDll->ei.nExtMapHeight;
		pSign->ei->fXScale = pSignDll->ei.fXScale;
		pSign->ei->fYScale = pSignDll->ei.fYScale;
		pSign->mse->nRadius = pSignDll->mse.nRadius;
		pSign->mse->dwShowClr = pSignDll->mse.dwShowClr;


		return pSign;
	}
	tagOApiMapTrack^ COmapApiCLI::Dll2CLI(tagOApiMapTrackV2 *pTrackDll)
	{
		tagOApiMapTrack^ pTrack = gcnew tagOApiMapTrack();
		if (pTrackDll == nullptr || pTrack == nullptr)
		{
			return nullptr;
		}
		pTrack->strName = cast_strUtf8_to_String(pTrackDll->strName);
		pTrack->pstrComment = cast_strUtf8_to_String(pTrackDll->pstrComment);
		pTrack->iTrackType = pTrackDll->iTrackType;
		pTrack->iOverlayIdx = pTrackDll->iOverlayIdx;
		pTrack->bRealLl = pTrackDll->bRealLl;
		pTrack->iShowLevel = pTrackDll->iShowLevel;
		pTrack->iShowLevelBak = pTrackDll->iShowLevelBak;
		pTrack->iShowLevelMax = pTrackDll->iShowLevelMax;
		pTrack->bShowName = pTrackDll->bShowName;
		pTrack->bEdit = pTrackDll->bEdit;
		pTrack->dwAltitudeColor = pTrackDll->dwAltitudeColor;
		pTrack->dwCustom1 = pTrackDll->dwCustom1;
		pTrack->dwCustom2 = pTrackDll->dwCustom2;
		pTrack->iCustomType1 = pTrackDll->iCustomType1;
		pTrack->iCustomType2 = pTrackDll->iCustomType2;
		pTrack->iCustomType3 = pTrackDll->iCustomType3;
		pTrack->iCustomType4 = pTrackDll->iCustomType4;


		int iSize = pTrackDll->nMtp;
		pTrack->nMtp = iSize;
		pTrack->pMtp = gcnew cli::array<tagOApiMapTrackPoint ^>(iSize);
		for (int i = 0; i < iSize; i++)
		{
			pTrack->pMtp[i] = gcnew tagOApiMapTrackPoint();
			pTrack->pMtp[i]->dCadBulge = pTrackDll->pMtp[i].dCadBulge;
			pTrack->pMtp[i]->iAltitude = pTrackDll->pMtp[i].iAltitude;
			pTrack->pMtp[i]->iCadRet = pTrackDll->pMtp[i].iCadRet;
			pTrack->pMtp[i]->lat = pTrackDll->pMtp[i].lat;
			pTrack->pMtp[i]->lng = pTrackDll->pMtp[i].lng;
			pTrack->pMtp[i]->time = pTrackDll->pMtp[i].time;
		}

		pTrack->mtd->dwLineClr = pTrackDll->mtd.dwLineClr;
		pTrack->mtd->dwCircleClr = pTrackDll->mtd.dwCircleClr;
		pTrack->mtd->iLineWidth = pTrackDll->mtd.iLineWidth;
		pTrack->mtd->iCircleWidth = pTrackDll->mtd.iCircleWidth;
		pTrack->mtd->iLineAlpha = pTrackDll->mtd.iLineAlpha;
		pTrack->mtd->iShowType = pTrackDll->mtd.iShowType;
		pTrack->mtd->iLineType = pTrackDll->mtd.iLineType;
		pTrack->mtd->bClose = pTrackDll->mtd.bClose;
		return pTrack;
	}
	tagOApiMapShape^ COmapApiCLI::Dll2CLI(tagOApiMapShapeV2 *pShapeDll)
	{
		tagOApiMapShape^ pShape = gcnew tagOApiMapShape();
		if (pShapeDll == nullptr || pShape == nullptr)
		{
			return nullptr;
		}

		int iSize = pShapeDll->nMtp;
		pShape->nMtp = iSize;
		pShape->pMtp = gcnew cli::array<tagOApiMapTrackPoint ^>(iSize);
		for (int i = 0; i < iSize; i++)
		{
			pShape->pMtp[i] = gcnew tagOApiMapTrackPoint();
			pShape->pMtp[i]->dCadBulge = pShapeDll->pMtp[i].dCadBulge;
			pShape->pMtp[i]->iAltitude = pShapeDll->pMtp[i].iAltitude;
			pShape->pMtp[i]->iCadRet = pShapeDll->pMtp[i].iCadRet;
			pShape->pMtp[i]->lat = pShapeDll->pMtp[i].lat;
			pShape->pMtp[i]->lng = pShapeDll->pMtp[i].lng;
			pShape->pMtp[i]->time = pShapeDll->pMtp[i].time;
		}
		pShape->strName = cast_strUtf8_to_String(pShapeDll->strName);
		if (pShapeDll->pstrComment)
		{
			pShape->pstrComment = cast_strUtf8_to_String(pShapeDll->pstrComment);
		}
		pShape->iShowFlag = pShapeDll->iShowFlag;
		pShape->iOverlayIdx = pShapeDll->iOverlayIdx;
		pShape->bRealLl = pShapeDll->bRealLl;
		pShape->dStartAngle = pShapeDll->dStartAngle;
		pShape->dEndAngle = pShapeDll->dEndAngle;
		pShape->iLineWidth = pShapeDll->iLineWidth;
		pShape->iLineAlpha = pShapeDll->iLineAlpha;
		pShape->iLineType = pShapeDll->iLineType;
		pShape->iAreaAlpha = pShapeDll->iAreaAlpha;
		pShape->bEditMode = pShapeDll->bEditMode;
		pShape->iShowLevel = pShapeDll->iShowLevel;
		pShape->iShowLevelBak = pShapeDll->iShowLevelBak;
		pShape->iShowLevelMax = pShapeDll->iShowLevelMax;
		pShape->iFillType = pShapeDll->iFillType;
		pShape->iFillSubType = pShapeDll->iFillSubType;
		pShape->iOuterRgnIdx = pShapeDll->iOuterRgnIdx;
		pShape->dwLineClr = pShapeDll->dwLineClr;
		pShape->dwAreaClr = pShapeDll->dwAreaClr;

		pShape->dwFillPattern = pShapeDll->dwFillPattern;
		pShape->dwFillChgClr = pShapeDll->dwFillChgClr;
		pShape->fFillRotate = pShapeDll->fFillRotate;
		pShape->fFillScale = pShapeDll->fFillScale;
		pShape->fFillOffsetX = pShapeDll->fFillOffsetX;
		pShape->fFillOffsetY = pShapeDll->fFillOffsetY;



		return pShape;
	}
	tagOApiMapDirections^ COmapApiCLI::Dll2CLI(tagOApiMapDirectionsV2 *pDirDll)
	{
		tagOApiMapDirections^ pDir = gcnew tagOApiMapDirections();
		if (pDirDll == nullptr || pDir == nullptr)
		{
			return nullptr;
		}
		pDir->nUnit = pDirDll->nUnit;
		pDir->bEdit = pDirDll->bEdit;
		pDir->bRealLl = pDirDll->bRealLl;
		pDir->iLineWidth = pDirDll->iLineWidth;
		pDir->dwLineClr = pDirDll->dwLineClr;
		pDir->iLineAlpha = pDirDll->iLineAlpha;
		pDir->iOverlayIdx = pDirDll->iOverlayIdx;
		pDir->iShowLevel = pDirDll->iShowLevel;
		pDir->iShowLevelBak = pDirDll->iShowLevelBak;
		pDir->iShowLevelMax = pDirDll->iShowLevelMax;
		pDir->dirSrh->iDirMode = pDirDll->dirSrh.iDirMode;
		pDir->dirSrh->mpEnd->lat = pDirDll->dirSrh.mpEnd.lat;
		pDir->dirSrh->mpEnd->lng = pDirDll->dirSrh.mpEnd.lng;
		pDir->dirSrh->mpStart->lat = pDirDll->dirSrh.mpStart.lat;
		pDir->dirSrh->mpStart->lng = pDirDll->dirSrh.mpStart.lng;
		for (int i = 0; i < MAX_API_DIR_WAYPOINTS; i++)
		{
			pDir->dirSrh->mpVia[i] = gcnew tagOApiLatLng();
			pDir->dirSrh->mpVia[i]->lat = pDirDll->dirSrh.mpVia[i].lat;
			pDir->dirSrh->mpVia[i]->lng = pDirDll->dirSrh.mpVia[i].lng;
		}
		if (pDir->nUnit>0)
		{
			pDir->punit = gcnew cli::array<tagOApiMapDirectionsUnit ^>(pDir->nUnit);
			for (int i = 0; i < pDir->nUnit; i++)
			{
				pDir->punit[i] = gcnew tagOApiMapDirectionsUnit();
				pDir->punit[i]->iType = pDirDll->punit[i].iType;
				pDir->punit[i]->strTitle = cast_strUtf8_to_String(pDirDll->punit[i].strTitle);
				pDir->punit[i]->nSubCount = pDirDll->punit[i].nSubCount;
				if (pDir->punit[i]->nSubCount>0)
				{
					pDir->punit[i]->strSubTitle = gcnew cli::array<String ^>(ARRAY_NUM);
					for (int j = 0; j < pDir->punit[i]->nSubCount; j++)
					{

						pDir->punit[i]->strSubTitle[j] = cast_strUtf8_to_String(pDirDll->punit[i].strSubTitle[j]);
					}
				}
				pDir->punit[i]->nLl = pDirDll->punit[i].nLl;
				if (pDir->punit[i]->nLl>0)
				{
					
					pDir->punit[i]->llList = gcnew cli::array<tagOApiLatLng ^>(pDirDll->punit[i].nLl);
					for (int j = 0; j < pDir->punit[i]->nLl; j++)
					{
						pDir->punit[i]->llList[j] = gcnew tagOApiLatLng();
						pDir->punit[i]->llList[j]->lat = pDirDll->punit[i].llList[j].lat;
						pDir->punit[i]->llList[j]->lng = pDirDll->punit[i].llList[j].lng;
					}
				}
			}
		}
		pDir->strName = cast_strUtf8_to_String(pDirDll->strName);
		pDir->strTitle = cast_strUtf8_to_String(pDirDll->strTitle);
		pDir->strGroup = cast_strUtf8_to_String(pDirDll->strGroup);
		pDir->strDirStart = cast_strUtf8_to_String(pDirDll->strDirStart);
		pDir->strDirEnd = cast_strUtf8_to_String(pDirDll->strDirEnd);

		if (pDirDll->pstrComment)
		{
			pDir->pstrComment = cast_strUtf8_to_String(pDirDll->pstrComment);
		}
		return pDir;
	}
	tagOApiObjectSrhReqCli^ COmapApiCLI::Dll2CLI(tagOApiObjectSrhReq *pSrhDll)
	{
		tagOApiObjectSrhReqCli^ pSrh = gcnew tagOApiObjectSrhReqCli();
		if (pSrhDll == nullptr || pSrh == nullptr)
		{
			return nullptr;
		}
		pSrh->bNoCase = pSrhDll->bNoCase;
		pSrh->bNoChild = pSrhDll->bNoChild;
		pSrh->idParent = pSrhDll->idParent;
		pSrh->idShapeSelect = pSrhDll->idShapeSelect;
		pSrh->iMaxCnt = pSrhDll->iMaxCnt;
		pSrh->iObjType = pSrhDll->iObjType;
		pSrh->iReqVer = pSrhDll->iReqVer;
		pSrh->iSrhOpt = pSrhDll->iSrhOpt;
		pSrh->iSrhValue = pSrhDll->iSrhValue;
		pSrh->strSrhTxt = cast_strUtf8_to_String(pSrhDll->strSrhTxt);
		return pSrh;
	}
	tagOApiRelatePoint^ COmapApiCLI::Dll2CLI(tagOApiRelatePointV1* pOrp)
	{
		tagOApiRelatePoint^ pOrpCli = gcnew tagOApiRelatePoint();
		if (pOrpCli == nullptr || pOrp == nullptr)
		{
			return nullptr;
		}
		pOrpCli->bReal = pOrp->bReal;
		pOrpCli->x = pOrp->x;
		pOrpCli->y = pOrp->y;
		pOrpCli->lat = pOrp->lat;
		pOrpCli->lng = pOrp->lng;
		return pOrpCli;
	}
	tagOmapLatlngCli^ COmapApiCLI::Dll2CLI(tagOmapLatlng* poll)
	{
		tagOmapLatlngCli^ platlng = gcnew tagOmapLatlngCli();
		if (poll == nullptr || platlng == nullptr)
		{
			return nullptr;
		}
		platlng->bReal = poll->bReal;
		platlng->lat = poll->lat;
		platlng->lng = poll->lng;
		return platlng;
	}
	cli::array<tagOphotoMapPicCli^>^ COmapApiCLI::Dll2CLI(tagOPhotoMapPic* pOmp, int nOmp)
	{
		cli::array<tagOphotoMapPicCli^>^ pOmpCli = gcnew cli::array<tagOphotoMapPicCli ^>(nOmp);
		if (pOmpCli == nullptr || pOmp == nullptr)
		{
			return nullptr;
		}
		for (int i = 0; i < nOmp;i++)
		{
			pOmpCli[i] = gcnew tagOphotoMapPicCli();
			pOmpCli[i]->iAction = pOmp[i].iAction;
			pOmpCli[i]->idPic = pOmp[i].idPic;
			pOmpCli[i]->iTmp = pOmp[i].iTmp;
			pOmpCli[i]->lat = pOmp[i].lat;
			pOmpCli[i]->lng = pOmp[i].lng;
			pOmpCli[i]->tmPhoto = pOmp[i].tmPhoto;
		}
		return pOmpCli;
	}
	cli::array<tagOApiItemList^>^ COmapApiCLI::Dll2CLI(tagOApiItemListV1* pOlvs, int nOlv)
	{
		cli::array<tagOApiItemList^>^ pOlvsCli = gcnew cli::array<tagOApiItemList ^>(nOlv);
		if (pOlvsCli == nullptr||pOlvs == nullptr)
		{
			return nullptr;
		}
		for (int i = 0; i < nOlv;i++)
		{
			pOlvsCli[i] = gcnew tagOApiItemList();
			pOlvsCli[i]->idObj = pOlvs[i].idObj;
			pOlvsCli[i]->iType = pOlvs[i].iType;
			pOlvsCli[i]->strName = cast_strUtf8_to_String(pOlvs[i].strName);
		}
		return pOlvsCli;
	}
	cli::array<tagCustomMap^>^ COmapApiCLI::Dll2CLI(tagOApiCustomMap* pCms, int nCm)
	{
		cli::array<tagCustomMap^>^ pCmsCli = gcnew cli::array<tagCustomMap ^>(nCm);
		if (pCmsCli == nullptr||pCms == nullptr)
		{
			return nullptr;
		}
		for (int i = 0;i<nCm;i++)
		{
			pCmsCli[i] = gcnew tagCustomMap();
			pCmsCli[i]->bIsSatellite = pCms[i].bIsSatellite;
			pCmsCli[i]->bUseLayer = pCms[i].bUseLayer;
			pCmsCli[i]->iCoordType = pCms[i].iCoordType;
			pCmsCli[i]->idLayerBig = pCms[i].idLayerBig;
			pCmsCli[i]->idLayerSmall = pCms[i].idLayerSmall;
			pCmsCli[i]->idMap = pCms[i].idMap;
			pCmsCli[i]->iHostEnd = pCms[i].iHostEnd;
			pCmsCli[i]->iHostStart = pCms[i].iHostStart;
			pCmsCli[i]->iLayerBigFlag = pCms[i].iLayerBigFlag;
			pCmsCli[i]->iLayerSmallFlag = pCms[i].iLayerSmallFlag;
			pCmsCli[i]->iMaxLevel = pCms[i].iMaxLevel;
			pCmsCli[i]->iMinLevel = pCms[i].iMinLevel;
			pCmsCli[i]->iTileFormat = pCms[i].iTileFormat;
			pCmsCli[i]->iTileSize = pCms[i].iTileSize;
			pCmsCli[i]->iVersion = pCms[i].iVersion;
			pCmsCli[i]->wPort = pCms[i].wPort;
			pCmsCli[i]->strName = cast_strUtf8_to_String(pCms[i].strName);
			pCmsCli[i]->strHost = cast_strUtf8_to_String(pCms[i].strHost);
			pCmsCli[i]->strUrl = cast_strUtf8_to_String(pCms[i].strUrl);
		}
		return pCmsCli;
	}
	tagOApiObjChageHdrCli^ COmapApiCLI::Dll2CLI(tagOApiObjChageHdr* pOch)
	{
		if (pOch == nullptr)
		{
			return nullptr;
		}
		tagOApiObjChageHdrCli^ pOchCli= gcnew tagOApiObjChageHdrCli();
		pOchCli->iFlag = pOch->iFlag;
		pOchCli->iVer = pOch->iVer;
		pOchCli->nList = pOch->nList;
		pOchCli->pdwList = gcnew cli::array<DWORD>(pOchCli->nList);
		for (int i = 0; i < pOch->nList;i++)
		{
			pOchCli->pdwList[i] = pOch->pdwList[i];
		}
		return pOchCli;
	}
	tagWinMapInfoCli^ COmapApiCLI::Dll2CLI(tagWinMapInfo* pWmi)
	{
		if (pWmi == nullptr)
		{
			return nullptr;
		}
		tagWinMapInfoCli^ pWmiCli = gcnew tagWinMapInfoCli();
		pWmiCli->lng = pWmi->lng;
		pWmiCli->lat = pWmi->lat;
		pWmiCli->bReal = pWmi->bReal;
		pWmiCli->x_lng = pWmi->x_lng;
		pWmiCli->y_lat = pWmi->y_lat;
		pWmiCli->bReal2 = pWmi->bReal;
		pWmiCli->iMapLevel = pWmi->iMapLevel;
		pWmiCli->iMapType = pWmi->iMapType;
		return pWmiCli;
	}
	tagPluginVer^ COmapApiCLI::Dll2CLI(tagOApiPluginVer *pPluginVer)
	{
		if (pPluginVer == nullptr)
		{
			return nullptr;
		}
		tagPluginVer^ pVerCli = gcnew tagPluginVer();
		pVerCli->iOmapVer = pPluginVer->iOmapVer;
		pVerCli->iCadPluginVer = pPluginVer->iCadPluginVer;
		pVerCli->iGisPluginVer = pPluginVer->iGisPluginVer;
		return pVerCli;
	}
	tagOmapWndRect^ COmapApiCLI::Dll2CLI(tagOApiOmapWndRect *pOmapWndRect)
	{
		if (pOmapWndRect == nullptr) return nullptr;
		
		tagOmapWndRect^ pWndRectCli = gcnew tagOmapWndRect();
		pWndRectCli->rectMapOfWnd = gcnew tagRECTCli();
	
		pWndRectCli->rectMapOfWnd->left = pOmapWndRect->rectMapOfWnd.left;
		pWndRectCli->rectMapOfWnd->right = pOmapWndRect->rectMapOfWnd.right;
		pWndRectCli->rectMapOfWnd->top = pOmapWndRect->rectMapOfWnd.top;
		pWndRectCli->rectMapOfWnd->bottom = pOmapWndRect->rectMapOfWnd.bottom;
		return pWndRectCli;
	}

	tagMapShapeDetail^ COmapApiCLI::Dll2CLI(tagOApiMapShapeDetail *pMapShapeDetail)
	{
		if (pMapShapeDetail == nullptr) return nullptr;

		tagMapShapeDetail^ pMapShapeDetailCli = gcnew tagMapShapeDetail();
		pMapShapeDetailCli->idObj= pMapShapeDetail->idObj;
		pMapShapeDetailCli->iPointCnt = pMapShapeDetail->iPointCnt;
		pMapShapeDetailCli->iAreaCnt= pMapShapeDetail->iAreaCnt;
		pMapShapeDetailCli->dPerimeter = pMapShapeDetail->dPerimeter;
		pMapShapeDetailCli->dAreaSize = pMapShapeDetail->dAreaSize;
		return pMapShapeDetailCli;
	}
	tagMapTrackDetail^ COmapApiCLI::Dll2CLI(tagOApiMapTrackDetail *pMapTrackDetail)
	{
		if (pMapTrackDetail == nullptr) return nullptr;

		tagMapTrackDetail^ pMapTrackDetailCli = gcnew tagMapTrackDetail();
		pMapTrackDetailCli->idObj = pMapTrackDetail->idObj;
		pMapTrackDetailCli->tStart = pMapTrackDetail->tStart;
		pMapTrackDetailCli->tEnd = pMapTrackDetail->tEnd;
		pMapTrackDetailCli->iTotalPoint = pMapTrackDetail->iTotalPoint;
		pMapTrackDetailCli->iTotalDist = pMapTrackDetail->iTotalDist;
		pMapTrackDetailCli->iAgvSpeed = pMapTrackDetail->iAgvSpeed;
		pMapTrackDetailCli->tEnd = pMapTrackDetail->tEnd;
		pMapTrackDetailCli->iMaxSpeed = pMapTrackDetail->iMaxSpeed;
		pMapTrackDetailCli->iMinAltitude = pMapTrackDetail->iMinAltitude;
		pMapTrackDetailCli->iMaxAltitude = pMapTrackDetail->iMaxAltitude;
		return pMapTrackDetailCli;
	}

	cli::array<tagCusMainBtnCli^>^ COmapApiCLI::Dll2CLI(tagCusMainBtn* pCbs, int nCb)
	{
		cli::array<tagCusMainBtnCli^>^ pCbsCli = gcnew cli::array<tagCusMainBtnCli^>(nCb);
		if (pCbsCli == nullptr || pCbs == nullptr)
		{
			return nullptr;
		}
		for (int i = 0; i < nCb; i++)
		{
			pCbsCli[i] = gcnew tagCusMainBtnCli();
			pCbsCli[i]->nId = pCbs[i].nId;
			pCbsCli[i]->iResult = pCbs[i].iResult;
		}
		return pCbsCli;
	}
	cli::array<tagCusFavMenuCli^>^ COmapApiCLI::Dll2CLI(tagCusFavMenu* pCfs, int nData)
	{
		if (pCfs == nullptr)
		{
			return nullptr;
		}

		int nCb = 0;
		_tagCusFavMenu *p = pCfs;
		for (int i = 0; i < nData;)
		{
			int iUnit = sizeof(tagCusFavMenu) + pCfs->nList * sizeof(DWORD);
			pCfs = (tagCusFavMenu *)((char*)pCfs + iUnit);
			i += iUnit;
			nCb++;
		}
		cli::array<tagCusFavMenuCli^>^ pCfsCli = gcnew cli::array<tagCusFavMenuCli^>(nCb);
		if (pCfsCli == nullptr)
		{
			return nullptr;
		}
		int n = 0;
		for (int i = 0; i < nData;)
		{
			pCfsCli[n] = gcnew tagCusFavMenuCli();
			pCfsCli[n]->nId = p->nId;
			if (p->nList > 0)
			{
				int *pIds = (int*)(p + 1);
				pCfsCli[n]->pIdList = gcnew cli::array<int^>(p->nList);
				for (int j = 0; j < p->nList; j++)
				{
					pCfsCli[n]->pIdList[j] = pIds[j];
				}

			}
			int iUnit = sizeof(_tagCusFavMenu) + p->nList * sizeof(DWORD);
			p = (tagCusFavMenu *)((char*)p + iUnit);
			i += iUnit;
			n++;
		}
		return pCfsCli;
	}
	tagCusMainMenuCli^  COmapApiCLI::Dll2CLI(tagCusMainMenu *pCusMainMenu)
	{
		if (pCusMainMenu == nullptr)
		{
			return nullptr;
		}
		tagCusMainMenuCli^ cmm = gcnew tagCusMainMenuCli();
		cmm->nId = pCusMainMenu->nId;
		return cmm;
	}
	tagMapObjEvent^ COmapApiCLI::Dll2CLI(tagOApiMapObjEvent* pMapObjEvent)
	{
		if (pMapObjEvent == nullptr)
		{
			return nullptr;
		}
		tagMapObjEvent^ moe = gcnew tagMapObjEvent();
		moe->rectMapOfWnd = gcnew tagRECTCli();
		moe->ptClickOfMap = gcnew tagPOINTCli();

		moe->idObj = pMapObjEvent->idObj;

		moe->rectMapOfWnd->left = pMapObjEvent->rectMapOfWnd.left;
		moe->rectMapOfWnd->right = pMapObjEvent->rectMapOfWnd.right;
		moe->rectMapOfWnd->top = pMapObjEvent->rectMapOfWnd.top;
		moe->rectMapOfWnd->bottom = pMapObjEvent->rectMapOfWnd.bottom;

		moe->ptClickOfMap->x = pMapObjEvent->ptClickOfMap.x;
		moe->ptClickOfMap->y = pMapObjEvent->ptClickOfMap.y;


		return moe;
	}
	tagWebSocketConf^ COmapApiCLI::Dll2CLI(tagOApiWebSocketConf* pWsc)
	{
		if (pWsc == nullptr)
		{
			return nullptr;
		}
		tagWebSocketConf^ wsc = gcnew tagWebSocketConf(); 
		wsc->bHttpTileService = pWsc->bHttpTileService;
		wsc->dwWssUserLimitIP = pWsc->dwWssUserLimitIP;
		wsc->iWssFlag = pWsc->iWssFlag;
		wsc->wPort = pWsc->wPort;
		wsc->strPsk = cast_strUtf8_to_String(pWsc->strPsk);
		wsc->strSslCaFn = cast_strUtf8_to_String(pWsc->strSslCaFn);
		wsc->strSslCertFn = cast_strUtf8_to_String(pWsc->strSslCertFn);
		wsc->strSslKeyFn = cast_strUtf8_to_String(pWsc->strSslKeyFn);
		return wsc;
	}
	tagPrj^ COmapApiCLI::Dll2CLI(tagOApiPrj *pPrj)
	{
		if (pPrj==nullptr)
		{
			return nullptr;
		}
		tagPrj^ prj = gcnew tagPrj();
		prj->dAngularUnit = pPrj->dAngularUnit;
		prj->dAzimuth = pPrj->dAzimuth;
		prj->dCentralMeridian = pPrj->dCentralMeridian;
		prj->dFalseEasting = pPrj->dFalseEasting;
		prj->dFalseNorthing = pPrj->dFalseNorthing;
		prj->dInverseFlattening = pPrj->dInverseFlattening;
		prj->dLatitude_Of_1st_Point = pPrj->dLatitude_Of_1st_Point;
		prj->dLatitude_Of_2nd_Point = pPrj->dLatitude_Of_2nd_Point;
		prj->dLatitudeOfCenter = pPrj->dLatitudeOfCenter;
		prj->dLatitudeOfOrigin = pPrj->dLatitudeOfOrigin;
		prj->dLinearUnit = pPrj->dLinearUnit;
		prj->dLongitude_Of_1st_Point = pPrj->dLongitude_Of_1st_Point;
		prj->dLongitude_Of_2nd_Point = pPrj->dLongitude_Of_2nd_Point;
		prj->dLongitudeOfCenter = pPrj->dLongitudeOfCenter;
		prj->dPrimeMeridian = pPrj->dPrimeMeridian;
		prj->dScaleFactor = pPrj->dScaleFactor;
		prj->dSemimajorAxis = pPrj->dSemimajorAxis;
		prj->dSemiminorAxis = pPrj->dSemiminorAxis;
		prj->dStandardParallel_1 = pPrj->dStandardParallel_1;
		prj->dStandardParallel_2 = pPrj->dStandardParallel_2;
		prj->iCoordType = pPrj->iCoordType;
		prj->iPrjType = pPrj->iPrjType;
		prj->iVersion = pPrj->iVersion;
		prj->strAngularUnit = cast_strUtf8_to_String(pPrj->strAngularUnit);
		prj->strDatum = cast_strUtf8_to_String(pPrj->strDatum);
		prj->strGeogcs = cast_strUtf8_to_String(pPrj->strGeogcs);
		prj->strLinearUnit = cast_strUtf8_to_String(pPrj->strLinearUnit);
		prj->strPrjName = cast_strUtf8_to_String(pPrj->strPrjName);
		prj->strPrjType = cast_strUtf8_to_String(pPrj->strPrjType);
		prj->strProjection = cast_strUtf8_to_String(pPrj->strProjection);
		prj->strSpheroid = cast_strUtf8_to_String(pPrj->strSpheroid);
		return prj;
	}
	cli::array<tagOApiPixelInfoCli^>^ COmapApiCLI::Dll2CLI(tagOApiPixelInfo *pOpi, int nOpi)
	{
		if (nOpi<=0||pOpi == nullptr)
		{
			return nullptr;
		}
		cli::array<tagOApiPixelInfoCli^>^ pOpiCli = gcnew cli::array<tagOApiPixelInfoCli ^>(nOpi);
		for (int i = 0; i < nOpi;i++)
		{
			pOpiCli[i] = gcnew tagOApiPixelInfoCli();
			pOpiCli[i]->dMeterX = pOpi[i].dMeterX;
			pOpiCli[i]->dMeterY = pOpi[i].dMeterY;
			pOpiCli[i]->iLevel = pOpi[i].iLevel;
		}
		return pOpiCli;
	}
	tagOApiSysCoorInfoCli^ COmapApiCLI::Dll2CLI(tagOApiSysCoorInfo* pSci)
	{
		if (pSci==nullptr)
		{
			return nullptr;
		}
		tagOApiSysCoorInfoCli^ pSciCli= gcnew tagOApiSysCoorInfoCli();
		pSciCli->iCoorType = pSci->iCoorType;
		pSciCli->hash = gcnew cli::array<byte>(16);
		for (int i = 0; i < 16;i++)
		{
			pSciCli->hash[i] = pSci->hash[i];
		}
		pSciCli->strInfo = cast_strUtf8_to_String(pSci->strInfo);
		return pSciCli;
	}
	tagOApiShapeFillCadPatItemCli^ COmapApiCLI::Dll2CLI(tagOApiShapeFillCadPatItem* pPatItem)
	{
		tagOApiShapeFillCadPatItemCli^ pPatItemCli = gcnew tagOApiShapeFillCadPatItemCli();
		if (pPatItemCli==nullptr||pPatItem==nullptr)
		{
			return nullptr;
		}
		pPatItemCli->strName = cast_strUtf8_to_String(pPatItem->strName);
		pPatItemCli->strComment = cast_strUtf8_to_String(pPatItem->strComment);
		pPatItemCli->dDefaultScale = pPatItem->dDefaultScale;
		pPatItemCli->id = pPatItem->id;
		if (pPatItem->nSfcpu > 0)
		{
			pPatItemCli->pSfcpu = gcnew cli::array<tagOApiShapeFillCadPatUnitCli^>(pPatItem->nSfcpu);
			for (int i = 0; i < pPatItem->nSfcpu; i++)
			{
				pPatItemCli->pSfcpu[i] = gcnew tagOApiShapeFillCadPatUnitCli();
				pPatItemCli->pSfcpu[i]->dAngle = pPatItem->pSfcpu[i].dAngle;
				pPatItemCli->pSfcpu[i]->dxOrg = pPatItem->pSfcpu[i].dxOrg;
				pPatItemCli->pSfcpu[i]->dyOrg = pPatItem->pSfcpu[i].dyOrg;
				pPatItemCli->pSfcpu[i]->dxDelta = pPatItem->pSfcpu[i].dxDelta;
				pPatItemCli->pSfcpu[i]->dyDelta = pPatItem->pSfcpu[i].dyDelta;
				pPatItemCli->pSfcpu[i]->nDash = pPatItem->pSfcpu[i].nDash;
				if (pPatItemCli->pSfcpu[i]->nDash>0)
				{
					pPatItemCli->pSfcpu[i]->dDashList = gcnew cli::array<double>(pPatItemCli->pSfcpu[i]->nDash);
					for (int j = 0; j < pPatItemCli->pSfcpu[i]->nDash; j++)
					{
						pPatItemCli->pSfcpu[i]->dDashList[j] = pPatItem->pSfcpu[i].dDashList[j];
					}
				}
			}
		}
		return pPatItemCli;
	}
	tagOmapGetMapFileCli^ COmapApiCLI::Dll2CLI(tagOmapGetMapFile* pMapFile)
	{
		if (pMapFile==nullptr)
		{
			return nullptr;
		}
		tagOmapGetMapFileCli^ pMapFileCli = gcnew tagOmapGetMapFileCli();
		pMapFileCli->iRet = pMapFile->iRet;
		
		
		pMapFileCli->bRealLl = pMapFile->bRealLl;
		pMapFileCli->bImageType = pMapFile->bImageType;
		pMapFileCli->bFile = pMapFile->bFile;
		pMapFileCli->bSendReq = pMapFile->bSendReq;
		pMapFileCli->strFile = cast_strUtf8_to_String(pMapFile->strFile);
		pMapFileCli->idMap = pMapFile->idMap;
		pMapFileCli->iMapLevel = pMapFile->iMapLevel;
		pMapFileCli->iMapType = pMapFile->iMapType;
		pMapFileCli->height = pMapFile->height;
		pMapFileCli->width = pMapFile->width;
		pMapFileCli->iFlag = pMapFile->iFlag;
		pMapFileCli->iHasPic = pMapFile->iHasPic;
		pMapFileCli->iPostCnt = pMapFile->iPostCnt;
		pMapFileCli->iTotalPic = pMapFile->iTotalPic;
		pMapFileCli->iValue = pMapFile->iValue;
		pMapFileCli->x_lng1 = pMapFile->x_lng1;
		pMapFileCli->y_lat1 = pMapFile->y_lat1;
		pMapFileCli->x_lng2 = pMapFile->x_lng2;
		pMapFileCli->y_lat2 = pMapFile->y_lat2;
		if (pMapFile->nData>0&&pMapFile->pData!=nullptr)
		{
			pMapFileCli->pData = gcnew cli::array<byte>(pMapFile->nData);
			for (int i = 0; i < pMapFile->nData;i++)
			{
				pMapFileCli->pData[i] =((BYTE*)(pMapFile->pData))[i];
			}
		}
		return pMapFileCli;
	}
	tagOmapReqContourCli^ COmapApiCLI::Dll2CLI(tagOmapReqContour* pCon)
	{
		if (pCon==nullptr)
		{
			return nullptr;
		}
		tagOmapReqContourCli^ pConCli = gcnew tagOmapReqContourCli();
		pConCli->iRet = pCon->iRet;
		pConCli->bRealLl = pCon->bRealLl;
		pConCli->iCheckFlag = pCon->iCheckFlag;
		pConCli->idMap = pCon->idMap;
		pConCli->iElevValue = pCon->iElevValue;
		pConCli->iMapLevel = pCon->iMapLevel;
		pConCli->iPostCnt = pCon->iPostCnt;
		pConCli->iValue = pConCli->iValue;
		pConCli->x_lng1 = pCon->x_lng1;
		pConCli->y_lat1 = pCon->y_lat1;
		pConCli->x_lng2 = pCon->x_lng2;
		pConCli->y_lat2 = pCon->y_lat2;
		pConCli->iRet = pCon->iRet;
		pConCli->iCheckResult = pCon->iCheckResult;
		pConCli->iNeedVip = pCon->iNeedVip;
		pConCli->bPart = pConCli->bPart;
		return pConCli;
	}

	cli::array<int> ^Dll2CLI(DWORD* pidList, int nId)
	{
		if (pidList == nullptr || nId == 0)
		{
			return nullptr;
		}
		cli::array<int>^ idList = gcnew cli::array<int>(nId);
		for (int i = 0; i < nId; i++)
		{
			idList[i] = pidList[i];
		}
		return idList;
	}

	INT64  COmapApiCLI::SetOmapObject(DWORD idObj, tagOApiObjGroup^ pGroup, DWORD idParent , int iPosition)
	{
		tagOApiObjGroupV3 *pGroupDll = CLI2Dll(pGroup);
		if (pGroupDll == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		
		INT64 idRet = 0;
		int iRet = g_omapApi.SetOmapObjectV3(idObj, pGroupDll,&idRet, idParent, iPosition);
		g_omapApi.FreeOmapObjectV3(pGroupDll, OMAP_OBJ_TYPE_GROUP);
		if (iRet<0)
		{
			idRet = iRet;
		}
		return idRet;
	}
	INT64  COmapApiCLI::SetOmapObject(DWORD idObj, tagOApiMapSign^ pSign,DWORD idParent, int iPosition)
	{
		tagOApiMapSignV3 *pSignDll = CLI2Dll(pSign);
		if (pSignDll == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		INT64 idRet = 0;
		int iRet = g_omapApi.SetOmapObjectV3(idObj, pSignDll,&idRet, idParent, iPosition);
		g_omapApi.FreeOmapObjectV3(pSignDll, OMAP_OBJ_TYPE_SIGN);
		if (iRet<0)
		{
			idRet = iRet;
		}
		return idRet;
	}
	INT64  COmapApiCLI::SetOmapObject(DWORD idObj, tagOApiMapTrack^ pTrack, DWORD idParent, int iPosition)
	{
		tagOApiMapTrackV3 *pTrackDll = CLI2Dll(pTrack);
		if (pTrackDll == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		INT64 idRet = 0;
		int iRet = g_omapApi.SetOmapObjectV3(idObj, pTrackDll,&idRet, idParent, iPosition);
		g_omapApi.FreeOmapObjectV3(pTrackDll, OMAP_OBJ_TYPE_TRACK);
		if (iRet<0)
		{
			idRet = iRet;
		}
		return idRet;
	}
	INT64  COmapApiCLI::SetOmapObject(DWORD idObj, tagOApiMapShape^ pShape,DWORD idParent, int iPosition)
	{
		tagOApiMapShapeV3 *pShapeDll = CLI2Dll(pShape);
		if (pShapeDll == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		INT64 idRet = 0;
		int iRet = g_omapApi.SetOmapObjectV3(idObj, pShapeDll, &idRet,idParent, iPosition);
		g_omapApi.FreeOmapObjectV3(pShapeDll, OMAP_OBJ_TYPE_SHAPE);
		if (iRet<0)
		{
			idRet = iRet;
		}
		return idRet;
	}
	INT64  COmapApiCLI::SetOmapObject(DWORD idObj, tagOApiMapDirections^ pDir,DWORD idParent, int iPosition)
	{
		tagOApiMapDirectionsV3 *pDirDll = CLI2Dll(pDir);
		if (pDirDll == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		INT64 idRet = 0;
		int iRet = g_omapApi.SetOmapObjectV3(idObj, pDirDll,&idRet, idParent, iPosition);
		g_omapApi.FreeOmapObjectV3(pDirDll, OMAP_OBJ_TYPE_DIR);
		if (iRet<0)
		{
			idRet = iRet;
		}
		return idRet;
	}
	int COmapApiCLI::SendMessageToOmap(int iCmdId, void *pData, int nData, INT64 *plResult)
	{
		return g_omapApi.SendMessageToOmap(iCmdId, pData, nData, plResult);
	}
	void COmapApiCLI::SetOmapTmpSign(double lat, double lng, bool bGcj02)
	{
		g_omapApi.SetOmapTmpSign(lat, lng, bGcj02);
	}
	void COmapApiCLI::GeoDecodeLatlng(double lat, double lng, bool bGcj02)
	{
		g_omapApi.GeoDecodeLatlng(lat, lng, bGcj02);
	}
	int COmapApiCLI::SetOmapLevelAndLocationExt(int iMapID, int iMapLevel, double x_lng, double y_lat, BYTE bActive, BYTE bReal, int iTimeoutMs)
	{
		return g_omapApi.SetOmapLevelAndLocationExt(iMapID, iMapLevel, x_lng, y_lat, bActive, bReal, iTimeoutMs);
	}
	void COmapApiCLI::CleanOmapTmpObject()
	{
		g_omapApi.CleanOmapTmpObject();
	}
	int COmapApiCLI::GetOmapSelObjectTree(BYTE bLlType, BYTE bBatchGetObjTree)
	{
		m_bBatchGetObjTree = bBatchGetObjTree;
		return g_omapApi.GetOmapSelObjectTree(bLlType);
	}
	void COmapApiCLI::SetObjTree(tagOApiObjDataItem *pData,int nItem)
	{
		cli::array<tagOApiObjIdItem^>^ pIds =nullptr;
		if (nItem==0||pData == NULL)
		{
			WndCmd(pIds);
		}
		pIds = gcnew cli::array<tagOApiObjIdItem ^>(nItem);
		for (int i = 0;i<nItem;i++)
		{
			pIds[i] = gcnew tagOApiObjIdItem();
			pIds[i]->idObj = pData[i].idObj;
			pIds[i]->idParent = pData[i].idParent;
			pIds[i]->iDataLen = pData[i].iDataLen;
			pIds[i]->iObjType = pData[i].iObjType;
			pIds[i]->idLayer = pData[i].iCustomData>>32;
			pIds[i]->idGis = pData[i].iCustomData&0xffffffff;
		}
		WndCmd(pIds);
	}
	int COmapApiCLI::SetOmapSelObjectTree(int iCmd, tagOApiMemBuf tag, bool bFreeBuf)
	{
		
		return g_omapApi.SetOmapSelObjectTree(iCmd, tag, bFreeBuf);
	}
	void COmapApiCLI::PrePareSetObjTree(DWORD idParent)
	{
		if (m_ptagBuf)
		{
			if (m_ptagBuf->pBuf)
			{
				free(m_ptagBuf->pBuf);
			}
			free(m_ptagBuf);
		}
		m_idParent = idParent;
		m_ptagBuf = (tagOApiMemBuf*)zMalloc(sizeof(tagOApiMemBuf));
		m_ptagBuf->nMem = 1000;
		m_ptagBuf->pBuf = (char *)malloc(m_ptagBuf->nMem);
		memset(m_ptagBuf->pBuf, 0, m_ptagBuf->nMem);
		tagOApiObjectOptHdr* pOoh = OApiNewOptHdr(0);
		pOoh->idParent = idParent;
		bool br = AppendMemBuf(m_ptagBuf, (char*)pOoh, sizeof(tagOApiObjectOptHdr));
		free(pOoh);
		m_ptagBuf->nBuf += sizeof(tagOApiObjDataItem);
	}
	bool COmapApiCLI::AddObjTree(tagOApiObjTree^ pObjTree, DWORD idParent)
	{
		if (m_ptagBuf==nullptr)
		{
			PrePareSetObjTree(idParent);
		}
		bool br = AddObjTreeToBuf(m_ptagBuf, pObjTree, idParent);
		if (br == false)
		{
			if (m_ptagBuf)
			{
				if (m_ptagBuf->pBuf)
				{
					free(m_ptagBuf->pBuf);
				}
				free(m_ptagBuf);
			}
			m_ptagBuf = NULL;
		}
		return br;
	}
	int COmapApiCLI::CommitObjTree()
	{
		if (m_ptagBuf==NULL)
		{
			return OMAP_API_ERR_DEAL;
		}
		int nLen = m_ptagBuf->nBuf;
		m_ptagBuf->nBuf = sizeof(tagOApiObjectOptHdr);

		tagOApiObjDataItem *pDataItem = (tagOApiObjDataItem *)OApiZeroMalloc(sizeof(tagOApiObjDataItem));
		pDataItem->iDataLen = nLen - sizeof(tagOApiObjectOptHdr)-sizeof(tagOApiObjDataItem);
		pDataItem->idObj = m_idParent;
		bool br = AppendMemBuf(m_ptagBuf, (char*)pDataItem, sizeof(tagOApiObjDataItem));
		m_ptagBuf->nBuf = nLen;
		int iRet = OMAP_API_ERR_ARGV;
		if (br)
		{
			iRet = g_omapApi.SetOmapSelObjectTree(OMAP_API_CMD_SET_OBJ_TREE, *m_ptagBuf, false);
		}

		if (m_ptagBuf)
		{
			if (m_ptagBuf->pBuf)
			{
				free(m_ptagBuf->pBuf);
			}
			free(m_ptagBuf);
		}
		m_ptagBuf = NULL;
		return iRet;
	}

	int COmapApiCLI::SetCmdCusWnd(tagCusShowWnd^ CusShowWnd)
	{
		
		tagOApiCusShowWnd *pCusShowWnd = CLI2Dll(CusShowWnd);
		if (pCusShowWnd == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		
		int iRet = g_omapApi.SetCusShowWnd(pCusShowWnd);
		free(pCusShowWnd);
		
		return iRet;
	}

	int COmapApiCLI::QueryCusShowWnd(int idWnd)
	{
		return g_omapApi.QueryCusShowWnd(idWnd);
	}

	int COmapApiCLI::DelCusShowWnd(int idWnd)
	{
		return g_omapApi.DelCusShowWnd(idWnd);
	}

	int COmapApiCLI::SetObjShowWnd(tagMapObjShowWnd^ MapObjShowWnd)
	{
		tagOApiMapObjShowWnd * pMapObjShowWnd = CLI2Dll(MapObjShowWnd);
		if (pMapObjShowWnd == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		int iRet = g_omapApi.SetObjShowWnd(pMapObjShowWnd);
		free(pMapObjShowWnd);
		return iRet;
	}


	int COmapApiCLI::SetCusMainBtn(int size)
	{
		
		char *pData = (char *)OApiZeroMalloc(3000 * size);
		tagCusMainBtn *pCmb = (tagCusMainBtn*)pData;
		int len = 0;
		for (int i = 0; i < size; i++)
		{
			if (i == 0)
			{
				pCmb->nId = i+1;
				strcpy_s(pCmb->strTxt, "aaa");
				FILE *pfile = fopen(".\\res\\btn1.png", "rb");
				char strBuf[3000] = { 0 };
				int nlen = fread(strBuf, 1, sizeof(strBuf), pfile);
				fclose(pfile);
				pCmb->nPngLen = nlen;
				memcpy((char*)(pCmb + 1), strBuf, nlen);
				len += nlen;
			}
			else
			{
				pCmb = (tagCusMainBtn*)(pData + sizeof(tagCusMainBtn) + len);
				pCmb->nId = i+1;
				strcpy_s(pCmb->strTxt, "bbb");
				FILE *pfile = fopen(".\\res\\btn2.png", "rb");
				char strBuf[3000] = { 0 };
				int nlen = fread(strBuf, 1, sizeof(strBuf), pfile);
				fclose(pfile);
				pCmb->nPngLen = nlen;
				memcpy((char*)(pCmb + 1), strBuf, nlen);
				len += nlen;
			}
		}

		int iRet = g_omapApi.SetCusMainBtn((tagCusMainBtn*)pData, sizeof(tagCusMainBtn) * size + len);
		free(pData);
	
		return iRet;

	}

	int COmapApiCLI::DelCusMainBtn(cli::array<int>^ids, int nCnt)
	{
		if (ids == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		//pPics->Count;
		int iSize = ids->Length;
		if (iSize == 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		int *pIds = (int*)zMalloc(sizeof(int)*iSize);
		if (pIds == nullptr || nCnt <= 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		for (int i = 0; i < iSize; i++)
		{
			pIds[i] = ids[i];
		}
		
		int iRet = g_omapApi.DelCusMainBtn(pIds, nCnt);
		
		return iRet;
	}

	int COmapApiCLI::QueryCusMainBtn(cli::array<int>^ids, int nCnt)
	{
		if (ids == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		//pPics->Count;
		int iSize = ids->Length;
		if (iSize == 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		int *pIds = (int*)zMalloc(sizeof(int)*iSize);
		if (pIds == nullptr || nCnt <= 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		for (int i = 0; i < iSize; i++)
		{
			pIds[i] = ids[i];
		}

		int iRet = g_omapApi.QueryCusMainBtn(pIds, nCnt);

		return iRet;
	}

	int COmapApiCLI::SetCusFavMenu(int size)
	{

		char *pData = (char *)OApiZeroMalloc(3000 * size);
		tagCusFavMenu *pCfm = (tagCusFavMenu*)pData;
		int len = 0;
		for (int i = 0; i < size; i++)
		{
			if (i == 0)
			{
				pCfm->nId = i + 1;
				strcpy_s(pCfm->strTxt, "AAA");
			}
			else
			{
				pCfm = (tagCusFavMenu*)(pData + sizeof(tagCusFavMenu));
				pCfm->nId = i + 1;
				strcpy_s(pCfm->strTxt, "BBB");
			}

		}

		int iRet = g_omapApi.SetCusFavMenu((tagCusFavMenu*)pData, sizeof(tagCusFavMenu) * size);
		free(pData);
		

		return iRet;

	}

	int COmapApiCLI::DelCusFavMenu(cli::array<int>^ids, int nCnt)
	{
		if (ids == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		//pPics->Count;
		int iSize = ids->Length;
		if (iSize == 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		int *pIds = (int*)zMalloc(sizeof(int)*iSize);
		if (pIds == nullptr || nCnt <= 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		for (int i = 0; i < iSize; i++)
		{
			pIds[i] = ids[i];
		}

		int iRet = g_omapApi.DelCusFavMenu(pIds, nCnt);

		return iRet;
	}

	int COmapApiCLI::QueryCusFavMenu(cli::array<int>^ids, int nCnt)
	{
		if (ids == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		//pPics->Count;
		int iSize = ids->Length;
		if (iSize == 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		int *pIds = (int*)zMalloc(sizeof(int)*iSize);
		if (pIds == nullptr || nCnt <= 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		for (int i = 0; i < iSize; i++)
		{
			pIds[i] = ids[i];
		}

		int iRet = g_omapApi.QueryCusFavMenu(pIds, nCnt);

		return iRet;
	}

	int COmapApiCLI::SetObjEvent(int iObjEventCmd)
	{
		return g_omapApi.SetObjEvent(iObjEventCmd);
	}
	int COmapApiCLI::SetCusMainMenu()
	{
		int nId = 1;
		int index = 0;
		tagCusMainMenu Menus[10];//˵100
		Menus[index].nId = -2;
		
		String ^strTitle = "ͨ";

		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());
		Menus[index].nId = nId++;
		strTitle = "";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = nId++;
		strTitle = "";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = -2;
		strTitle = "ɫ";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = nId++;
		strTitle = "ɫ";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = nId++;
		strTitle = "ɫ";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = -2;
		strTitle = "";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = nId++;
		strTitle = "";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = nId++;
		strTitle = "";
		strcpy(Menus[index++].strTxt, cast_to_string(strTitle).c_str());

		Menus[index].nId = nId++;
		strcpy(Menus[index++].strTxt, "Test");

		int iRet = g_omapApi.SetCusMainMenu(Menus, index);
		return iRet;
	}
	int COmapApiCLI::DelCusMainMenu()
	{
		int iRet = g_omapApi.SetCusMainMenu(nullptr, 0);
		return iRet;
	}

	bool COmapApiCLI::AppendObjToBuf(tagOApiMemBuf * ptagBuf, tagOApiObjTree^ pObjTree, int &iItemCur)
	{
		if (pObjTree==nullptr)
		{
			return false;
		}
		int nBuf = 0;
		char *pbuf = NULL;
		DWORD idOmap = 0;
		DWORD idParent = 0;
		int idLayer = 0;
		int idGis = 0;
		if (pObjTree->iObjType == OMAP_OBJ_TYPE_GROUP)
		{
			tagOApiObjGroupV3 *pObj = CLI2Dll(pObjTree->pGroup);
			idLayer = pObjTree->pGroup->idLayer;
			idGis = pObjTree->pGroup->idGis;
			idOmap = pObjTree->pGroup->idObj;
			idParent = pObjTree->pGroup->idParent;
			pbuf = (char*)g_omapApi.SetOmapObjectToBufV3(pObj, pObjTree->iObjType, nBuf);
			g_omapApi.FreeOmapObjectV3(pObj, pObjTree->iObjType);
		}
		else if (pObjTree->iObjType == OMAP_OBJ_TYPE_SIGN)
		{
			tagOApiMapSignV3 *pObj = CLI2Dll(pObjTree->pSign);
			idLayer = pObjTree->pSign->idLayer;
			idGis = pObjTree->pSign->idGis;
			idOmap = pObjTree->pSign->idObj;
			idParent = pObjTree->pSign->idParent;
			pbuf = (char*)g_omapApi.SetOmapObjectToBufV3(pObj, pObjTree->iObjType, nBuf);
			g_omapApi.FreeOmapObjectV3(pObj, pObjTree->iObjType);
		}
		else if (pObjTree->iObjType == OMAP_OBJ_TYPE_TRACK)
		{
			tagOApiMapTrackV3 *pObj = CLI2Dll(pObjTree->pTrack);
			idLayer = pObjTree->pTrack->idLayer;
			idGis = pObjTree->pTrack->idGis;
			idOmap = pObjTree->pTrack->idObj;
			idParent = pObjTree->pTrack->idParent;
			pbuf = (char*)g_omapApi.SetOmapObjectToBufV3(pObj, pObjTree->iObjType, nBuf);
			g_omapApi.FreeOmapObjectV3(pObj, pObjTree->iObjType);
		}
		else if (pObjTree->iObjType == OMAP_OBJ_TYPE_SHAPE)
		{
			tagOApiMapShapeV3 *pObj = CLI2Dll(pObjTree->pShape);
			idLayer = pObjTree->pShape->idLayer;
			idGis = pObjTree->pShape->idGis;
			idOmap = pObjTree->pShape->idObj;
			idParent = pObjTree->pShape->idParent;
			pbuf = (char*)g_omapApi.SetOmapObjectToBufV3(pObj, pObjTree->iObjType, nBuf);
			g_omapApi.FreeOmapObjectV3(pObj, pObjTree->iObjType);
		}
		else if (pObjTree->iObjType == OMAP_OBJ_TYPE_DIR)
		{
			tagOApiMapDirectionsV3 *pObj = CLI2Dll(pObjTree->pDir);
			idLayer = pObjTree->pDir->idLayer;
			idGis = pObjTree->pDir->idGis;
			idOmap = pObjTree->pDir->idObj;
			idParent = pObjTree->pDir->idParent;
			pbuf = (char*)g_omapApi.SetOmapObjectToBufV3(pObj, pObjTree->iObjType, nBuf);
			g_omapApi.FreeOmapObjectV3(pObj, pObjTree->iObjType);
		}
		if (pbuf==NULL)
		{
			return false;
		}
		tagOApiObjDataItem *pDataItem = (tagOApiObjDataItem *)OApiZeroMalloc(sizeof(tagOApiObjDataItem));
		pDataItem->iDataLen = nBuf;
		pDataItem->idObj = idOmap;
		if (idParent!=0)
		{
			pDataItem->idParent = idParent;
		}
		INT64 idlayer64 = idLayer;
		pDataItem->iCustomData = idlayer64<<32|(idGis & 0xffffffff);
		pDataItem->iObjType = pObjTree->iObjType;
		iItemCur = ptagBuf->nBuf;
		bool br = AppendMemBuf(ptagBuf, (char*)pDataItem, sizeof(tagOApiObjDataItem));
		free(pDataItem);
		if (br)
		{
			AppendMemBuf(ptagBuf, pbuf, nBuf);
		}
		free(pbuf);
		return br;
	}
	bool COmapApiCLI::AddObjTreeToBuf(tagOApiMemBuf * ptagBuf,tagOApiObjTree^ pObjTree, DWORD idParent)
	{
		
		while (pObjTree != nullptr)
		{
			int iItemCur = 0;
			if (AppendObjToBuf(ptagBuf, pObjTree,iItemCur) == false)
			{
				return false;
			}
			if (pObjTree->pChild!=nullptr)
			{
				if (AddObjTreeToBuf(ptagBuf, pObjTree->pChild, idParent) == false)
				{
					return false;
				}
				//tagOApiObjDataItem *pDataItem = (tagOApiObjDataItem*)(ptagBuf->pBuf + iItemCur);
				//pDataItem->iDataLen = ptagBuf->nBuf - iItemCur;
			}
			pObjTree = pObjTree->pNext;
		}
		return true;
	}


	int COmapApiCLI::SetOmapSelObjectTree(tagOApiObjTree^ pObjTree,DWORD idParent)
	{


		if (pObjTree==nullptr)
		{
			return OMAP_API_ERR_DEAL;
		}
		tagOApiMemBuf tagBuf;
		memset(&tagBuf, 0, sizeof(tagOApiMemBuf));
		tagBuf.nMem = 1000;
		tagBuf.pBuf = (char *)malloc(tagBuf.nMem);
		memset(tagBuf.pBuf, 0, tagBuf.nMem);
		tagOApiObjectOptHdr* pOoh = OApiNewOptHdr(0);
		pOoh->idParent = idParent;
		bool br = AppendMemBuf(&tagBuf, (char*)pOoh, sizeof(tagOApiObjectOptHdr));
		free(pOoh);
		tagBuf.nBuf += sizeof(tagOApiObjDataItem);
		
		br = br && AddObjTreeToBuf(&tagBuf, pObjTree, idParent);
		if (br == false)
		{
			free(tagBuf.pBuf);
			return OMAP_API_ERR_DEAL;
		}
		int nLen = tagBuf.nBuf;
		tagBuf.nBuf = sizeof(tagOApiObjectOptHdr);

		tagOApiObjDataItem *pDataItem = (tagOApiObjDataItem *)OApiZeroMalloc(sizeof(tagOApiObjDataItem));
		pDataItem->iDataLen = nLen - sizeof(tagOApiObjectOptHdr)-sizeof(tagOApiObjDataItem);
		pDataItem->idObj = idParent;
		br = AppendMemBuf(&tagBuf, (char*)pDataItem, sizeof(tagOApiObjDataItem));
		free(pDataItem);
		tagBuf.nBuf = nLen;
		int iRet = OMAP_API_ERR_ARGV;
		if (br)
		{
			iRet = g_omapApi.SetOmapSelObjectTree(OMAP_API_CMD_SET_OBJ_TREE, tagBuf, true);
		}
		else
		{
			free(tagBuf.pBuf);
		}
		return iRet;
	}


	int COmapApiCLI::GetOmapObjectList(DWORD idParent)
	{
		return g_omapApi.GetOmapObjectList(idParent,1);
	}
	int COmapApiCLI::GetOmapObject(DWORD idObj, BYTE bLlType)
	{
		return g_omapApi.GetOmapObject(idObj, bLlType);
	}
	int COmapApiCLI::DelOmapObject(cli::array<DWORD>^ pidList, int nId, bool bNoGroup, bool bForceDel)
	{
		DWORD* pIds = (DWORD*)zMalloc(sizeof(DWORD)*nId);
		for (int i = 0; i < nId;i++)
		{
			pIds[i] = pidList[i];
		}
		int iRet = g_omapApi.DelOmapObject(pIds, nId, bNoGroup, bForceDel);
		free(pIds);
		return iRet;
	}
	int COmapApiCLI::GetOmapSelectList(int iFlag)
	{
		return g_omapApi.GetOmapSelectList(iFlag);
	}
	int COmapApiCLI::SetOmapSelectIdList(cli::array<UINT>^ pidList)
	{
		int nId = pidList->Length;
		if (nId==0)
		{
			return OMAP_API_ERR_ARGV;
		}
		DWORD* pIds = CLI2Dll(pidList);
		int iRet = g_omapApi.SetOmapSelectIdList(pIds, nId);
		free(pIds);
		return iRet;
	}
	int COmapApiCLI::SrhOmapObject(tagOApiObjectSrhReqCli^ pSrhReq)
	{
		tagOApiObjectSrhReq *pSrh = CLI2Dll(pSrhReq);
		int iRet = -1;
		if (pSrh)
		{
			iRet = g_omapApi.SrhOmapObject(pSrh);
			free(pSrh);
		}
		return iRet;
	}
	void COmapApiCLI::DecodeObjSrhRes(tagOApiObjectSrhRes* pSrhRes, int nRes)
	{
		cli::array<tagOApiObjectSrhResCli^>^ pResCli = nullptr;
		if (pSrhRes!=nullptr&&nRes !=0)
		{
			pResCli = gcnew cli::array<tagOApiObjectSrhResCli ^>(nRes);
			for (int i = 0; i < nRes;i++)
			{
				pResCli[i] = gcnew tagOApiObjectSrhResCli();
				pResCli[i]->idObj = pSrhRes[i].idObj;
				pResCli[i]->iObjType = pSrhRes[i].iObjType;
			}
		}
		WndCmd(pResCli);
	}
	int COmapApiCLI::GetOmapMapData(double x_lng1, double y_lat1, double x_lng2, double y_lat2, INT64 iMaxPixel, int iMaxLevel)
	{
		return g_omapApi.GetOmapMapData(x_lng1, y_lat1, x_lng2, y_lat2, iMaxPixel, iMaxLevel);
	}
	void COmapApiCLI::DecodeMapData(tagOmapGetMap * pMapData, BYTE *pData,int nData)
	{
		if (pMapData==nullptr||pData==nullptr||nData<=0)
		{
			return;
		}
		tagOmapGetMapCli^ pGetMapCli = gcnew tagOmapGetMapCli();
		pGetMapCli->bRealLl = pMapData->bRealLl;
		pGetMapCli->x_lng1 = pMapData->x_lng1;
		pGetMapCli->y_lat1 = pMapData->y_lat1;
		pGetMapCli->x_lng2 = pMapData->x_lng2;
		pGetMapCli->y_lat2 = pMapData->y_lat2;
		pGetMapCli->height = pMapData->height;
		pGetMapCli->width = pMapData->width;
		pGetMapCli->iMaxLevel = pMapData->iMaxLevel;
		pGetMapCli->iMaxPixel = pMapData->iMaxPixel;
		pGetMapCli->pData = gcnew cli::array<byte>(nData);
		for (int i = 0; i < nData;i++)
		{
			pGetMapCli->pData[i] = pData[i];
		}
		WndCmd(pGetMapCli);
	}
	int COmapApiCLI::SetOmapButton(int iAdd, String^strTip, int iTimeoutMs)
	{
		if (iAdd == 1)
		{
			m_tagSysMsg->bSetBtn = true;
		}
		else if (iAdd == 0)
		{
			m_tagSysMsg->bSetBtn = false;
		}
		string strBuf = cast_to_string(strTip);
		return g_omapApi.SetOmapButton(iAdd, (char*)strBuf.c_str(), iTimeoutMs);
	}
	int COmapApiCLI::GetOmapStatusInfo()
	{
		int iRet = g_omapApi.GetOmapStatusInfo();
		m_tagSysMsg->iVip = GET_OMAP_API_STATUE_LV(iRet);
		return iRet;
	}
	int COmapApiCLI::ReqVip5Demo(bool bSend)
	{
		return g_omapApi.ReqVip5Demo(bSend);
	}
	int COmapApiCLI::CheckInterfaceVer(int iType, int iVer, bool bSendReq)
	{
		return g_omapApi.CheckInterfaceVer(iType, iVer, bSendReq);
	}
	int COmapApiCLI::GetOmapPluginVer()
	{
		return g_omapApi.GetOmapPluginVer();
	}
	int COmapApiCLI::GetOmapWndRect()
	{
		return g_omapApi.GetOmapWndRect();
	}
	int COmapApiCLI::GetMapShapeDetail(DWORD idObj)
	{
		return g_omapApi.GetShapeDetail(idObj);
	}
	int COmapApiCLI::GetMapTrackDetail(DWORD idObj)
	{
		return g_omapApi.GetTrackDetail(idObj);
	}
	
	int COmapApiCLI::SetSysCoorPoint(int iCoorType, tagOApiRelatePoint^ pPoint)
	{
		tagOApiRelatePointV1 *pPointDll = CLI2Dll(pPoint);
		int iRet = OMAP_API_ERR_ARGV;
		if (pPointDll)
		{
			iRet = g_omapApi.SetSysCoorPoint(iCoorType, pPointDll, 1);
			free(pPointDll);
		}
		return iRet;
	}
	int COmapApiCLI::SetSysCoorPoint(int iCoorType, cli::array<tagOApiRelatePoint^>^ pPoints)
	{
		tagOApiRelatePointV1 *pPointDll = CLI2Dll(pPoints);
		int iRet = OMAP_API_ERR_ARGV;
		if (pPointDll)
		{
			iRet = g_omapApi.SetSysCoorPoint(iCoorType, pPointDll, pPoints->Length);
			free(pPointDll);
		}
		return iRet;
		
	}
	void COmapApiCLI::GetSysCoorInfo()
	{
		g_omapApi.GetSysCoorInfo();
	}
	void COmapApiCLI::GetSysCoorCenter()
	{
		g_omapApi.GetSysCoorCenter();
	}
	void COmapApiCLI::GetCoorPixelInfo(double lng_x, double lat_y)
	{
		int iRet = g_omapApi.GetCoorPixelInfo(lng_x, lat_y);
	}
	void COmapApiCLI::GetWinMapInfo(BYTE bRealLL)
	{
		g_omapApi.GetWinMapInfo(bRealLL);
	}
	int COmapApiCLI::FollowWinMapInfo(int iFollowMs)
	{
		if (iFollowMs == 1)
		{
			m_tagSysMsg->bFollowWin = false;
		}
		else if (iFollowMs>1)
		{
			m_tagSysMsg->bFollowWin = true;
		}
		return g_omapApi.FollowWinMapInfo(iFollowMs);
	}
	int COmapApiCLI::FollowObjChange(int iAppID)
	{
		if (iAppID == OAPI_APP_ID_ALL||iAppID>0)
		{
			m_tagSysMsg->bFollowObj = true;
		}
		else if (iAppID == OAPI_APP_ID_NONE)
		{
			m_tagSysMsg->bFollowObj = false;
		}

		return g_omapApi.FollowObjChange(iAppID);
	}
	int COmapApiCLI::SendGetShapeFillPatList()
	{
		return g_omapApi.SendGetShapeFillPatList();
	}
	bool COmapApiCLI::DeocdeShapeFillPatList(void *pBuf, int nBuf)
	{
		m_pFillCadPatHdr = g_omapApi.DeocdeShapeFillPatList(pBuf, nBuf);
		return m_pFillCadPatHdr?true:false;
	}
	void COmapApiCLI::FreeShapeFillPatList(bool bFreeMe)
	{
		g_omapApi.FreeShapeFillPatList(m_pFillCadPatHdr, bFreeMe);
	}
	int COmapApiCLI::GetLatlng()
	{
		return g_omapApi.SendMessageToOmap(OMAP_WIN_CMD_GET_LATLNG, NULL, 0);
	}
	int COmapApiCLI::SetPicSignList(cli::array<tagOphotoMapPicCli^>^ pOmps)
	{
		tagOPhotoMapPic *pOm = CLI2Dll(pOmps);
		int iRet = OMAP_API_ERR_ARGV;
		if (pOm)
		{
			iRet = g_omapApi.SendMessageToOmap(OMAP_WIN_CMD_SHOW_PIC, pOm, sizeof(tagOPhotoMapPic)*pOmps->Length);
			free(pOm);
		}
		return iRet;
	}
	int COmapApiCLI::GetLatlngByTime(cli::array<tagOphotoMapPicCli^>^ pOmps)
	{
		tagOPhotoMapPic *pOm = CLI2Dll(pOmps);
		int iRet = OMAP_API_ERR_ARGV;
		if (pOm)
		{
			iRet = g_omapApi.SendMessageToOmap(OMAP_WIN_CMD_TIME_TO_LATLNG, pOm, sizeof(tagOPhotoMapPic)*pOmps->Length);
			free(pOm);
		}
		return iRet;
	}
	void COmapApiCLI::ReleaseRes()
	{
		if (m_pFillCadPatHdr)
		{
			FreeShapeFillPatList(true);
		}
		if (m_ptagBuf)
		{
			if (m_ptagBuf->nMem > 0)
			{
				free(m_ptagBuf->pBuf);
			}
			free(m_ptagBuf);
			m_ptagBuf = NULL;
		}
		if (m_tagSysMsg)
		{
			if (m_tagSysMsg->bFollowObj)
			{
				g_omapApi.FollowObjChange(OAPI_APP_ID_NONE);
			}
			if (m_tagSysMsg->bFollowWin)
			{
				g_omapApi.FollowWinMapInfo(1);
			}
			if (m_tagSysMsg->bSetBtn)
			{
				g_omapApi.SetOmapButton(0, "Cleared");
			}
		}
	}
	void COmapApiCLI::PrintMsgBox(char* strMsg, char* strTitle)
	{
#ifdef Debug_MESSAGEBOX
		USES_CONVERSION;
		MessageBox(NULL, A2T(strMsg), A2T(strTitle), MB_OK);
#endif // Debug_MESSAGEBOX
		
	}
	int COmapApiCLI::GetOmapMapFile(cli::array<tagOmapGetMapFileCli^>^ pReqs)
	{
		if (pReqs==nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		int nReq = pReqs->Length;
		if (nReq==0)
		{
			return OMAP_API_ERR_ARGV;
		}
		tagOmapGetMapFile* pReq = CLI2Dll(pReqs);
		int iRet = g_omapApi.GetOmapMapFile(pReq, nReq);
		free(pReq);
		return iRet;
	}
	void COmapApiCLI::DecodeMapFile(tagOmapGetMapFile* pMapFile)
	{
		tagOmapGetMapFileCli^ pMapFileCli = Dll2CLI(pMapFile);
		WndCmd(pMapFileCli);
	}
	int COmapApiCLI::GetOmapContour(tagOmapReqContourCli^ pReq)
	{
		if (pReq == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		
		tagOmapReqContour *pReqDll = CLI2Dll(pReq);
		m_tagConBox->x_lng1 = pReq->x_lng1;
		m_tagConBox->y_lat1 = pReq->y_lat1;
		m_tagConBox->x_lng2 = pReq->x_lng2;
		m_tagConBox->y_lat2 = pReq->y_lat2;
		m_tagConBox->iValue = pReq->iValue;
		m_tagConBox->iMapLevel = pReq->iMapLevel;
		m_tagConBox->iPostCnt = pReq->iPostCnt;
		m_tagConBox->iElevValue = pReq->iElevValue;
		if (pReq->iCheckFlag==1)//ʾ  ΪΧ10
		{
			if (m_tagSysMsg->dxPixel==nullptr||m_tagSysMsg->dyPixel==nullptr)
			{
				g_omapApi.GetCoorPixelInfo((pReq->x_lng1 + pReq->x_lng2) / 2, (pReq->y_lat1 + pReq->y_lat2) / 2);
				if (m_tagSysMsg->dxPixel != nullptr && m_tagSysMsg->dyPixel != nullptr)
				{
					pReqDll->x_lng1 = pReq->x_lng1 - 10 * m_tagSysMsg->dxPixel[pReq->iMapLevel];
					pReqDll->x_lng2 = pReq->x_lng2 + 10 * m_tagSysMsg->dxPixel[pReq->iMapLevel];
					pReqDll->y_lat1 = pReq->y_lat1 - 10 * m_tagSysMsg->dyPixel[pReq->iMapLevel];
					pReqDll->y_lat2 = pReq->y_lat2 + 10 * m_tagSysMsg->dyPixel[pReq->iMapLevel];
				}
			}
		}
		int iRet = g_omapApi.GetOmapContour(pReqDll, 1);
		free(pReqDll);
		return iRet;
	}

	int COmapApiCLI::GetWebSocketConf()
	{
		return g_omapApi.GetSysWebSocketConf();
	}

	int COmapApiCLI::GetCusMapCfgList()
	{
		return g_omapApi.GetCusMapCfgList();
	}

	int COmapApiCLI::ReGetOmapContour()
	{
		tagOmapReqContour tagReq;
		memset(&tagReq, 0, sizeof(tagOmapReqContour));
		tagReq.bRealLl = 2;
		tagReq.iCheckFlag = 0;
		tagReq.idMap = m_tagConBox->idMap;
		tagReq.iElevValue = m_tagConBox->iElevValue;
		tagReq.iMapLevel = m_tagConBox->iMapLevel;
		tagReq.iPostCnt = m_tagConBox->iPostCnt;
		tagReq.iValue = m_tagConBox->iValue;
		tagReq.x_lng1 = m_tagConBox->x_lng1;
		tagReq.x_lng2 = m_tagConBox->x_lng2;
		tagReq.y_lat1 = m_tagConBox->y_lat1;
		tagReq.y_lat2 = m_tagConBox->y_lat2;
		int iRet = g_omapApi.GetOmapContour(&tagReq, 1);
		return iRet;
	}
	void COmapApiCLI::DecodeContour(tagOmapReqContour* pReq)
	{
		if (pReq == nullptr)
		{
			return;
		}
		if (pReq->iRet >= 0 || pReq->iRet == GET_CONTOUR_RET_ERR_PART_OK)
		{
			pReq->pData = pReq + 1;
			if (pReq->nData > 0)
			{
				tagOApiObjectOptHdr *pOptHdr = (tagOApiObjectOptHdr*)pReq->pData;
				DecodeOmapObjBuf2TreeStruct(pOptHdr);
			}
			
		}
		
		tagOmapReqContourCli^ pReqCli = Dll2CLI(pReq);
		if (pReqCli==nullptr)
		{
			return;
		}

		WndCmd(pReqCli);
	}
	String^ COmapApiCLI::GetPatItem(DWORD dwFillPattern)
	{
		if (m_pFillCadPatHdr == nullptr)
		{
			g_omapApi.SendGetShapeFillPatList();
		}
		if (m_pFillCadPatHdr)
		{
			for (int i = 0; i < m_pFillCadPatHdr->nSfcpi; i++)
			{
				if (m_pFillCadPatHdr->pSfcpi[i].id == dwFillPattern)
				{
					return cast_strUtf8_to_String(m_pFillCadPatHdr->pSfcpi[i].strName);
				}
			}
		}
		return "SOLID";
	}
	tagOApiShapeFillCadPatItemCli^ COmapApiCLI::GetPatItemDef(DWORD dwFillPattern)
	{
		tagOApiShapeFillCadPatItem* pPatItem= nullptr;
		if (m_pFillCadPatHdr == NULL)
		{
			g_omapApi.SendGetShapeFillPatList();
		}
		if (m_pFillCadPatHdr)
		{
			for (int i = 0; i < m_pFillCadPatHdr->nSfcpi; i++)
			{
				if (m_pFillCadPatHdr->pSfcpi[i].id == dwFillPattern)
				{
					pPatItem = &m_pFillCadPatHdr->pSfcpi[i];
					break;
				}
			}
		}
		return Dll2CLI(pPatItem);
	}
	DWORD COmapApiCLI::GetPatItemId(String^ StrPatName)
	{
		string st = cast_to_string(StrPatName, MAX_API_NAME_LEN);
		const char *pbuf = st.c_str();
		char patName[MAX_API_NAME_LEN];
		strcpy_s(patName, pbuf);
		if (m_pFillCadPatHdr == NULL)
		{
			g_omapApi.SendGetShapeFillPatList();
		}
		if (m_pFillCadPatHdr)
		{
			int len = strlen(patName);
			for (int i = len - 1; i >= 0; i--)
			{
				if (patName[i] == ',')
				{
					patName[i] = 0;
				}
			}
			for (int i = 0; i < m_pFillCadPatHdr->nSfcpi; i++)
			{
				if (strcmp(m_pFillCadPatHdr->pSfcpi[i].strName, patName) == 0)
				{
					return m_pFillCadPatHdr->pSfcpi[i].id;
				}
			}
			return m_pFillCadPatHdr->pSfcpi[0].id;
		}
		return 0;
	}
	bool COmapApiCLI::DecodeOmapSingleObjBuf(tagOApiObjectOptHdr *pOoh, int nBuf)
	{
		if (pOoh->iType == OMAP_OBJ_TYPE_GROUP)
		{
			tagOApiObjGroupV2* pGroup = g_omapApi.GetOmapGroupFromBufV2(pOoh + 1, nBuf);
			tagOApiObjGroup^ pGroupCli = Dll2CLI(pGroup);
			pGroupCli->idObj = pOoh->idObj;
			pGroupCli->idParent = pOoh->idParent;
			WndCmd(pGroupCli);
			g_omapApi.FreeOmapObjectV2(pGroup, OMAP_OBJ_TYPE_GROUP);
		}
		else if (pOoh->iType == OMAP_OBJ_TYPE_SIGN)
		{
			tagOApiMapSignV2* pSign = g_omapApi.GetOmapSignFromBufV2(pOoh + 1, nBuf);
			tagOApiMapSign^ pSignCli = Dll2CLI(pSign);
			pSignCli->idObj = pOoh->idObj;
			pSignCli->idParent = pOoh->idParent;
			WndCmd(pSignCli);
			g_omapApi.FreeOmapObjectV2(pSign, OMAP_OBJ_TYPE_SIGN);
		}
		else if (pOoh->iType == OMAP_OBJ_TYPE_TRACK)
		{
			tagOApiMapTrackV2* pTrack = g_omapApi.GetOmapTrackFromBufV2(pOoh + 1, nBuf);
			tagOApiMapTrack^ pTrackCli = Dll2CLI(pTrack);
			pTrackCli->idObj = pOoh->idObj;
			pTrackCli->idParent = pOoh->idParent;
			WndCmd(pTrackCli);
			g_omapApi.FreeOmapObjectV2(pTrack, OMAP_OBJ_TYPE_TRACK);
		}
		else if (pOoh->iType == OMAP_OBJ_TYPE_SHAPE)
		{
			tagOApiMapShapeV2* pShape = g_omapApi.GetOmapShapeFromBufV2(pOoh + 1, nBuf);
			tagOApiMapShape^ pShapeCli = Dll2CLI(pShape);
			pShapeCli->idParent = pOoh->idParent;
			WndCmd(pShapeCli);
			g_omapApi.FreeOmapObjectV2(pShape, OMAP_OBJ_TYPE_SHAPE);
		}
		else if (pOoh->iType == OMAP_OBJ_TYPE_DIR)
		{
			tagOApiMapDirectionsV2* pDir = g_omapApi.GetOmapDirFromBufV2(pOoh + 1, nBuf);
			tagOApiMapDirections^ pDirCli = Dll2CLI(pDir);
			pDirCli->idObj = pOoh->idObj;
			pDirCli->idParent = pOoh->idParent;
			WndCmd(pDirCli);
			g_omapApi.FreeOmapObjectV2(pDir, OMAP_OBJ_TYPE_DIR);
		}
		else
		{
			//PrintMsgBox("ֵ֧Ķ", "ʾ");
			return false;
		}
		return true;
	}

	bool COmapApiCLI::DecodeOmapObjBuf(tagOApiObjectOptHdr *pOptHdr)
	{
		if (m_bBatchGetObjTree == 2)
		{
			return DecodeOmapObjBuf2TreeStruct(pOptHdr);
		}
		vector<tagOApiMapSignV2*> v_Sign;
		vector<tagOApiObjGroupV2 *> v_Group;
		vector<tagOApiMapTrackV2*> v_Track;
		vector<tagOApiMapShapeV2*> v_Shape;
		vector<tagOApiMapDirectionsV2*> v_Dir;
		vector<DWORD> v_SignId;
		vector<DWORD> v_GroupId;
		vector<DWORD> v_TrackId;
		vector<DWORD> v_ShapeId;
		vector<DWORD> v_DirId;
		vector<DWORD> v_SignIdParent;
		vector<DWORD> v_GroupIdParent;
		vector<DWORD> v_TrackIdParent;
		vector<DWORD> v_ShapeIdParent;
		vector<DWORD> v_DirIdParent;
		tagOApiObjDataItem *pDataItem;
		pDataItem = (tagOApiObjDataItem*)(pOptHdr + 1);
		int iTotalLen = pDataItem->iDataLen;
		pDataItem++;
		bool bMemoryErr = false;
		double dProgRate = 0;
		int iTempRate = 0;
		for (int i = 0; i < iTotalLen;)
		{
			if (m_ehGetProgRate)
			{
				if (m_bBatchGetObjTree == 1)
				{
					dProgRate = 0.5*i / iTotalLen;
				}
				else
				{
					dProgRate = 1.0*i / iTotalLen;
				}
				if (iTempRate!=(int)(100*dProgRate))
				{
					WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
					iTempRate = (int)(100 * dProgRate);
				}
			}
			int len = pDataItem->iDataLen;
			i += len + sizeof(tagOApiObjDataItem);
			if (len>0)
			{
				if (pDataItem->iObjType == OMAP_OBJ_TYPE_GROUP)
				{
					tagOApiObjGroupV2 *pGroup = g_omapApi.GetOmapGroupFromBufV2(pDataItem + 1, len);
					if (pGroup==nullptr)
					{
						bMemoryErr = true;
						break;
					}
					if (m_bBatchGetObjTree == 1)
					{
						v_Group.push_back(pGroup);
						v_GroupId.push_back(pDataItem->idObj);
						v_GroupIdParent.push_back(pDataItem->idParent);
					}
					else
					{
						tagOApiObjGroup^ pGroupCli = Dll2CLI(pGroup);
						pGroupCli->idObj = pDataItem->idObj;
						pGroupCli->idParent = pDataItem->idParent;
						WndCmd(pGroupCli);
						g_omapApi.FreeOmapObjectV2(pGroup, OMAP_OBJ_TYPE_GROUP);
					}
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_SIGN)
				{
					tagOApiMapSignV2* pSign = g_omapApi.GetOmapSignFromBufV2(pDataItem + 1, len);
					if (pSign == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					if (m_bBatchGetObjTree == 1)
					{
						v_Sign.push_back(pSign);
						v_SignId.push_back(pDataItem->idObj);
						v_SignIdParent.push_back(pDataItem->idParent);
					}
					else
					{
						tagOApiMapSign^ pSignCli= Dll2CLI(pSign);
						pSignCli->idObj = pDataItem->idObj;
						pSignCli->idParent = pDataItem->idParent;
						WndCmd(pSignCli);
						g_omapApi.FreeOmapObjectV2(pSign, OMAP_OBJ_TYPE_SIGN);
					}
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_TRACK)
				{
					tagOApiMapTrackV2* pTrack = g_omapApi.GetOmapTrackFromBufV2(pDataItem + 1, len);
					if (pTrack == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					if (m_bBatchGetObjTree == 1)
					{
						v_Track.push_back(pTrack);
						v_TrackId.push_back(pDataItem->idObj);
						v_TrackIdParent.push_back(pDataItem->idParent);
					}
					else
					{
						tagOApiMapTrack^ pTrackCli = Dll2CLI(pTrack);
						pTrackCli->idObj = pDataItem->idObj;
						pTrackCli->idParent = pDataItem->idParent;
						WndCmd(pTrackCli);
						g_omapApi.FreeOmapObjectV2(pTrack, OMAP_OBJ_TYPE_TRACK);
					}
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_SHAPE)
				{
					tagOApiMapShapeV2* pShape = g_omapApi.GetOmapShapeFromBufV2(pDataItem + 1, len);
					if (pShape == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					if (m_bBatchGetObjTree == 1)
					{
						v_Shape.push_back(pShape);
						v_ShapeId.push_back(pDataItem->idObj);
						v_ShapeIdParent.push_back(pDataItem->idParent);
					}
					else
					{
						tagOApiMapShape^ pShapeCli = Dll2CLI(pShape);
						pShapeCli->idObj = pDataItem->idObj;
						pShapeCli->idParent = pDataItem->idParent;
						WndCmd(pShapeCli);
						g_omapApi.FreeOmapObjectV2(pShape, OMAP_OBJ_TYPE_SHAPE);
					}
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_DIR)
				{
					tagOApiMapDirectionsV2* pDir = g_omapApi.GetOmapDirFromBufV2(pDataItem + 1, len);
					if (pDir == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					if (m_bBatchGetObjTree == 1)
					{
						v_Dir.push_back(pDir);
						v_DirId.push_back(pDataItem->idObj);
						v_DirIdParent.push_back(pDataItem->idParent);
					}
					else
					{
						tagOApiMapDirections^ pDirCli = Dll2CLI(pDir);
						pDirCli->idObj = pDataItem->idObj;
						pDirCli->idParent = pDataItem->idParent;
						WndCmd(pDirCli);
						g_omapApi.FreeOmapObjectV2(pDir, OMAP_OBJ_TYPE_DIR);
					}
					
				}
			}
			if (i < iTotalLen)
			{
				pDataItem = (tagOApiObjDataItem *)((char*)(pDataItem + 1) + len);
			}
		}
		
		if (m_bBatchGetObjTree==1)
		{
			dProgRate = 0.5;
			WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
			iTempRate = (int)(100 * dProgRate);

			int iTolalObj = v_Sign.size() + v_Track.size() + v_Shape.size() + v_Dir.size() + v_Group.size();
			int iCurObj = 0;
			bool bRet = true;
			if (v_Group.size() > 0)
			{
				iCurObj++;
				dProgRate = 0.5 + 1.0 * iCurObj / iTolalObj;
				if (iTempRate != (int)(100 * dProgRate))
				{
					WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
					iTempRate = (int)(100 * dProgRate);
				}

				int iSize = v_Group.size();
				cli::array<tagOApiObjGroup^>^ pObjArray = gcnew cli::array<tagOApiObjGroup ^>(iSize);
				if (pObjArray == nullptr)
				{
					bMemoryErr = true;
					bRet = false;
				}
				for (int i = 0; i < iSize; i++)
				{
					if (bRet)
					{
						pObjArray[i] = gcnew tagOApiObjGroup();
						if (pObjArray[i] == nullptr)
						{
							bMemoryErr = true;
							bRet = false;
						}
						else
						{
							pObjArray[i] = Dll2CLI(v_Group.at(i));
							pObjArray[i]->idObj = v_GroupId.at(i);
							pObjArray[i]->idParent = v_GroupIdParent.at(i);
						}
					}
					g_omapApi.FreeOmapObjectV2(v_Group.at(i), OMAP_OBJ_TYPE_GROUP);
				}
				WndCmd(pObjArray);
			}
			bRet = true;
			if (v_Sign.size()>0)
			{
				iCurObj++;
				dProgRate = 0.5 + 1.0 * iCurObj / iTolalObj;
				if (iTempRate != (int)(100 * dProgRate))
				{
					WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
					iTempRate = (int)(100 * dProgRate);
				}

				int iSize = v_Sign.size();
				cli::array<tagOApiMapSign^>^ pObjArray = gcnew cli::array<tagOApiMapSign ^>(iSize);
				if (pObjArray == nullptr)
				{
					bMemoryErr = true;
					bRet = false;
				}
				for (int i = 0; i < iSize;i++)
				{
					if (bRet)
					{
						pObjArray[i] = gcnew tagOApiMapSign();
						if (pObjArray[i] == nullptr)
						{
							bMemoryErr = true;
							bRet = false;
						}
						else
						{
							pObjArray[i] = Dll2CLI(v_Sign.at(i));
							pObjArray[i]->idObj = v_SignId.at(i);
							pObjArray[i]->idParent = v_SignIdParent.at(i);
						}
					}
					g_omapApi.FreeOmapObjectV2(v_Sign.at(i), OMAP_OBJ_TYPE_SIGN);
				}
				WndCmd(pObjArray);
			}
			bRet = true;
			if (v_Track.size() > 0)
			{
				iCurObj++;
				dProgRate = 0.5 + 1.0 * iCurObj / iTolalObj;
				if (iTempRate != (int)(100 * dProgRate))
				{
					WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
					iTempRate = (int)(100 * dProgRate);
				}

				int iSize = v_Track.size();
				cli::array<tagOApiMapTrack^>^ pObjArray = gcnew cli::array<tagOApiMapTrack ^>(iSize);
				if (pObjArray == nullptr)
				{
					bMemoryErr = true;
					bRet = false;
				}
				for (int i = 0; i < iSize; i++)
				{
					if (bRet)
					{
						pObjArray[i] = gcnew tagOApiMapTrack();
						if (pObjArray[i] == nullptr)
						{
							bMemoryErr = true;
							bRet = false;
						}
						else
						{
							pObjArray[i] = Dll2CLI(v_Track.at(i));
							pObjArray[i]->idObj = v_TrackId.at(i);
							pObjArray[i]->idParent = v_TrackIdParent.at(i);
						}
					}
					g_omapApi.FreeOmapObjectV2(v_Track.at(i), OMAP_OBJ_TYPE_TRACK);
				}
				WndCmd(pObjArray);
			}
			bRet = true;
			if (v_Shape.size() > 0)
			{
				iCurObj++;
				dProgRate = 0.5 + 1.0 * iCurObj / iTolalObj;
				if (iTempRate != (int)(100 * dProgRate))
				{
					WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
					iTempRate = (int)(100 * dProgRate);
				}

				int iSize = v_Shape.size();
				cli::array<tagOApiMapShape^>^ pObjArray = gcnew cli::array<tagOApiMapShape ^>(iSize);
				if (pObjArray == nullptr)
				{
					bMemoryErr = true;
					bRet = false;
				}
				for (int i = 0; i < iSize; i++)
				{
					if (bRet)
					{
						pObjArray[i] = gcnew tagOApiMapShape();
						if (pObjArray[i] == nullptr)
						{
							bMemoryErr = true;
							bRet = false;
						}
						else
						{
							pObjArray[i] = Dll2CLI(v_Shape.at(i));
							pObjArray[i]->idObj = v_ShapeId.at(i);
							pObjArray[i]->idParent = v_ShapeIdParent.at(i);
						}
					}
					g_omapApi.FreeOmapObjectV2(v_Shape.at(i), OMAP_OBJ_TYPE_SHAPE);
				}
				WndCmd(pObjArray);
			}
			
			bRet = true;
			if (v_Dir.size() > 0)
			{
				iCurObj++;
				dProgRate = 0.5 + 1.0 * iCurObj / iTolalObj;
				if (iTempRate != (int)(100 * dProgRate))
				{
					WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
					iTempRate = (int)(100 * dProgRate);
				}

				int iSize = v_Dir.size();
				cli::array<tagOApiMapDirections^>^ pObjArray = gcnew cli::array<tagOApiMapDirections ^>(iSize);
				if (pObjArray == nullptr)
				{
					bMemoryErr = true;
					bRet = false;
				}
				for (int i = 0; i < iSize; i++)
				{
					if (bRet)
					{
						pObjArray[i] = gcnew tagOApiMapDirections();
						if (pObjArray[i] == nullptr)
						{
							bMemoryErr = true;
							bRet = false;
						}
						else
						{
							pObjArray[i] = Dll2CLI(v_Dir.at(i));
							pObjArray[i]->idObj = v_DirId.at(i);
							pObjArray[i]->idParent = v_DirIdParent.at(i);
						}
					}
					g_omapApi.FreeOmapObjectV2(v_Dir.at(i), OMAP_OBJ_TYPE_DIR);
				}
				WndCmd(pObjArray);
			}
			
			
		}
		
		dProgRate = 1;
		WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
		return bMemoryErr?false:true;
	}

	bool COmapApiCLI::DecodeOmapObjBuf2TreeStruct(tagOApiObjectOptHdr *pOptHdr)
	{
		tagOApiObjTree^ pTreeParent = nullptr;// gcnew tagOApiObjTree();
		tagOApiObjTree^ pCurObjTree = nullptr;
		tagOApiTreeMgr^ pCurTreeMgr = nullptr;
		tagOApiObjDataItem *pDataItem;
		pDataItem = (tagOApiObjDataItem*)(pOptHdr + 1);
		int iTotalLen = pDataItem->iDataLen;
		pDataItem++;
		bool bMemoryErr = false;
		int iCur = 0;
		int iChild = 0;

		double dProgRate = 0;
		int iTempRate = 0;
		for (int i = 0; i < iTotalLen;)
		{
			dProgRate = 1.0*i / iTotalLen;
			if (iTempRate != (int)(100 * dProgRate))
			{
				WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
				iTempRate = (int)(100 * dProgRate);
			}
			int len = pDataItem->iDataLen;
			i += len + sizeof(tagOApiObjDataItem);
			if (len>0)
			{
				tagOApiObjTree^ pTree = gcnew tagOApiObjTree();
				while (pCurTreeMgr != nullptr)
				{
					if (pCurTreeMgr->nChild>0)
					{
						break;
					}
					else
					{
						pCurObjTree = pCurTreeMgr->treeNode;
						pCurTreeMgr = pCurTreeMgr->pFront;
						pCurTreeMgr->pNext = nullptr;
						
					}
				}
				if (pDataItem->iObjType == OMAP_OBJ_TYPE_GROUP)
				{
					tagOApiObjGroupV2 *pGroup = g_omapApi.GetOmapGroupFromBufV2(pDataItem + 1, len);
					if (pGroup == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					if (pCurTreeMgr)
					{
						pCurTreeMgr->nChild -= pGroup->nChild+1;
					}
					pTree->iObjType = OMAP_OBJ_TYPE_GROUP;
					pTree->pGroup = Dll2CLI(pGroup);
					pTree->pGroup->idObj = pDataItem->idObj;
					pTree->pGroup->idParent = pDataItem->idParent;
					if (pGroup->nChild==0)
					{

					}
					else
					{
						tagOApiTreeMgr^ pMgr = gcnew tagOApiTreeMgr();
						pMgr->nChild = pGroup->nChild;
						pMgr->treeNode = pTree;
						if (pCurTreeMgr==nullptr)
						{
							pCurTreeMgr = pMgr;
						}
						else
						{
							pCurTreeMgr->pNext = pMgr;
							pMgr->pFront = pCurTreeMgr;
							pCurTreeMgr = pCurTreeMgr->pNext;
						}
					}
					g_omapApi.FreeOmapObjectV2(pGroup, OMAP_OBJ_TYPE_GROUP);

				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_SIGN)
				{
					tagOApiMapSignV2* pSign = g_omapApi.GetOmapSignFromBufV2(pDataItem + 1, len);
					if (pSign == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					pTree->iObjType = OMAP_OBJ_TYPE_SIGN;
					pTree->pSign = Dll2CLI(pSign);
					pTree->pSign->idObj = pDataItem->idObj;
					pTree->pSign->idParent = pDataItem->idParent;
					g_omapApi.FreeOmapObjectV2(pSign, OMAP_OBJ_TYPE_SIGN);
					
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_TRACK)
				{
					tagOApiMapTrackV2* pTrack = g_omapApi.GetOmapTrackFromBufV2(pDataItem + 1, len);
					if (pTrack == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					pTree->iObjType = OMAP_OBJ_TYPE_TRACK;
					pTree->pTrack = Dll2CLI(pTrack);
					pTree->pTrack->idObj = pDataItem->idObj;
					pTree->pTrack->idParent = pDataItem->idParent;
					g_omapApi.FreeOmapObjectV2(pTrack, OMAP_OBJ_TYPE_TRACK);
					
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_SHAPE)
				{
					tagOApiMapShapeV2* pShape = g_omapApi.GetOmapShapeFromBufV2(pDataItem + 1, len);
					if (pShape == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					pTree->iObjType = OMAP_OBJ_TYPE_SHAPE;
					pTree->pShape = Dll2CLI(pShape);
					pTree->pShape->idObj = pDataItem->idObj;
					pTree->pShape->idParent = pDataItem->idParent;
					g_omapApi.FreeOmapObjectV2(pShape, OMAP_OBJ_TYPE_SHAPE);
					
				}
				else if (pDataItem->iObjType == OMAP_OBJ_TYPE_DIR)
				{
					tagOApiMapDirectionsV2* pDir = g_omapApi.GetOmapDirFromBufV2(pDataItem + 1, len);
					if (pDir == nullptr)
					{
						bMemoryErr = true;
						break;
					}
					pTree->iObjType = OMAP_OBJ_TYPE_DIR;
					pTree->pDir = Dll2CLI(pDir);
					pTree->pDir->idObj = pDataItem->idObj;
					pTree->pDir->idParent = pDataItem->idParent;
					g_omapApi.FreeOmapObjectV2(pDir, OMAP_OBJ_TYPE_DIR);
					

				}
				if (pTreeParent == nullptr)
				{
					pTreeParent = pTree;
				}
				else if (pCurObjTree&&pCurTreeMgr&&
					pCurObjTree->iObjType == OMAP_OBJ_TYPE_GROUP&&
					pCurObjTree->pChild == nullptr&&pCurTreeMgr->nChild>0)
				{
					pCurObjTree->pChild = pTree;
				}
				else
				{
					pCurObjTree->pNext = pTree;
				}
				if (pCurTreeMgr&&pTree->iObjType != OMAP_OBJ_TYPE_GROUP)
				{
					pCurTreeMgr->nChild--;
				}
				pCurObjTree = pTree;
			}
			if (i < iTotalLen)
			{
				pDataItem = (tagOApiObjDataItem *)((char*)(pDataItem + 1) + len);
			}
		}
		WndCmd(pTreeParent);
		dProgRate = 1;
		WndCmd(dProgRate, eEventHanderType::eDecodeObjTree);
		return bMemoryErr ? false : true;
	}
	int COmapApiCLI::SetSysCoordProj(tagPrj^ prj)
	{
		tagOApiPrj *pPrj = CLI2Dll(prj);
		if (pPrj == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		int iRet = g_omapApi.SetSysCoordProj(pPrj);
		free(pPrj);
		return iRet;
	}
	int COmapApiCLI::GetSysCoordProj()
	{
		return g_omapApi.GetSysCoordProj();
	}

	int COmapApiCLI::MoveOmapObject(int idParent, int nIndexInParent, cli::array<int>^ idList, int nId)
	{
		if (idList == nullptr)
		{
			return OMAP_API_ERR_ARGV;
		}
		//pPics->Count;
		int iSize = idList->Length;
		if (iSize == 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		DWORD *pidList = (DWORD*)zMalloc(sizeof(int)*iSize);
		if (pidList == nullptr || nId <= 0)
		{
			return OMAP_API_ERR_ARGV;
		}
		for (int i = 0; i < iSize; i++)
		{
			pidList[i] = idList[i];
		}

		int iRet = g_omapApi.MoveOmapObject(idParent, nIndexInParent, pidList, nId);

		return iRet;
	}
}
