
#include "WndProcCLI.h"

namespace OmapCLI
{			
	static OmapWndCLI::OmapWndCLI()
	{
		WNDCLASSEX wc;
		OmapCLI::WndProc ^windowProc =
			gcnew OmapCLI::WndProc(OmapWndCLI::WndProc);
		_windowProcHandle = GCHandle::Alloc(windowProc);

		ZeroMemory(&wc, sizeof(WNDCLASSEX));
		wc.cbSize = sizeof(WNDCLASSEX);
		wc.style = CS_DBLCLKS;
		wc.lpfnWndProc = reinterpret_cast<WNDPROC>(Marshal::GetFunctionPointerForDelegate(windowProc).ToPointer());
		wc.hInstance = GetModuleHandle(NULL);
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = (HBRUSH)COLOR_WINDOW; //(HBRUSH)GetStockObject(HOLLOW_BRUSH);
		wc.lpszClassName = CUSTOM_CLASS_NAME;
		ATOM classAtom = RegisterClassEx(&wc);
		DWORD lastError = GetLastError();
		if (classAtom == 0 && lastError != ERROR_CLASS_ALREADY_EXISTS)
		{
			throw gcnew ApplicationException("Register window class failed!");
		}
		System::AppDomain::CurrentDomain->ProcessExit += gcnew System::EventHandler(OmapWndCLI::ProcessExit);
				
	}

	OmapWndCLI::OmapWndCLI() : _caption("Starts2000 Custom ClassName Window")
	{
	}

	OmapWndCLI::OmapWndCLI(String ^caption) : _caption(caption)
	{
	}

	OmapWndCLI::~OmapWndCLI()
	{
		if (_hWnd)
		{
			DestroyWindow(_hWnd);
		}
	}

	void OmapWndCLI::Create()
	{
		DWORD styleEx = 0x00050100;
		DWORD style = 0x17cf0000 & (!WS_VISIBLE);

		pin_ptr<const wchar_t> caption = PtrToStringChars(_caption);

		_hWnd = CreateWindowEx(styleEx, CUSTOM_CLASS_NAME, caption, style,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			NULL, NULL, GetModuleHandle(NULL), NULL);
		if (_hWnd == NULL)
		{
			throw gcnew ApplicationException("Create window failed! Error code:" + GetLastError());
		}
		g_omapApi.Init((WORD*)CUSTOM_CLASS_NAME);
	}
	LRESULT OmapWndCLI::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		System::Windows::Forms::Message message = System::Windows::Forms::Message::Create((IntPtr)hWnd,
			(int)msg, (IntPtr)((void*)wParam), (IntPtr)((void*)lParam));
		System::Diagnostics::Debug::WriteLine(message.ToString());
				
		if (msg == WM_DESTROY)
		{
			PostQuitMessage(0);
			return 0;
		}
		if (msg == g_msgGetMapProcess&&g_msgGetMapProcess != 0)
		{
			g_omapCli->WndCmd(1.0*(int)lParam / (int)wParam, eEventHanderType::eGetMapProcess);
		}
		if (msg == g_msgGetContourProcess&&g_msgGetContourProcess != 0)
		{
			g_omapCli->WndCmd(1.0*(int)lParam / (int)wParam, eEventHanderType::eGetContourProcess);
		}
		if (msg == WM_COPYDATA && wParam == OMAP_WIN_API_FLAG)
		{
			COPYDATASTRUCT* pcd = (COPYDATASTRUCT*)lParam;
			int nAppId = (pcd->dwData >> 16) & 0xffff;
			int nCmdId = pcd->dwData & 0xffff;
			if (nCmdId == OMAP_API_CMD_CLICK_BTN)
			{
				eEventHanderType eType = eEventHanderType::eOmapBtnCliked;
				//g_omapCli->PrintMsgBox("GIS btn is clicked", "ʾ");
				g_omapCli->WndCmd(eType);
				return TRUE;
			}
			if (pcd->cbData == 0 && !(nCmdId == OMAP_API_CMD_CLICK_BTN ||nCmdId == OMAP_API_CMD_GET_WEB_SOCKET_CONF
				||nCmdId == OMAP_API_CMD_GET_CUS_MAP_CFG))//OMAP_API_CMD_CLICK_BTNcbDataΪ0
			{
				//MessageBox(_T("ǰάͼûVIPûִ֧APIӿ"));
				//g_omapCli->PrintMsgBox("ǰάͼûVIPûִ֧APIӿ", "ʾ");
				return TRUE;
			}
			else if (nCmdId == OMAP_API_CMD_GET_OBJ)
			{
				tagOApiObjectOptHdr* pOoh = (tagOApiObjectOptHdr*)pcd->lpData;
				g_omapCli->DecodeOmapSingleObjBuf(pOoh, pcd->cbData - sizeof(tagOApiObjectOptHdr));
			}
			else if (nCmdId == OMAP_WIN_CMD_GET_LATLNG)
			{
				tagOmapLatlng oll;
				memcpy(&oll, pcd->lpData, sizeof(oll));
				tagOmapLatlngCli^ ollCli = g_omapCli->Dll2CLI(&oll);
				g_omapCli->WndCmd(ollCli);
				eEventHanderType eType = eEventHanderType::eBringWindowsToTop;
				g_omapCli->WndCmd(eType);
			}
			
			else if (nCmdId == OMAP_WIN_CMD_TIME_TO_LATLNG)
			{
				tagOPhotoMapPic* pOmp = (tagOPhotoMapPic*)pcd->lpData;
				int nOmp = pcd->cbData / sizeof(tagOPhotoMapPic);
				cli::array<tagOphotoMapPicCli^>^ pOmpCli = g_omapCli->Dll2CLI(pOmp, nOmp);
				g_omapCli->WndCmd(pOmpCli);
			}
			else if (nCmdId == OMAP_WIN_CMD_LATLNG_GEOCODE)
			{
				tagOmapGeoDecode* pgd = (tagOmapGeoDecode*)pcd->lpData;
				tagOmapGeoDecodeCli^ gd = gcnew tagOmapGeoDecodeCli();
				gd->nLevel = pgd->nLevel;
				gd->oll = g_omapCli->Dll2CLI(&(pgd->oll));
				for (int i = 0; i < pgd->nLevel; i++)
				{
					gd->strArea[i] = g_omapCli->cast_strUtf8_to_String(pgd->strArea[i]);
				}
				g_omapCli->WndCmd(gd);
			}
			else if (nCmdId == OMAP_API_CMD_GET_OBJ_LIST || nCmdId == OMAP_API_CMD_GET_SEL_LIST)
			{
				
				BYTE* pData = (BYTE*)pcd->lpData;
				int nList = (pcd->cbData - sizeof(tagOApiObjectOptHdr)) / sizeof(tagOApiItemListV1);
				tagOApiItemListV1* pOlv = (tagOApiItemListV1*)(pData + sizeof(tagOApiObjectOptHdr));
				cli::array<tagOApiItemList^>^ pOlvCli = g_omapCli->Dll2CLI(pOlv, nList);
				g_omapCli->WndCmd(pOlvCli);
			}
			else if (nCmdId == OMAP_WIN_CMD_FOLLW_OBJ_CHG_LIST)
			{
				tagOApiObjChageHdr *pOch = (tagOApiObjChageHdr *)pcd->lpData;
				pOch->pdwList = (DWORD*)(pOch + 1);
				tagOApiObjChageHdrCli^ pOchCli = g_omapCli->Dll2CLI(pOch);
				g_omapCli->WndCmd(pOchCli);
			}
			else if (nCmdId == OMAP_WIN_CMD_GET_MAP_INFO)
			{
				tagWinMapInfo * pWmi = (tagWinMapInfo*)pcd->lpData;
				tagWinMapInfoCli^pWmiCli = g_omapCli->Dll2CLI(pWmi);
				g_omapCli->m_tagSysMsg->ptagWinInfo = g_omapCli->Dll2CLI(pWmi);
				g_omapCli->WndCmd(pWmiCli);
			}
			else if (nCmdId == OMAP_API_CMD_GET_CUS_MAP_CFG)
			{
				int nCm = pcd->cbData/sizeof(tagOApiCustomMap);
				cli::array<tagCustomMap^>^ pCmsCli = g_omapCli->Dll2CLI((tagOApiCustomMap*)pcd->lpData,nCm);
				g_omapCli->WndCmd(pCmsCli);
			}
			else if (nCmdId == OMAP_API_CMD_GET_PLUGIN_VER)
			{
				tagPluginVer^ pVer = nullptr;
				if (pcd->lpData&&pcd->cbData >= sizeof(tagOApiPluginVer))
				{
					pVer = g_omapCli->Dll2CLI((tagOApiPluginVer*)pcd->lpData);
				}
				g_omapCli->WndCmd(pVer);
			}
			else if (nCmdId == OMAP_API_CMD_GET_COOR_PIXEL_INFO)
			{
				int nSize = pcd->cbData / sizeof(tagOApiPixelInfo);
				tagOApiPixelInfo* pOpi = (tagOApiPixelInfo*)pcd->lpData;
				g_omapCli->m_tagSysMsg->dxPixel = gcnew cli::array<double>(nSize);
				g_omapCli->m_tagSysMsg->dyPixel = gcnew cli::array<double>(nSize);
				for (int i = 0; i < nSize;i++)
				{
					g_omapCli->m_tagSysMsg->dxPixel[i] = pOpi[i].dMeterX;
					g_omapCli->m_tagSysMsg->dyPixel[i] = pOpi[i].dMeterY;
				}
				cli::array<tagOApiPixelInfoCli^>^ pOpiCli = g_omapCli->Dll2CLI(pOpi, nSize);
				g_omapCli->WndCmd(pOpiCli);
			}
			else if (nCmdId == OMAP_API_CMD_GET_SYS_COOR_CENTER)
			{
				tagOApiRelatePointV1 *pOrp = (tagOApiRelatePointV1*)pcd->lpData;
				tagOApiRelatePoint^ pOrpCli = g_omapCli->Dll2CLI(pOrp);
				g_omapCli->m_tagSysMsg->dxCoorCenter = pOrp->x;
				g_omapCli->m_tagSysMsg->dyCoorCenter = pOrp->y;
				g_omapCli->WndCmd(pOrpCli);
			}
			else if (nCmdId == OMAP_API_CMD_GET_SYS_COOR_INFO)
			{
				tagOApiSysCoorInfo *pSci = (tagOApiSysCoorInfo *)pcd->lpData;
				pSci->strInfo = (char*)(pSci + 1);
				tagOApiSysCoorInfoCli^ pSciCli = g_omapCli->Dll2CLI(pSci);
				g_omapCli->m_tagSysMsg->iCoorType = pSci->iCoorType;
				g_omapCli->m_tagSysMsg->hashCoor = gcnew cli::array<char>(sizeof(pSci->hash));
				for (int i = 0; i < sizeof(pSci->hash);i++)
				{
					g_omapCli->m_tagSysMsg->hashCoor[i] = pSci->hash[i];
				}
				g_omapCli->WndCmd(pSciCli);
			}
			else if (nCmdId == OMAP_API_CMD_GET_SHAPE_FILL_PAT_LIST)
			{
				g_omapCli->DeocdeShapeFillPatList(pcd->lpData, pcd->cbData);
			}
			else if (nCmdId == OMAP_API_CMD_GET_SEL_OBJ_TREE)
			{
				tagOApiObjectOptHdr *pOptHdr = (tagOApiObjectOptHdr*)pcd->lpData;
				g_omapCli->DecodeOmapObjBuf(pOptHdr);
				//g_omapCli->DecodeOmapObjBuf2TreeStruct(pOptHdr);
			}
			else if (nCmdId == OMAP_API_CMD_SET_OBJ_TREE)
			{
				int nData = pcd->cbData/sizeof(tagOApiObjDataItem);
				g_omapCli->SetObjTree((tagOApiObjDataItem*)pcd->lpData,nData);
			}
			else if (nCmdId == OMAP_API_CMD_SRH_OBJ_EXT)
			{
				if (pcd->cbData >= sizeof(tagOApiObjectSrhReq))
				{
					int nRes = (pcd->cbData - sizeof(tagOApiObjectSrhReq)) / sizeof(tagOApiObjectSrhRes);
					tagOApiObjectSrhReq *ptagReq = (tagOApiObjectSrhReq*)pcd->lpData;
					tagOApiObjectSrhRes *pRes =NULL;
					if(nRes>0)
						pRes = (tagOApiObjectSrhRes*)(ptagReq + 1);
					g_omapCli->DecodeObjSrhRes(pRes, nRes);
				}
			}
			else if (nCmdId == OMAP_API_CMD_GET_MAP_DATA)
			{
				if (pcd->cbData==0)
				{
					return TRUE;
				}
				tagOApiObjectOptHdr* pOoh = (tagOApiObjectOptHdr*)pcd->lpData;
				tagOmapGetMap *pGet = (tagOmapGetMap*)(pOoh + 1);
				BYTE *pDataImg = (BYTE *)(pGet + 1);
				int nDataIng = (pcd->cbData - sizeof(tagOApiObjectOptHdr)-sizeof(tagOmapGetMap));
				g_omapCli->DecodeMapData(pGet, pDataImg, nDataIng);
			}
			else if (nCmdId == OMAP_API_CMD_GET_MAP_FILE)
			{
				if (pcd->cbData < sizeof(tagOmapGetMapFile) )
				{
					return true;
				}
				tagOmapGetMapFile *p = (tagOmapGetMapFile*)pcd->lpData;
				g_omapCli->DecodeMapFile(p);

			}
			else if (OMAP_API_CMD_GET_CONTOUR == nCmdId)
			{
				if (pcd->cbData <= 0)
				{
					return TRUE;
				}
				tagOmapReqContour *p = (tagOmapReqContour*)pcd->lpData;
				g_omapCli->DecodeContour(p);

			}
			else if (OMAP_API_CMD_GET_WEB_SOCKET_CONF == nCmdId)
			{
				if (pcd->cbData == sizeof(tagOApiWebSocketConf))
				{
					tagOApiWebSocketConf *pWebSocketConf = (tagOApiWebSocketConf*)pcd->lpData;
					tagWebSocketConf^ wsc = g_omapCli->Dll2CLI(pWebSocketConf);
					g_omapCli->WndCmd(wsc);
				}
			}
			else if (OMAP_API_CMD_SET_BTN == nCmdId)
			{
				//g_omapCli->PrintMsgBox("GIS btn is Setted", "ʾ");
				if (pcd->cbData < sizeof(int))
					return TRUE;
				int iBtnStatus = 0;
				memcpy(&iBtnStatus, pcd->lpData, sizeof(int));
				g_omapCli->WndCmd(iBtnStatus);
			}
			else if (OMAP_API_CMD_GET_COORD_PROJ == nCmdId)
			{
				tagOApiPrj *pPrj = nullptr;
				if (pcd->cbData == sizeof(tagOApiPrj))
				{
					pPrj = (tagOApiPrj*)pcd->lpData;
				}
				tagPrj^ prj = g_omapCli->Dll2CLI(pPrj);
				g_omapCli->WndCmd(prj);
			}
			else if (OMAP_API_CMD_GET_OMAP_WND_RECT == nCmdId)
			{
				tagOApiOmapWndRect *pOmapWndRect = nullptr;
				if (pcd->cbData == sizeof(tagOApiOmapWndRect))
				{
					pOmapWndRect = (tagOApiOmapWndRect*)pcd->lpData;
				}
				tagOmapWndRect^ omapWndRect = g_omapCli->Dll2CLI(pOmapWndRect);
				g_omapCli->WndCmd(omapWndRect);
			}
			else if (nCmdId == OMAP_API_CMD_CUS_WND_SET || nCmdId == OMAP_API_CMD_CUS_WND_QUERY || nCmdId == OMAP_API_CMD_CUS_WND_DEL)
			{
				
				int iShowCusWndRet = 0;
				memcpy(&iShowCusWndRet, pcd->lpData, sizeof(int));
				
				g_omapCli->WndCmd(iShowCusWndRet, nCmdId);
			}
			else if (nCmdId == OMAP_API_CMD_CUS_WND_CLOSE_EVENT)
			{
				if (pcd->cbData < sizeof(int))
				{
					return TRUE;
				}
				int idWnd = 0;
				int *id = (int*)((char*)pcd->lpData);
				memcpy(&idWnd, id, sizeof(int));
				g_omapCli->WndCmd(idWnd, eEventHanderType::eGetCmdCusCloseWnd);
			}
			else if (OMAP_API_CMD_GET_SHAPE_DETAIL == nCmdId)
			{
				tagOApiMapShapeDetail *pShapeDetail = nullptr;
				if (pcd->cbData == sizeof(tagOApiRevHdr) + sizeof(tagOApiMapShapeDetail))
				{
					pShapeDetail = (tagOApiMapShapeDetail*)((char*)pcd->lpData + sizeof(tagOApiRevHdr));
				}
				tagMapShapeDetail^ pMapShapeDetail = g_omapCli->Dll2CLI(pShapeDetail);
				g_omapCli->WndCmd(pMapShapeDetail);
			}
			else if (OMAP_API_CMD_GET_TRACK_DETAIL == nCmdId)
			{
				tagOApiMapTrackDetail *pTrackDetail = nullptr;
				if (pcd->cbData == sizeof(tagOApiRevHdr) + sizeof(tagOApiMapTrackDetail))
				{
					pTrackDetail = (tagOApiMapTrackDetail*)((char*)pcd->lpData + sizeof(tagOApiRevHdr));
				}
				tagMapTrackDetail^ pMapTrackDetail = g_omapCli->Dll2CLI(pTrackDetail);
				g_omapCli->WndCmd(pMapTrackDetail);
			}
			else if (nCmdId == OMAP_API_CMD_CUS_MAIN_BTN_SET || nCmdId == OMAP_API_CMD_CUS_MAIN_BTN_QUERY ||
			nCmdId == OMAP_API_CMD_CUS_MAIN_BTN_DEL || nCmdId == OMAP_API_CMD_CUS_MAIN_BTN_CLICK)
			{
				int nData = pcd->cbData;
				tagCusMainBtn *pCmb = (tagCusMainBtn *)((char*)(pcd->lpData) + sizeof(tagOApiRevHdr));
				int nCmb = (pcd->cbData - sizeof(tagOApiRevHdr)) / sizeof(tagCusMainBtn);
				cli::array<tagCusMainBtnCli^>^ pCusMainBtn = g_omapCli->Dll2CLI(pCmb, nCmb);
				g_omapCli->WndCmd(pCusMainBtn,nCmdId);
			}
			else if (nCmdId == OMAP_API_CMD_CUS_FAV_MENU_SET || nCmdId == OMAP_API_CMD_CUS_FAV_MENU_QUERY ||
				nCmdId == OMAP_API_CMD_CUS_FAV_MENU_DEL || nCmdId == OMAP_API_CMD_CUS_FAV_MENU_CLICK)
			{
				tagCusFavMenu *pCfm = (tagCusFavMenu *)((char*)(pcd->lpData) + sizeof(tagOApiRevHdr));
				int nData = pcd->cbData - sizeof(tagOApiRevHdr);
				cli::array<tagCusFavMenuCli^>^ pCusFavMenu = g_omapCli->Dll2CLI(pCfm, nData);
				g_omapCli->WndCmd(pCusFavMenu, nCmdId);
			}
			else if (nCmdId == OMAP_API_CMD_OBJ_EVENT_SET || nCmdId == OMAP_API_CMD_OBJ_EVENT_QUERY)
			{
				int iEvent = 0;
				memcpy(&iEvent, pcd->lpData, sizeof(int));
				g_omapCli->WndCmd(iEvent,nCmdId);
				
			}
			else if (nCmdId == OMAP_API_CMD_CUS_MAIN_MENU_SET)
			{
				int nData = pcd->cbData;
			}
			else if (nCmdId == OMAP_API_CMD_OBJ_EVENT_TIRGGER)
			{
				if (pcd->cbData != sizeof(tagOApiMapObjEvent))
				{
					return TRUE;
				}
				tagOApiMapObjEvent* pOmb = (tagOApiMapObjEvent*)pcd->lpData;
				tagMapObjEvent^ pMapObjEvent = g_omapCli->Dll2CLI(pOmb);
				g_omapCli->WndCmd(pMapObjEvent);
			
			}
			else if (nCmdId == OMAP_API_CMD_OBJ_CLOSE_WND_EVENT)
			{
				if (pcd->cbData < sizeof(tagOApiRevHdr))
				{
					return TRUE;
				}
				int *idObj = (int*)((char*)pcd->lpData + sizeof(tagOApiRevHdr));
				int id = 0;
				memcpy(&id, idObj, sizeof(int));
				g_omapCli->WndCmd(id, eEventHanderType::eObjCloseWndEvent);
			}
			else if (nCmdId == OMAP_API_CMD_CUS_MAIN_MENU_CLICK)
			{
				if (pcd->cbData < sizeof(tagOApiRevHdr))
				{
					return TRUE;
				}
				int nMenu = (pcd->cbData - sizeof(tagOApiRevHdr)) / sizeof(tagCusMainMenu);
				tagCusMainMenu *pMenu = (tagCusMainMenu*)((char*)pcd->lpData + sizeof(tagOApiRevHdr));
				tagCusMainMenuCli^ pCusMainMenu = g_omapCli->Dll2CLI(pMenu);
				g_omapCli->WndCmd(pCusMainMenu);
			}
		}
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	void OmapWndCLI::ProcessExit(Object^ sender, EventArgs^ e)
	{
		UnregisterClass(CUSTOM_CLASS_NAME, GetModuleHandle(NULL));
		if (OmapWndCLI::_windowProcHandle.IsAllocated)
		{
			OmapWndCLI::_windowProcHandle.Free();
		}
	}

}
