﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace OmapInterface_CSharp
{
    public partial class Form1 : Form
    {
        [DllImport("user32.dll", EntryPoint = "ShowWindow", CharSet = CharSet.Auto)]
        public static extern int ShowWindow(IntPtr hwnd, int nCmdShow);
        public const int SW_HIDE = 0;
        public const int SW_SHOW = 5;
        public const int SW_SHOWNORMAL = 1;
        IntPtr m_ParentHwnd;
        public struct Rect
        {
            public int Left;
            public int Top;
            public int Right;
            public int Bottom;
        }
        [DllImport("User32.dll", EntryPoint = "FindWindow")]
        private static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
        [DllImport("user32.dll")]
        private static extern bool SetForegroundWindow(IntPtr hWnd);
        [DllImport("user32.dll")]
        private static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);
        [DllImport("user32.dll")]
        private static extern bool IsIconic(IntPtr hWnd);
        private const int SW_RESTORE = 9;
        [DllImport("user32.dll", EntryPoint = "SetParent")]
        public static extern int SetParent(IntPtr hWndChild, IntPtr hWndNewParent);
        [DllImport("user32.dll")]
        private static extern int GetWindowRect(IntPtr hwnd, out  Rect lpRect);
        [DllImport("user32.dll")]
        private static extern bool SetWindowPos(IntPtr hWnd, IntPtr hWndlnsertAfter, int X, int Y, int cx, int cy, uint Flags);
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern int MoveWindow(IntPtr hWnd, int x, int y, int nWidth, int nHeight, bool BRePaint);
        public Form1(IntPtr hwnd)
        {
            m_ParentHwnd = hwnd;
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            IntPtr hwnd = FindWindow("omapWin", null);
            SetParent(this.Handle, hwnd);
            Rect rect = new Rect();
            GetWindowRect(this.Handle, out rect);
            //SetWindowPos(this.Handle, (IntPtr)(-2), 900, 23, 0, 0, 3);
            MoveWindow(this.Handle, 1110, 26, 175, 20, true);
            ShowWindow(m_ParentHwnd, SW_HIDE);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OmapOperation.SetOmapTmpSign(40.123,112.22);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ShowWindow(m_ParentHwnd, SW_SHOW);
            Close();
        }
    }
}
