﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using OmapCLI;
namespace OmapInterface_CSharp
{
    public partial class OmapApiTest : Form
    {
        
        public static bool IsNumeric(string value)
        {
            return Regex.IsMatch(value, @"^[+-]?\d*[.]?\d*$");
        }
        //static public OmapApiCLI g_omapApi = new OmapApiCLI();
        public OmapApiTest()
        {
            InitializeComponent();
        }
        private void OmapApiTest_Load(object sender, EventArgs e)
        {
            OmapOperation.SetParentHandle(this.Handle);
        }
        
        private void IDC_BTN_SET_LATLNG_Click(object sender, EventArgs e)
        {
            OmapOperation.SetOmapTmpSign(40.12346, 116.23456);
            
        }

        private void IDC_BTN_SET_MAP_STA_Click(object sender, EventArgs e)
        {
            OmapOperation.SetOmapLevelAndLocationExt(101, 16, 116.23456, 40.12346, 0, 0);
        }

        private void IDC_BTN_GET_LATLNG_Click(object sender, EventArgs e)
        {
            OmapOperation.GetLatlng();
        }

        private void IDC_BTN_SET_PHOTOLIST_Click(object sender, EventArgs e)
        {
            //System.Diagnostics.Stopwatch stopwatch = new System.Diagnostics.Stopwatch();
            //stopwatch.Start(); //  开始监视代码
            tagOphotoMapPicCli[] pOm = new tagOphotoMapPicCli[10000];
            for(int i = 0;i<10000;i++)
            {
                pOm[i] = new tagOphotoMapPicCli();
                pOm[i].idPic = i + 10000;
                pOm[i].lat = 40.123456 + 0.001 * i;
                pOm[i].lng = 116.123456 + 0.001 * i;
            }
            OmapOperation.SetPicSignList(pOm);
            //stopwatch.Stop(); //  停止监视
            //TimeSpan timeSpan = stopwatch.Elapsed; //  获取总时间
            //double milliseconds = timeSpan.TotalMilliseconds;  //  毫秒数
            //int f = 0;
        }

        private void IDC_BTN_LATLNG_DECODE_Click(object sender, EventArgs e)
        {
            double lng = 0, lat = 0;
            string ss = m_edit_Latlng.Text;
            string[] s = ss.Split(',');
            if (s.Length != 2 || !IsNumeric(s[0]) || !IsNumeric(s[1]))
            {
                MessageBox.Show("经纬度格式错误!");
                lat = 40.12345;
                lng = 116.22334;
            }
            else
            {
                lat = double.Parse(s[0]);
                lng = double.Parse(s[1]);

            }
            OmapOperation.GeoDecodeLatlng(lat, lng);
        }

        private void IDC_BTN_GET_LATLNG_BY_TIME_Click(object sender, EventArgs e)
        {
            tagOphotoMapPicCli[] omp = new tagOphotoMapPicCli[100];
            for (int i = 0; i < 100; i++)
            {
                omp[i] = new tagOphotoMapPicCli();
                omp[i].tmPhoto = (uint)(DateTime.Now.Subtract(DateTime.Parse("1970-1-1")).TotalMilliseconds - 86400 + i * 60);

            }
            OmapOperation.GetLatlngByTime(omp);
        }

        private void IDC_BTN_GET_OBJ_LIST_Click(object sender, EventArgs e)
        {
            uint idParent = 0;
            int nSelect = m_list_Result.SelectedItems.Count;

            if (nSelect > 0)
            {
                string strType = m_list_Result.SelectedItems[0].Text;
                if (strType == "文件夹")
                {

                    idParent = (uint)m_list_Result.SelectedItems[0].Tag;
                }

            }
            OmapOperation.GetObjList(idParent);
        }

        private void IDC_BTN_GET_OBJ_Click(object sender, EventArgs e)
        {
            int nSelect = m_list_Result.SelectedItems.Count;
            if (nSelect <= 0)
            {
                MessageBox.Show("请选择对象");
                return;
            }
            uint idObj = (uint)m_list_Result.SelectedItems[0].Tag;
            OmapOperation.GetObj(idObj);
        }
        
        private void SetObjToOmap(uint idParent)
        {
            long iRet = 0;
            tagOApiObjGroup pGroup = new tagOApiObjGroup();
            pGroup.strName = "我的文件夹";
            iRet = OmapOperation.SetOmapObject(0, pGroup);
            if(iRet<0)
            {
                return;
            }
            tagOApiMapSign pSign = new tagOApiMapSign();
            pSign.strName = "我的标签";
            pSign.pstrComment = "标签备注信息";
            pSign.lat = 40.1111;
            pSign.lng = 116.2222;
            pSign.pic.iSignPic = 1;
            pSign.iTxtType = 1;
            iRet = OmapOperation.SetOmapObject(0, pSign);
            if (iRet < 0)
            {
                return;
            }
            tagOApiMapTrack pTrack = new tagOApiMapTrack();
            pTrack.strName = "我的轨迹";
            pTrack.pstrComment = "轨迹备注信息";
            pTrack.mtd.dwLineClr = OmapOperation.RGB(0, 244, 244);
            pTrack.nMtp = 100;
            pTrack.pMtp = new tagOApiMapTrackPoint[pTrack.nMtp];
            for (int i = 0; i < pTrack.nMtp;i++ )
            {
                pTrack.pMtp[i] = new tagOApiMapTrackPoint();
                pTrack.pMtp[i].lat = 40.1122 + i * 0.001;
                pTrack.pMtp[i].lng = 116.2223 + i * (i * 0.1) * 0.002;
            }
            iRet = OmapOperation.SetOmapObject(0, pTrack);
            if (iRet < 0)
            {
                return;
            }
            tagOApiMapShape pShape = new tagOApiMapShape();
            pShape.strName = "我的图形";
            pShape.pstrComment = "图形备注信息";
            pShape.nMtp = 10;
            pShape.pMtp = new tagOApiMapTrackPoint[pShape.nMtp];
            for (int i = 0; i < pShape.nMtp; i++)
            {
                pShape.pMtp[i] = new tagOApiMapTrackPoint();
                pShape.pMtp[i].lat = 40.1122 + i * 0.001;
                pShape.pMtp[i].lng = 116.2223 + i * (i * 0.1) * 0.002;
            }
            iRet = OmapOperation.SetOmapObject(0, pShape);
            if (iRet < 0)
            {
                return;
            }
            tagOApiMapDirections pDir = new tagOApiMapDirections();
            pDir.strName = "我的路线";
            pDir.pstrComment = "路线备注信息";
            pDir.strTitle = "Test dir";
            pDir.nUnit = 10;
            pDir.dirSrh.iDirMode = 0;
            pDir.dirSrh.mpStart.lat = 40.099;
            pDir.dirSrh.mpStart.lng = 116.099;
            pDir.punit = new tagOApiMapDirectionsUnit[pDir.nUnit];
            double lat = 40.1;
            double lng = 116.1;
            for (int i = 0; i < pDir.nUnit; i++)
            {
                pDir.punit[i] = new tagOApiMapDirectionsUnit();
                pDir.punit[i].strTitle = String.Format("step{0}", i + 1);
                if (i == 0)
                {
                    pDir.punit[i] = new tagOApiMapDirectionsUnit();
                    pDir.punit[i].strSubTitle = new String[8];
                   pDir.punit[i].strSubTitle[0] = "substep1";
                   pDir.punit[i].strSubTitle[1] =  "substep2";
                   pDir.punit[i].nSubCount = 2;
                }
                pDir.punit[i].nLl = 20;
                pDir.punit[i].llList = new tagOApiLatLng[pDir.punit[i].nLl];
                int a = new Random().Next(1, 11);
                int b = new Random().Next(1, 11);
                for (int j = 0; j < pDir.punit[i].nLl; j++)
                {
                    pDir.punit[i].llList[j] = new tagOApiLatLng();
                    if (j > 0)
                    {
                        lat += a / 1000.0;
                        lng += b / 1000.0;
                    }
                    pDir.punit[i].llList[j].lat = lat;
                    pDir.punit[i].llList[j].lng = lng;
                }
            }
            pDir.dirSrh.mpEnd.lat = lat + 0.001;
            pDir.dirSrh.mpEnd.lng = lng + 0.001;
            iRet = OmapOperation.SetOmapObject(0, pDir);
            if (iRet < 0)
            {
                return;
            }
        }
        private void IDC_BTN_SET_OBJ_Click(object sender, EventArgs e)
        {
            uint idParent = 0;
            int nSelect = m_list_Result.SelectedItems.Count;

            if (nSelect > 0)
            {
                string strType = m_list_Result.SelectedItems[0].Text;
                if (strType == "文件夹")
                {
                    idParent = (uint)m_list_Result.SelectedItems[0].Tag;
                }
            }
            SetObjToOmap(idParent);
        }

        private void IDC_BTN_DEL_OBJ_Click(object sender, EventArgs e)
        {
            int nSelect = m_list_Result.SelectedItems.Count;
            if (nSelect == 0)
            {
                MessageBox.Show("请选择要删除的对象");
                return;
            }
            if (MessageBox.Show("您确定要删除所选定的对象吗？", "提示窗", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk) == DialogResult.No)
            {
                return;
            }
            uint[] pIds = new uint[nSelect];
            for (int i = 0; i < nSelect; i++)
                pIds[i] = (uint)m_list_Result.SelectedItems[i].Tag;
            int iRet = OmapOperation.DelOmapObject(pIds, nSelect);
            if (iRet == 0)
            {
                for (int i = nSelect - 1; i >= 0; i--)
                {
                    ListViewItem item = m_list_Result.SelectedItems[i];
                    m_list_Result.Items.Remove(item);
                }
            }
        }

        private void IDC_BTN_SET_TMP_OBJ_Click(object sender, EventArgs e)
        {
            SetObjToOmap(OmapDef.OMAP_TMP_OBJ_GROUP_ID);
        }

        private void IDC_BTN_CLEAN_TMP_OBJ_Click(object sender, EventArgs e)
        {
            OmapOperation.CleanOmapTmpObject();
        }

        private void IDC_BTN_GET_OMAP_VER_Click(object sender, EventArgs e)
        {
            String strAppPath = "";
            int iOmapVer = 0;
            if(!OmapOperation.GetOmapVersion(ref iOmapVer, ref strAppPath))
            {
                return;
            }
            StringBuilder sbInfo = new StringBuilder();
            sbInfo.AppendFormat("版本号:{0}.{1}.{2}\n路径:{3}", iOmapVer / 100, iOmapVer % 100 / 10, iOmapVer % 10, strAppPath);
            MessageBox.Show(sbInfo.ToString());
        }

        private void IDC_BTN_SHOW_TOOLBOX_Click(object sender, EventArgs e)
        {
            Form1 fm = new Form1(this.Handle);
            fm.Show();
            //this.Show();
            //ShowWindow(this.Handle, 0);
        }

        private void Btn_Test_Click(object sender, EventArgs e)
        {
            if(false)
            {
                //获取等高线
                tagOmapReqContourCli tag = new tagOmapReqContourCli();
                tag.idMap = 1;
                tag.bRealLl = 2;
                tag.iCheckFlag = 1;
                tag.iElevValue = 10;
                tag.iMapLevel = 12;
                tag.iPostCnt = 1;
                tag.iValue = 1;
                tag.x_lng1 = 527661.11;
                tag.y_lat1 = 3442806.11;
                tag.x_lng2 = 596263.67;
                tag.y_lat2 = 3498498.51;
                OmapOperation.GetOmapContour(tag);
            }
            if(false)
            {
                //查询奥维对象
                tagOApiObjectSrhReqCli tag = new tagOApiObjectSrhReqCli();
                tag.strSrhTxt = "Add";
                OmapOperation.SrhOmapObject(tag);

            }
            if(false)
            {
                //获取图形填充图案
                uint id = OmapOperation.GetPatItemId("ANSI33");
                string str = OmapOperation.GetPatItem(id);
                tagOApiShapeFillCadPatItemCli p =  OmapOperation.GetPatItemDef(id);
                int f = 0;
            }
            if(false)
            {
                //tagOmapReqContourCli pReq;
               // OmapOperation.GetOmapSelectList(OmapDef.OBJ_SELECT_CHECK_FLAG_GROUP_JOIN);
            }
            if(false)
            {
                //获取奥维地图图片文件
                tagOmapGetMapFileCli[] pMapFiles = new tagOmapGetMapFileCli[1];
                pMapFiles[0] = new tagOmapGetMapFileCli();
                pMapFiles[0].iMapType = 6;
                pMapFiles[0].x_lng1 = 606461.94;
                pMapFiles[0].y_lat1 = 4442518.53;
                pMapFiles[0].x_lng2 = 607461.94;
                pMapFiles[0].y_lat2 = 4443518.53;
                pMapFiles[0].bRealLl = 2;
                pMapFiles[0].width = 550;
                pMapFiles[0].height = 550;
                pMapFiles[0].iFlag = 1;
                pMapFiles[0].iMapLevel = 16;
                pMapFiles[0].bSendReq = 1;
                pMapFiles[0].iValue = 1;
                pMapFiles[0].idMap = 1;
                pMapFiles[0].strFile = "D:\\tmp\\img\\mapfile.png";
                OmapOperation.GetOmapMapFile(pMapFiles);
            }
            if(false)
            {
                //获取奥维地图图片数据
                tagOmapGetMapCli tag = new tagOmapGetMapCli();
                tag.x_lng1 = 606461.94;
                tag.y_lat1 = 4442518.53;
                tag.x_lng2 = 607461.94;
                tag.y_lat2 = 4443518.53;
                tag.bRealLl = 2;
                tag.iMaxLevel = 16;
                tag.iMaxPixel = 100000000;
                OmapOperation.GetOmapMapData(tag.x_lng1, tag.y_lat1, tag.x_lng2, tag.y_lat2, tag.iMaxPixel, tag.iMaxLevel);
            }
            if(false)
            {
                //获取奥维收藏夹选中对象
                OmapOperation.GetOmapSelectList();
            }
            if(true)
            {
                //设置工具栏小按钮
                OmapOperation.SetOmapButton(1, "C# 测试");
                //OmapOperation.SetOmapButton(2, "C++ 测试");
            }
            if(false)
            {
                //设置关联点
                tagOApiRelatePoint pPoint = new tagOApiRelatePoint();
                pPoint.bReal = 1;
                pPoint.lng = 112.125;
                pPoint.lat = 25.254;
                pPoint.x = 700000;
                pPoint.y = 2770000;
                OmapOperation.SetSysCoorPoint(3, pPoint);
            }
            if(false)
            {
                //获取关联点
                OmapOperation.GetSysCoorInfo();
            }
           if(false)
           {
                //获取关联点坐标系屏幕中心点
               OmapOperation.GetSysCoorCenter();
           }
            if(false)
            {
                //平面坐标系下使用
                //获取谷歌28级地图下像素比例
                OmapOperation.GetCoorPixelInfo(700000, 2700000);
            }
            if(false)
            {//定时获取Omap地图的相关信息
                OmapOperation.FollowWinMapInfo(1000);
               // OmapOperation.FollowWinMapInfo(1);调用此函数后停止此功能
            }
            if (false)
            {//获取Omap当前信息
                OmapOperation.GetWinMapInfo(0);
            }
            if(false)
            {//测试检测对象变化
                OmapOperation.FollowObjChange(OmapDef.OAPI_APP_ID_QUERY);
            }
        }

        private void BTN_TEST_B_Click(object sender, EventArgs e)
        {
            OmapOperation.CommitObjTree();
        }

        private void OmapApiTest_FormClosing(object sender, FormClosingEventArgs e)
        {
            OmapOperation.ReleaseRes();
        }

        private void IDC_BTN_GETSHAPEDETAIL_Click(object sender, EventArgs e)
        {
            int nSelect = m_list_Result.SelectedItems.Count;
            if (nSelect <= 0)
            {
                MessageBox.Show("请选择对象");
                return;
            }
            String strType = m_list_Result.SelectedItems[0].Text;
            if(strType != "图形")
            {
                MessageBox.Show("请选择图形");
                return;
            }
            uint idObj = (uint)m_list_Result.SelectedItems[0].Tag;
            OmapOperation.GetMapShapeDetail(idObj);
        }

        private void IDC_BTN_GET_OMAP_WND_RECT_Click(object sender, EventArgs e)
        {
            OmapOperation.GetOmapWndRect();
        }

        private void IDC_BTN_GETTRACKDETAIL_Click(object sender, EventArgs e)
        {
            int nSelect = m_list_Result.SelectedItems.Count;
            if (nSelect <= 0)
            {
                MessageBox.Show("请选择对象");
                return;
            }
            String strType = m_list_Result.SelectedItems[0].Text;
            if (strType != "轨迹")
            {
                MessageBox.Show("请选择轨迹");
                return;
            }
            uint idObj = (uint)m_list_Result.SelectedItems[0].Tag;
            OmapOperation.GetMapTrackDetail(idObj);
        }

        private void IDC_BTN_SET_CMD_CUS_WND_Click(object sender, EventArgs e)
        {
            String strDlgTitle = "自定义弹窗名称";
            int WndId = 1;   //窗口id ，取值范围1-10
            byte bCloseEvent = 1;
            int left = 350;
            int right = 750;
            int top = 200;
            int bottom = 800;
            string strHtml = "<?ovital_ct name=\"ovital_sample\">{\"user\": \"Andy\",\"birthday\" : \"\",\"sex\" : \"man\",\"Marital_status\" : false,\"work_address\" : \"0\"}";
            SetCmdCusWnd(WndId, bCloseEvent, strDlgTitle, strHtml, left, right, top, bottom);


        }
        public void SetCmdCusWnd(int WndId, byte bCloseEvent, String strWndTitle, String strHtml, int left, int right, int top, int bottom)
        {
            tagCusShowWnd cusShowWnd = new tagCusShowWnd();
            cusShowWnd.rectWnd = new tagRECTCli();
            cusShowWnd.idWnd = WndId;
            cusShowWnd.bCloseEvent = bCloseEvent;
            cusShowWnd.rectWnd.left = left;
            cusShowWnd.rectWnd.right = right;
            cusShowWnd.rectWnd.top = top;
            cusShowWnd.rectWnd.bottom = bottom;

            cusShowWnd.strDlgTitle = strWndTitle;
            cusShowWnd.pHtml = strHtml;
            cusShowWnd.nHtml = strHtml.Length;

            OmapOperation.SetCmdCusWnd(cusShowWnd);
        }


        private void IDC_BTN_SET_CUS_MAIN_BTN_Click(object sender, EventArgs e)
        {
            //id取值范围1-10,重复则覆盖
            int size = 2;

            OmapOperation.SetCusMainBtn(size);
        }

        private void IDC_BTN_DEL_CUS_MAIN_BTN_Click(object sender, EventArgs e)
        {
            int []ids = { 1, 2 };
            
            OmapOperation.DelCusMainBtn(ids, 2);
        }

        private void IDC_BTN_QUERY_CUS_MAIN_BTN_Click(object sender, EventArgs e)
        {
            int []ids= { 1, 2 };
            OmapOperation.QueryCusMainBtn(ids, 2);
        }

        private void IDC_BTN_SET_CUS_FAV_MENU_Click(object sender, EventArgs e)
        {
            //id取值范围1-10,重复则覆盖
            int size = 2;
            OmapOperation.SetCusFavMenu(size);
        }

        private void IDC_BTN_DEL_CUS_FAV_MENU_Click(object sender, EventArgs e)
        {
            int[] ids = { 1, 2 };
            OmapOperation.DelCusFavMenu(ids, 2);
        }

        private void IDC_BTN_QUERY_CUS_FAV_MENU_Click(object sender, EventArgs e)
        {
            int[] ids = { 1, 2 };
            OmapOperation.QueryCusFavMenu(ids, 2);
        }

        private void IDC_BTN_SET_OBJ_EVENT_Click(object sender, EventArgs e)
        {
            OmapOperation.SetObjEvent();
        }

        private void IDC_BTN_SET_CUSMAINMENU_Click(object sender, EventArgs e)
        {
            OmapOperation.SetCumMainMenu();
        }

        private void IDC_BTN_DEL_CUSMAINMENU2_Click(object sender, EventArgs e)
        {
            OmapOperation.DelCusMainMenu();
        }

        private void IDC_BTN_SET_COORD_PROJ_Click(object sender, EventArgs e)
        {
            //CoordType 2 经纬度(如果要设置经纬度坐标，不需要其他参数)；4 横轴墨卡托
            //iPrjType enum eWGS_1984=0,eXian_1980=1,eKrasovsky_1940=2,eUTM=3, eCGCS2000=4,eCustomType=5
            tagPrj tagPrj = new tagPrj();
            tagPrj.iCoordType = 4;
            tagPrj.iPrjType = 2;
            tagPrj.dFalseEasting = 500000;
            tagPrj.dFalseNorthing = 0;
            tagPrj.dScaleFactor = 1;
            tagPrj.dCentralMeridian = 105;
            tagPrj.dAngularUnit = 0.5;
            tagPrj.dLinearUnit = 1.0;
            tagPrj.dSemimajorAxis = 6378245.0;
            tagPrj.dInverseFlattening = 298.3;
            OmapOperation.SetSysCoordProj(tagPrj);
        }

        private void IDC_BTN_GET_COORD_PROJ_Click(object sender, EventArgs e)
        {
            OmapOperation.GetSysCoordProj();
        }

        private void IDC_BTN_GET_CUS_MAP_CFG_Click(object sender, EventArgs e)
        {
            OmapOperation.GetCusMapCfgList();
        }

        private void IDC_BTN_GET_WEB_SOCKET_CONF_Click(object sender, EventArgs e)
        {
            OmapOperation.GetWebSocketConf();
        }

        private void IDC_BTN_QUERY_CMD_CUS_WND_Click(object sender, EventArgs e)
        {
            int WndID = 1; //窗口id ，取值范围1 - 10
            OmapOperation.QueryCusShowWnd(WndID);
        }

        private void IDC_BTN_DEL_CMD_CUS_WND_Click(object sender, EventArgs e)
        {
            int WndID = 1; //窗口id ，取值范围1 - 10
            OmapOperation.DelCusShowWnd(WndID);
        }

        private void IDC_BTN_CMD_MOVE_OBJ_Click(object sender, EventArgs e)
        {
            int idParent = 738224536;
            int nIndexInParent = 0;
            int[] idList = { 1633817490, 1606192095, 746456053, 2140764178, 1270509728, 691868557, 28138214 };
            int nId = idList.Length;
            OmapOperation.MoveOmapObject(idParent, nIndexInParent, idList, nId);
        }
    }
}
