﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OmapCLI;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Runtime.InteropServices;
using System.Diagnostics;



namespace OmapInterface_CSharp
{
    #region OMAPAPI_DEF
    public class OmapDef
    {
        public const int OMAP_WIN_API_VERSION = 101;
        public const int OMAP_WIN_API_FLAG = 1001;

        public const int OMAP_WIN_CMD_REGISTER = 20000;
        public const int OMAP_WIN_CMD_GET_LATLNG = 20001;
        public const int OMAP_WIN_CMD_SET_LATLNG = 20002;
        public const int OMAP_WIN_CMD_LATLNG_GEOCODE = 20003;
        public const int OMAP_WIN_CMD_SHOW_PIC = 20004;
        public const int OMAP_WIN_CMD_TIME_TO_LATLNG = 20005;
        public const int OMAP_WIN_CMD_GET_VERSION = 20006;
        public const int OMAP_WIN_CMD_SET_MAP_LOCATION = 20007;
        public const int OMAP_WIN_CMD_CLOSE = 20008;
        public const int OMAP_WIN_CMD_SAVE_CFG = 20009;
        public const int OMAP_WIN_CMD_CLEAN_TMP_OBJ = 20010;
        public const int OMAP_WIN_CMD_SET_MAP_LOCATION_EXT = 20011;
        public const int OMAP_WIN_CMD_GET_MAP_INFO = 20012;
        public const int OMAP_WIN_CMD_FOLLW_MAP_INFO = 20013;
        public const int OMAP_WIN_CMD_FOLLW_OBJ_CHG_FLAG = 20014;
        public const int OMAP_WIN_CMD_FOLLW_OBJ_CHG_LIST = 20015;

        public const int OMAP_API_CMD_GET_OBJ_LIST = 20100;
        public const int OMAP_API_CMD_GET_OBJ = 20101;
        public const int OMAP_API_CMD_SET_OBJ = 20102;
        public const int OMAP_API_CMD_DEL_OBJ = 20103;
        public const int OMAP_API_CMD_GET_SEL_LIST = 20104;
        public const int OMAP_API_CMD_SRH_OBJ = 20105;
        public const int OMAP_API_CMD_SET_SEL_ID_LIST = 20106;
        public const int OMAP_API_CMD_SRH_OBJ_EXT = 20107;

        public const int OMAP_API_CMD_GET_SEL_OBJ_TREE = 20110;
        // 返回tagOApiObjDataItem数组, 会自动填充(修正)idParent与idObj
        public const int OMAP_API_CMD_SET_OBJ_TREE = 20112;


        public const int OMAP_API_CMD_SET_SYS_COOR_POINT = 20201;
        public const int OMAP_API_CMD_GET_SYS_COOR_INFO = 20202;
        public const int OMAP_API_CMD_REQ_INTERFACE_VER = 20203;

        public const int OMAP_API_CMD_GET_MAP_DATA = 20301;

        public const int OMAP_API_CMD_SET_BTN = 20401;
        public const int OMAP_API_CMD_CLICK_BTN = 20402;

        public const int OMAP_API_CMD_GET_STATUS_INFO = 20501;
        public const int OMAP_AIP_CMD_REQ_VIP5_DEMO = 20503;


        public const int OMAP_API_CMD_CUS_MAIN_BTN_QUERY = 20701;
        public const int OMAP_API_CMD_CUS_MAIN_BTN_SET = 20702;	// 添加或者修改
        public const int OMAP_API_CMD_CUS_MAIN_BTN_DEL = 20703;
        public const int OMAP_API_CMD_CUS_MAIN_BTN_CLICK = 20704;

        public const int OMAP_API_CMD_CUS_FAV_MENU_QUERY = 20711;
        public const int OMAP_API_CMD_CUS_FAV_MENU_SET = 20712;	// 添加或者修改
        public const int OMAP_API_CMD_CUS_FAV_MENU_DEL = 20713;
        public const int OMAP_API_CMD_CUS_FAV_MENU_CLICK = 20714;

        public const int OMAP_API_CMD_OBJ_EVENT_QUERY = 20721;
        public const int OMAP_API_CMD_OBJ_EVENT_SET = 20722;
        public const int OMAP_API_CMD_OBJ_EVENT_TIRGGER = 20723;

        public const int OMAP_API_CMD_GET_OMAP_WND_RECT = 20730;
        public const int OMAP_API_CMD_OBJ_SHOW_WND = 20731;
        public const int OMAP_API_CMD_OBJ_CLOSE_WND_EVENT = 20732;

        public const int OMAP_API_CMD_CUS_MAIN_MENU_SET = 20742;
        public const int OMAP_API_CMD_CUS_MAIN_MENU_CLICK = 20744;

        public const int OMAP_API_CMD_CUS_WND_SET = 20750;
        public const int OMAP_API_CMD_CUS_WND_QUERY = 20751;
        public const int OMAP_API_CMD_CUS_WND_DEL = 20752;
        public const int OMAP_API_CMD_CUS_WND_CLOSE_EVENT = 20753;

        public const int OMAP_RET_SYS_COOR_TYPE_ERR = -2;
        public const int OMAP_RET_SYS_COOR_SIM_PARAM_ERR = -1;
        public const int OMAP_RET_SYS_COOR_OK = 0;

        public const int ACTION_MOUSE_MOVE = 1;
        public const int ACTION_MOUSE_CLICK = 2;

        public const int GEO_DECODE_ERR_WAIT = -1;
        public const int GEO_DECODE_ERR_NO_DATA = -2;
        public const int MAX_API_NAME_LEN = 100;
        public const int MAX_API_DIR_WAYPOINTS = 8;

        public const int OMAP_OBJ_TYPE_GROUP = 30;
        public const int OMAP_OBJ_TYPE_SIGN = 7;
        public const int OMAP_OBJ_TYPE_TRACK = 8;
        public const int OMAP_OBJ_TYPE_SHAPE = 13;
        public const int OMAP_OBJ_TYPE_DIR = 11;

        public const int OMAP_API_ERR_OK = 1;
        public const int OMAP_API_ERR_WND = -1;
        public const int OMAP_API_ERR_REGISTER = -2;
        public const int OMAP_API_ERR_VER = -3;
        public const int OMAP_API_ERR_ARGV = -4;
        public const int OMAP_API_ERR_NOT_VIP = -5;
        public const int OMAP_API_ERR_DEAL = -6;
        public const int OMAP_API_ERR_NOT_VIP5 = -7;
        public const int OMAP_API_ERR_UNLOAD_OBJ = -8;
        public const int OMAP_API_ERR_CMD = -9;

        public const int OAPI_APP_ID_QUERY = -100;
        public const int OAPI_APP_ID_ALL = -1;
        public const int OAPI_APP_ID_NONE = 0;

        public const int USER = 0x0400;
        public const int OAPI_LL_TYPE_DEFAULT = 0;
        public const int OAPI_LL_TYPE_REAL = 1;
        public const int OAPI_LL_TYPE_OFFSET = 2;
        public const int OAPI_LL_TYPE_PLANE = 3;
        public const int OAPI_LL_TYPE_GOOGLE_PX = 4;

        public const int OAPI_MAP_OBJ_EVENT_NONE = 0;
        public const int OAPI_MAP_OBJ_EVENT_SEND_ONLY = 1;
        public const int OAPI_MAP_OBJ_EVENT_SEND_EXT = 2;

        // 所有对象
        public const int OBJ_SELECT_CHECK_FLAG_ALL = 0;
        // 选中对象, 选中的文件夹自动包含所有子对象
        public const int OBJ_SELECT_CHECK_FLAG_GROUP_JOIN = 1;
        // 选中对象, 选中的文件夹不自动包括非选中子对象
        public const int OBJ_SELECT_CHECK_FLAG_SEL_ONLY = 2;
        // 选中对象, 如果选中的是文件夹, 则排除文件夹本身去选中子结点
        public const int OBJ_SELECT_CHECK_FLAG_NO_GROUP = 3;
        public const int OAPI_INTERFACE_TYPE_CAD = 1;
        //临时对象分组节点ID
        public const int OMAP_TMP_OBJ_GROUP_ID = 202;

        public const int WM_COPYDATA = 0x004A;
        public const int WM_USER = 0x0400;
        public const int WM_SAVE_SHPFILE = WM_USER + 1;

        public const int SRH_OBJ_OPT_NAME_FUZZY = 0;
        public const int SRH_OBJ_OPT_NAME_HEADER = 1;
        public const int SRH_OBJ_OPT_COMMENT_FUZZY = 2;
        public const int SRH_OBJ_OPT_COMMENT_HEADER = 3;
        public const int SRH_OBJ_OPT_SRH_SAME = 4;
        public const int SRH_OBJ_OPT_NAME_MATCH = 5;
        public const int SRH_OBJ_OPT_COMMENT_MATCH = 6;

        public const int SRH_OBJ_OPT_SIGN_SHOW_STYLE = 11;
        public const int SRH_OBJ_OPT_SIGN_ICON_ID = 12;

        public const int SRH_OBJ_OPT_TRACK_LINET_TYPE = 21;
        public const int SRH_OBJ_OPT_TRACK_SHOW_STYLE = 22;
        public const int SRH_OBJ_OPT_TRACK_CLASS0 = 23;

        public const int GET_CONTOUR_RET_ERR_EXCEED_ONE = -101;
        public const int GET_CONTOUR_RET_ERR_PART_OK = -102;
        public const int GET_CONTOUR_RET_ERR_PART_ERR = -103;

        public bool IS_TXT_SRH_OBJ_OPT(int x)
        {
            return (x == SRH_OBJ_OPT_NAME_FUZZY || x == SRH_OBJ_OPT_NAME_HEADER || x == SRH_OBJ_OPT_COMMENT_FUZZY || x == SRH_OBJ_OPT_COMMENT_HEADER || x == SRH_OBJ_OPT_NAME_MATCH || x == SRH_OBJ_OPT_COMMENT_MATCH);
        }

        public bool IS_INT_SRH_OBJ_OPT(int x)
        {
            return (x == SRH_OBJ_OPT_SIGN_SHOW_STYLE || x == SRH_OBJ_OPT_SIGN_ICON_ID || x == SRH_OBJ_OPT_TRACK_LINET_TYPE || x == SRH_OBJ_OPT_TRACK_SHOW_STYLE || x == SRH_OBJ_OPT_TRACK_CLASS0);
        }

        public bool IS_SAME_SRH_OBJ_OPT(int x)
        {
            return (x == SRH_OBJ_OPT_SRH_SAME);
        }

        public int OMAP_ALIGN_8_BYTE(int x)
        {
            return ((x) % 8 == 0) ? x : ((x) / 8 * 8 + 8);
        }

        public bool IS_OMAP_API_INTERRUPT_ERR(int x)
        {

            if (x == OMAP_API_ERR_NOT_VIP || x == OMAP_API_ERR_DEAL || x == OMAP_API_ERR_NOT_VIP5 || x == OMAP_API_ERR_UNLOAD_OBJ)
                return true;
            else
                return false;
        }
        public const int OAPI_RET_ERR_VIP_LEVEL = -1; //奥维VIP级别不够
        public const int OAPI_RET_ERR_VIP5_NEED = -2; //需要VIP5及以上
        public const int OAPI_RET_ERR_LATLNG_INVALID = -3;//坐标系错误
        public const int OAPI_RET_ERR_ARGV = -4; //参数错误
        public const int OAPI_RET_ERR_MEMORY_OUT = -5; //内存异常
        public const int OAPI_RET_ERR_UNKNOWN = -6; //未知错误
        public const int OAPI_RET_ERR_ARGV_REQ = -7;//与等高线请求相关
        public const int OAPI_RET_ERR_MEMORY_END = -8; //内存不足而终止

        public const int OAPI_DATA_HAS_FULL = 1;
        public const int OAPI_DATA_PART_ONLY = 2;
        public const int OAPI_DATA_IS_NONE = 3;



        public const int GET_MAP_FILE_RET_ERR_COORD_TYPE = -101;//坐标系设置错误(或位置偏差过大)
        public const int GET_MAP_FILE_RET_ERR_IGNORE = -102;//忽略
        public const int GET_MAP_FILE_RET_ERR_SIZE_EXCEED = -103;//地图尺寸太大
        public const int GET_MAP_FILE_RET_ERR_PIXEL_EXCEED = -104;//地图像素太高
        public const int GET_MAP_FILE_RET_ERR_CREATE_IMG = -105; //创建地图失败
        public const int GET_MAP_FILE_RET_ERR_RESIZE = -106;//地图扭曲太大


        public const int GET_MAP_FILE_IMG_TYPE_PNG = 0;
        public const int GET_MAP_FILE_IMG_TYPE_JPG = 1;
    };
    #endregion
    static public class OmapEventHander
    {
        static public void NullParameh(eEventHanderType eType)
        {
            switch (eType)
            {
                case eEventHanderType.eBringWindowsToTop:
                    OmapOperation.BringWindowsToTop();
                    break;
                case eEventHanderType.eOmapBtnCliked:
                    // MessageBox.Show("Omap的按钮被点击了！");
                    OmapOperation.GetOmapSelObjectTree(0, 1);
                    break;
                default:
                    Trace.WriteLine("aaaa");
                    break;
            }

        }
        static public void GetLatlng(tagOmapLatlngCli oll)
        {
            string str = string.Format("{0:F6},{1:F6}", oll.lat, oll.lng);
            Program.g_omapTest.m_edit_Result.Text = str;
        }
        static public void GetGeoDecode(tagOmapGeoDecodeCli gd)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("经纬度:{0:F6},{1:F6}\r\n解析结果:\r\n", gd.oll.lat, gd.oll.lng);
            if (gd.nLevel == OmapDef.GEO_DECODE_ERR_WAIT)
            {
                sb.AppendFormat("等待数据中，请1秒后再次请求\r\n");
            }
            else if (gd.nLevel == OmapDef.GEO_DECODE_ERR_NO_DATA)
            {
                sb.AppendFormat("找不到对应信息\r\n");
            }
            for (int i = 0; i < gd.nLevel; i++)
            {
                sb.AppendFormat("{0}\r\n", gd.strArea[i]);
            }
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetLatlngByTime(tagOphotoMapPicCli[] pOmps)
        {
            int iSize = pOmps.Length;
            int nCount = 0;
            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < iSize; i++)
            {
                if (pOmps[i].lat != 0 || pOmps[i].lng != 0)
                {
                    nCount++;
                }
            }
            sb.AppendFormat("共有{0}张照片获得经纬度:\r\n", nCount);
            int iCur = 0;
            for (int i = 0; i < iSize; i++)
            {
                if (pOmps[i].lat != 0 || pOmps[i].lng != 0)
                {
                    sb.AppendFormat("第{0}张经纬度：{1:F6},{2:F6}\r\n", iCur++ + 1, pOmps[i].lat, pOmps[i].lng);
                }
            }
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjList(tagOApiItemList[] pOlvs)
        {
            Program.g_omapTest.m_list_Result.Clear();
            Program.g_omapTest.m_list_Result.Columns.Add("类别", 50);
            Program.g_omapTest.m_list_Result.Columns.Add("名称", 150);
            Program.g_omapTest.m_list_Result.ShowGroups = false;
            int nList = pOlvs.Length;

            //uint[] pIds = new uint[nList];
            for (int i = 0; i < nList; i++)
            {
                string strType;
                //pIds[i] = pOlvs[i].idObj;
                if (pOlvs[i].iType == OmapDef.OMAP_OBJ_TYPE_GROUP)
                {
                    strType = "文件夹";
                }
                else if (pOlvs[i].iType == OmapDef.OMAP_OBJ_TYPE_SIGN)
                {
                    strType = "标签";
                }
                else if (pOlvs[i].iType == OmapDef.OMAP_OBJ_TYPE_TRACK)
                {
                    strType = "轨迹";
                }
                else if (pOlvs[i].iType == OmapDef.OMAP_OBJ_TYPE_SHAPE)
                {
                    strType = "图形";
                }
                else if (pOlvs[i].iType == OmapDef.OMAP_OBJ_TYPE_DIR)
                {
                    strType = "路线";
                }
                else
                    strType = "未知";

                ListViewItem lvi = new ListViewItem(strType);
                lvi.SubItems.Add(pOlvs[i].strName);
                lvi.Tag = pOlvs[i].idObj;

                Program.g_omapTest.m_list_Result.Items.Add(lvi);
            }
            //OmapOperation.SetOmapSelectIdList(pIds);
            Program.g_omapTest.m_list_Result.EndUpdate();
        }
        static public void GetObjSign(tagOApiMapSign pSign)
        {
            if (false)
            {
                tagOApiObjTree objTree = new tagOApiObjTree();
                objTree.iObjType = OmapDef.OMAP_OBJ_TYPE_SIGN;
                pSign.strName = pSign.strName + "_b";
                objTree.pSign = pSign;
                OmapOperation.AddObjTree(objTree, pSign.idParent);
            }

            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("SignName={0}\r\n", pSign.strName);
            sb.AppendFormat("latlng={0:F6},{1:F6}\r\n", pSign.lat, pSign.lng);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjTrack(tagOApiMapTrack pTrack)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("TrackName={0}\r\n", pTrack.strName);
            sb.AppendFormat("TrackPointCount={0}\r\n", pTrack.nMtp);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjShape(tagOApiMapShape pShape)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("ShapeName={0}\r\n", pShape.strName);
            sb.AppendFormat("ShapeVertexCount={0}\r\n", pShape.nMtp);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjDirections(tagOApiMapDirections pDir)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("DirectionsName={0}\r\n", pDir.strName);
            sb.AppendFormat("DirectionsUnit={0}\r\n", pDir.nUnit);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjGroup(tagOApiObjGroup pGroup)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("GroupName={0}\r\n", pGroup.strName);
            sb.AppendFormat("NumberOfChild={0}\r\n", pGroup.nChild);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjSignArray(tagOApiMapSign[] pSigns)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("收到标签{0}个\r\n", pSigns.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjTrackArray(tagOApiMapTrack[] pTracks)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("收到轨迹{0}个\r\n", pTracks.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjShapeArray(tagOApiMapShape[] pShapes)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("收到图形{0}个\r\n", pShapes.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjDirectionsArray(tagOApiMapDirections[] pDirs)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("收到路线{0}个\r\n", pDirs.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjGroupArray(tagOApiObjGroup[] pGroups)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("收到文件夹{0}个\r\n", pGroups.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetObjChange(tagOApiObjChageHdrCli pOch)
        {
            if (pOch.iFlag == 1 && pOch.nList == 1 && pOch.pdwList[0] >= 202 && pOch.pdwList[0] <= 400)
            {
                //删除临时对象  此时可能发生在将新建的临时对象删除或添加到收藏夹。
                return;
            }
            StringBuilder sb = new StringBuilder();
            if (pOch.iFlag == 0)
            {
                sb.Append("添加或修改对象id如下：\r\n");
            }
            else
            {
                sb.Append("删除对象id如下：\r\n");
            }
            for (int i = 0; i < pOch.nList; i++)
            {
                sb.AppendFormat("{0}\r\n", pOch.pdwList[i]);
            }
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetWinMapInfo(tagWinMapInfoCli pWmi)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("地图类型：{0}\r\n地图级别：{1}\r\n中心点经纬度：{2:F6},{3:F6}\r\n", pWmi.iMapType, pWmi.iMapLevel, pWmi.lng, pWmi.lat);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetGooglePixelInfo(tagOApiPixelInfoCli[] pOpi)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("获得{0}级地图信息\r\n", pOpi.Length);
            sb.AppendFormat("第一级像素：X:{0:F6},Y:{1:F6}\r\n", pOpi[0].dMeterX, pOpi[0].dMeterY);
            sb.AppendFormat("最后一级像素：X:{0:F6},Y:{1:F6}\r\n", pOpi[pOpi.Length - 1].dMeterX, pOpi[pOpi.Length - 1].dMeterY);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetSysCoorCenter(tagOApiRelatePoint pOrp)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("平面坐标系的中心点：{0:F6},{1:F6}\r\n", pOrp.x, pOrp.y);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetSysCoorInfo(tagOApiSysCoorInfoCli pSci)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("坐标类型：{0},\r\n坐标信息：{1}\r\n", pSci.iCoorType, pSci.strInfo);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void TestObjTree(tagOApiObjTree pOtree)
        {
            while (pOtree != null)
            {
                if (pOtree.pChild != null)
                {
                    TestObjTree(pOtree.pChild);
                }
                if (pOtree.pGroup != null)
                {
                    pOtree.pGroup.strName = pOtree.pGroup.strName + "_Add";

                }
                else if (pOtree.pSign != null)
                {
                    pOtree.pSign.strName = pOtree.pSign.strName + "_Add";
                }
                else if (pOtree.pTrack != null)
                {
                    pOtree.pTrack.strName = pOtree.pTrack.strName + "_Add";
                }
                else if (pOtree.pShape != null)
                {
                    pOtree.pShape.strName = pOtree.pShape.strName + "_Add";
                }
                else if (pOtree.pDir != null)
                {
                    pOtree.pDir.strName = pOtree.pDir.strName + "_Add";
                }
                pOtree = pOtree.pNext;
            }
        }
        static public void GetOmapObjTree(tagOApiObjTree pOtree)
        {
            if (false)
            {
                TestObjTree(pOtree);
                OmapOperation.SetOmapSelObjectTree(pOtree, 0);
            }


            //MessageBox.Show("GetOmapObjTree");
        }
        static public void GetProgressRate(double dProgRate, eEventHanderType eTpye)
        {
            if (eTpye == eEventHanderType.eGetContourProcess)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("进度：{0},类型{1},\r\n", dProgRate, (int)eTpye);
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }
        static public void GetObjSrh(tagOApiObjectSrhResCli[] pRes)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("共检索到{0}条结果\r\n", pRes.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetOmapMapData(tagOmapGetMapCli pMapData)
        {
            System.IO.MemoryStream ms = new System.IO.MemoryStream(pMapData.pData);
            System.Drawing.Image img = System.Drawing.Image.FromStream(ms);
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("获得的图片像素为({0}×{1})\r\n", img.Width, img.Height);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetOmapMapFile(tagOmapGetMapFileCli pMapFile)
        {
            StringBuilder sb = new StringBuilder();
            if (pMapFile.iRet == OmapDef.OAPI_DATA_HAS_FULL)
            {
                sb.AppendFormat("获得图片成功！\r\n");
            }
            else if (pMapFile.iRet == OmapDef.GET_MAP_FILE_RET_ERR_IGNORE)
            {
                sb.AppendFormat("因图片不完整，忽略本次操作！\r\n");
            }
            else
            {
                sb.AppendFormat("其他错误！\r\n");
            }
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetContour(tagOmapReqContourCli pReq)
        {
            StringBuilder sb = new StringBuilder();
            if (pReq.iRet > 0)
            {
                sb.AppendFormat("获取高程成功！\r\n");
            }
            else if (pReq.iRet == OmapDef.GET_CONTOUR_RET_ERR_PART_OK)
            {
                sb.AppendFormat("获取高程(部分)成功！\r\n");
            }
            else if (pReq.iRet == OmapDef.GET_CONTOUR_RET_ERR_EXCEED_ONE)
            {
                sb.AppendFormat("当前操作(取高程)超出系统支持的范围！\r\n请缩小范围后再操作！\r\n");
            }
            else if (pReq.iRet == OmapDef.OAPI_RET_ERR_VIP_LEVEL)
            {
                sb.AppendFormat("当前操作(取高程)需要vip级别为：{}级.\r\n", pReq.iNeedVip);

            }
            else if (pReq.iRet == OmapDef.OAPI_RET_ERR_ARGV_REQ)
            {
                if (pReq.iCheckResult == OmapDef.OAPI_DATA_HAS_FULL)
                {
                    OmapOperation.ReGetContour();
                    sb.AppendFormat("检测到高程数据完整，系统自动重新获取等高线！\r\n");
                }
                else if (pReq.iCheckResult == OmapDef.OAPI_DATA_PART_ONLY)
                {
                    sb.AppendFormat("检测到高程数据不完整！\r\n");
                }
                else
                {
                    sb.AppendFormat("检测到没有高程数据！\r\n");
                }
            }
            else
            {
                sb.AppendFormat("{0}", OmapOperation.GetOmapDataErrMsg(pReq.iRet));
            }
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void SetObjIds(tagOApiObjIdItem[] pObjIds)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("返回对象id的数量为：{0}\r\n", pObjIds.Length);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void SetOmapBtn(int iBtnStatus)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("OmapBtn状态为：{0}\r\n", iBtnStatus);
            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }
        static public void GetWebSocketConf(tagWebSocketConf wsc)
        {
            if (wsc != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取Websocket配置成功\r\n");
                sb.AppendFormat(("iWssFlag:{0}\r\n"), wsc.iWssFlag);
                sb.AppendFormat(("dwWssUserLimitIP:{0}\r\n"), wsc.dwWssUserLimitIP);
                sb.AppendFormat(("wPort:{0}\r\n"), wsc.wPort);
                sb.AppendFormat(("strPsk:{0}\r\n"), (wsc.strPsk));
                sb.AppendFormat(("strSslCaFn:{0}\r\n"), (wsc.strSslCaFn));
                sb.AppendFormat(("strSslCertFn:{0}\r\n"), (wsc.strSslCertFn));
                sb.AppendFormat(("strSslKeyFn:{0}\r\n"), (wsc.strSslKeyFn));
                sb.AppendFormat(("bHttpTileService:{0}\r\n"), wsc.bHttpTileService);
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }
        static public void GetCusMapCfgList(tagCustomMap[] pMaps)
        {
            if (pMaps != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取自定义地图列表成功\r\n");
                for(int i = 0; i < pMaps.Length; i++)
                {
                    sb.AppendFormat(("idMap:{0}\r\n"), pMaps[i].idMap);
                    sb.AppendFormat(("idLayerBig:{0}\r\n"), pMaps[i].idLayerBig);
                    sb.AppendFormat(("idLayerSmall:{0}\r\n"), pMaps[i].idLayerSmall);
                    sb.AppendFormat(("iLayerBigFlag:{0}\r\n"), pMaps[i].iLayerBigFlag);
                    sb.AppendFormat(("iLayerSmallFlag:{0}\r\n"), pMaps[i].iLayerSmallFlag);
                    sb.AppendFormat(("iMinLevel:{0}\r\n"), pMaps[i].iMinLevel);
                    sb.AppendFormat(("iMaxLevel:{0}\r\n"), pMaps[i].iMaxLevel);
                    sb.AppendFormat(("idLayerSmall:{0}\r\n"), pMaps[i].iCoordType);
                    sb.AppendFormat(("iTileFormat:{0}\r\n"), pMaps[i].iTileFormat);
                    sb.AppendFormat(("iTileSize:{0}\r\n"), pMaps[i].iTileSize);
                    sb.AppendFormat(("iVersion:{0}\r\n"), pMaps[i].iVersion);
                    sb.AppendFormat(("bUseLayer:{0}\r\n"), pMaps[i].bUseLayer);
                    sb.AppendFormat(("bIsSatellite:{0}\r\n"), pMaps[i].bIsSatellite);
                    sb.AppendFormat(("strName:{0}\r\n"), (pMaps[i].strName));
                    sb.AppendFormat(("strHost:{0}\r\n"), (pMaps[i].strHost));
                    sb.AppendFormat(("wPort:{0}\r\n"), pMaps[i].wPort);
                    sb.AppendFormat(("iHostStart:{0}\r\n"), pMaps[i].iHostStart);
                    sb.AppendFormat(("iHostEnd:{0}\r\n"), pMaps[i].iHostEnd);
                    sb.AppendFormat(("strUrl:{0}\r\n"), (pMaps[i].strUrl));
                    sb.AppendFormat("\r\n");
                }
                
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }
        static public void GetSysCoordProj(tagPrj prj)
        {
            if (prj != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取系统坐标系信息成功\r\n");
                sb.AppendFormat(("strPrjType:{0}\r\n"), (prj.strPrjType));
                sb.AppendFormat(("strPrjName:{0}\r\n"), (prj.strPrjName));
                sb.AppendFormat(("strGeogcs:{0}\r\n"), (prj.strGeogcs));
                sb.AppendFormat(("strDatum:{0}\r\n"), (prj.strDatum));
                sb.AppendFormat(("strSpheroid:{0}\r\n"), (prj.strSpheroid));
                sb.AppendFormat(("dSemimajorAxis:{0}\r\n"), prj.dSemimajorAxis);
                sb.AppendFormat(("dSemiminorAxis:{0}\r\n"), prj.dSemiminorAxis);
                sb.AppendFormat(("dInverseFlattening:{0}\r\n"), prj.dInverseFlattening);
                sb.AppendFormat(("strPrimem:{0}\r\n"), (prj.strPrimem));
                sb.AppendFormat(("dPrimeMeridian:{0}\r\n"), prj.dPrimeMeridian);
                sb.AppendFormat(("strAngularUnit:{0}\r\n"), (prj.strAngularUnit));
                sb.AppendFormat(("dAngularUnit:{0}\r\n"), prj.dAngularUnit);
                sb.AppendFormat(("strLinearUnit:{0}\r\n"), (prj.strLinearUnit));
                sb.AppendFormat(("dLinearUnit:{0}\r\n"), prj.dLinearUnit);
                sb.AppendFormat(("strProjection:{0}\r\n"), (prj.strProjection));
                sb.AppendFormat(("dFalseEasting:{0}\r\n"), prj.dFalseEasting);
                sb.AppendFormat(("dFalseNorthing:{0}\r\n"), prj.dFalseNorthing);
                sb.AppendFormat(("dCentralMeridian:{0}\r\n"), prj.dCentralMeridian);
                sb.AppendFormat(("dScaleFactor:{0}\r\n"), prj.dScaleFactor);
                sb.AppendFormat(("dLatitudeOfOrigin:{0}\r\n"), prj.dLatitudeOfOrigin);
                sb.AppendFormat(("dLatitudeOfCenter:{0}\r\n"), prj.dLatitudeOfCenter);
                sb.AppendFormat(("dStandardParallel_1:{0}\r\n"), prj.dStandardParallel_1);
                sb.AppendFormat(("dStandardParallel_2:{0}\r\n"), prj.dStandardParallel_2);
                sb.AppendFormat(("dLatitude_Of_1st_Point:{0}\r\n"), prj.dLatitude_Of_1st_Point);
                sb.AppendFormat(("dLatitude_Of_2nd_Point:{0}\r\n"), prj.dLinearUnit);
                sb.AppendFormat(("dLinearUnit:{0}\r\n"), prj.dLatitude_Of_2nd_Point);
                sb.AppendFormat(("dLongitude_Of_1st_Point:{0}\r\n"), prj.dLongitude_Of_1st_Point);
                sb.AppendFormat(("dLongitude_Of_2nd_Point:{0}\r\n"), prj.dLongitude_Of_2nd_Point);
                sb.AppendFormat(("dAzimuth:{0}\r\n"), prj.dAzimuth);
                sb.AppendFormat(("dLongitudeOfCenter:{0}\r\n"), prj.dLongitudeOfCenter);
                sb.AppendFormat(("iPrjType:{0}\r\n"), prj.iPrjType);
                sb.AppendFormat(("iCoordType:{0}\r\n"), prj.iCoordType);
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }
        static public void GetOmapPluginVer(tagPluginVer pVer)
        {
            if (pVer != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取版本号信息成功\r\n");
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }

        }
        static public void GetOmapWndRect(tagOmapWndRect pOmapWndRect)
        {
            if(pOmapWndRect != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取可显示区域信息成功\r\n");
                sb.AppendFormat("left:{0}\r\nright:{1}\r\ntop:{2}\r\nbottom:{3}", pOmapWndRect.rectMapOfWnd.left, pOmapWndRect.rectMapOfWnd.right,
                    pOmapWndRect.rectMapOfWnd.top, pOmapWndRect.rectMapOfWnd.bottom);
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }

        static public void GetMapShapeDetai(tagMapShapeDetail pMapShapeDetail)
        {
            if (pMapShapeDetail != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取图形信息成功\r\n");
                sb.AppendFormat("idObj:{0};\r\n", pMapShapeDetail.idObj);
                if (pMapShapeDetail.idObj > 0)
                {
                    sb.AppendFormat(("PointCnt:{0};\r\n"), pMapShapeDetail.iPointCnt);
                    sb.AppendFormat(("AreaCnt:{0};\r\n"), pMapShapeDetail.iAreaCnt);
                    sb.AppendFormat(("Perimeter:{0}(公里);\r\n"), pMapShapeDetail.dPerimeter);
                    sb.AppendFormat(("AreaSize:{0}(平方米);\r\n"), pMapShapeDetail.dAreaSize);
                }
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }

        static public void GetMapTrackDetail(tagMapTrackDetail pMapTrackDetail)
        {
            if (pMapTrackDetail != null)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("获取轨迹信息成功\r\n");
                sb.AppendFormat("idObj:{0};\r\n", pMapTrackDetail.idObj);
                if (pMapTrackDetail.idObj > 0)
                {
                    sb.AppendFormat("tStart:{0};\r\n", pMapTrackDetail.tStart);
                    sb.AppendFormat("tEnd:{0};\r\n", pMapTrackDetail.tEnd);
                    sb.AppendFormat("TotalPoint:{0};\r\n", pMapTrackDetail.iTotalPoint);
                    sb.AppendFormat("TotalDist{0}(米);\r\n", pMapTrackDetail.iTotalDist);
                    sb.AppendFormat("AgvSpeed:{0}(公里/每小时);\r\n", pMapTrackDetail.iAgvSpeed);
                    sb.AppendFormat("MaxSpeed:{0}(公里/每小时);\r\n", pMapTrackDetail.iMaxSpeed);
                    sb.AppendFormat("MaxAltitude:{0}(米);\r\n", pMapTrackDetail.iMaxAltitude);
                    sb.AppendFormat("MinAltitude:{0}(米);\r\n", pMapTrackDetail.iMinAltitude);
                }
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }

        static public void GetMainBtn(tagCusMainBtnCli[] pCms,int nCmdId)
        {
           if(pCms != null)
            {
                int nCmb = pCms.Length;
                StringBuilder sb = new StringBuilder();
               
                if (nCmdId == OmapDef.OMAP_API_CMD_CUS_MAIN_BTN_SET)
                {
                    sb.AppendFormat("SetCusMainBtn:\r\n");
                }
                else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_MAIN_BTN_QUERY)
                {
                     sb.AppendFormat("QueryCusMainBtn:\r\n");
                }
                else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_MAIN_BTN_DEL)
                {
                     sb.AppendFormat("DelCusMainBtn:\r\n");
                }
                else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_MAIN_BTN_CLICK)
                {
                     sb.AppendFormat("ClickCusMainBtn:\r\n");
                }
                for (int i = 0; i < nCmb; i++)
                {
                    sb.AppendFormat("BtnId:{0},Result:{1}\r\n", pCms[i].nId, pCms[i].iResult);
                }
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }

        static public void GetFavMenu(tagCusFavMenuCli[] pCfs, int nCmdId)
        {
            if(pCfs != null)
            {
                int nCnt = pCfs.Length;
                StringBuilder sb = new StringBuilder();
                if (nCmdId == OmapDef.OMAP_API_CMD_CUS_FAV_MENU_SET)
                {
                    sb.AppendFormat("SetCusFavMenu:\r\n");
                }
                else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_FAV_MENU_QUERY)
                {
                    sb.AppendFormat("QueryCusFavMenu:\r\n");
                }
                else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_FAV_MENU_DEL)
                {
                    sb.AppendFormat("DelCusFavMenu:\r\n");
                }
                else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_FAV_MENU_CLICK)
                {
                    sb.AppendFormat("ClickCusFavMenu:\r\n");
                }

                for(int i = 0; i < nCnt; i++)
                {
                    sb.AppendFormat("MenuId:{0},Result:{1}\r\n", pCfs[i].nId, pCfs[i].iResult);
                    if(pCfs[i].nList > 0)
                    {
                        sb.AppendFormat(" Clicked ObjIDs:\r\n");
                        for(int j = 0; j < pCfs[i].nList; j++)
                        {
                            sb.AppendFormat("    {0} \r\n", pCfs[i].pIdList[j]);
                        }
                    }
                }
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }
        static int m_iObjEventType = 0;
        static public void GetObjEvent(int iObjEventCmd, int nCmdId)
        {
            StringBuilder sb = new StringBuilder();
            if(nCmdId == OmapDef.OMAP_API_CMD_OBJ_EVENT_SET)
            {
                sb.AppendFormat("SetObjEvent:{0}", iObjEventCmd);
                m_iObjEventType = iObjEventCmd;
            }
            else if(nCmdId == OmapDef.OMAP_API_CMD_OBJ_EVENT_QUERY)
            {
                sb.AppendFormat("QueryObjEvent:{0}", iObjEventCmd);
            }
            else
            {
                if(iObjEventCmd > 0)
                {
                    if (nCmdId == OmapDef.OMAP_API_CMD_CUS_WND_SET)
                    {
                        sb.AppendFormat("SetCusWnd:{0}", iObjEventCmd);
                    }
                    else if(nCmdId == OmapDef.OMAP_API_CMD_CUS_WND_QUERY)
                    {
                        sb.AppendFormat("QueryCusWnd:{0}", iObjEventCmd);
                    }
                    else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_WND_QUERY)
                    {
                        sb.AppendFormat("DelCusWnd:{0}", iObjEventCmd);
                    }
                }
                else
                {
                    if (nCmdId == OmapDef.OMAP_API_CMD_CUS_WND_SET)
                    {
                        sb.AppendFormat("SetCusWndFail");
                    }
                    else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_WND_QUERY)
                    {
                        sb.AppendFormat("QueryCusWnddFail");
                    }
                    else if (nCmdId == OmapDef.OMAP_API_CMD_CUS_WND_QUERY)
                    {
                        sb.AppendFormat("DelCusWnddFail");
                    }
                }
            }

            Program.g_omapTest.m_edit_Result.Text = sb.ToString();
        }

        static public void GetCusMainMenuClick(tagCusMainMenuCli pCmm)
        {
            if(pCmm != null)
            {
                StringBuilder sb = new StringBuilder();

                sb.AppendFormat("Clicked MenuId:{0}", pCmm.nId);

                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }

        static public void GetObjEventTirgger(tagMapObjEvent pMoe)
        {
            if(pMoe != null)
            {
                StringBuilder sb = new StringBuilder();

                sb.AppendFormat("ObjId:{0}\r\n", pMoe.idObj);
                sb.AppendFormat(("rectMapOfWnd:\r\n[\r\nleft:{0},\r\nright:{1},\r\ntop:{2},\r\nbottom:{3}\r\n]\r\n"), pMoe.rectMapOfWnd.left,
                pMoe.rectMapOfWnd.top, pMoe.rectMapOfWnd.right, pMoe.rectMapOfWnd.bottom);
                sb.AppendFormat(("pointClickOfMap:\r\n[\r\nx:{0},\r\ny:{1}\r\n]\r\n"), pMoe.ptClickOfMap.x, pMoe.ptClickOfMap.y);

                Program.g_omapTest.m_edit_Result.Text = sb.ToString();

                if(m_iObjEventType == OmapDef.OAPI_MAP_OBJ_EVENT_SEND_ONLY)
                {
                   OmapOperation.SetObjShowWnd(pMoe,1,1);
                }
            }
        }

        static public void GetObjCloseWnd(int idObj, eEventHanderType eType)
        {
            if(eType == eEventHanderType.eObjCloseWndEvent)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("弹窗被关闭\r\n对象ID: {0}", idObj);
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
            else if(eType == eEventHanderType.eGetCmdCusCloseWnd)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendFormat("被关闭自定义非特定弹窗ID: {0}", idObj);
                Program.g_omapTest.m_edit_Result.Text = sb.ToString();
            }
        }
    }
    public class OmapOperation
    {
        #region DLL_IMPORT
        [DllImport("User32.dll", EntryPoint = "FindWindow")]
        private static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
        [DllImport("user32.dll")]
        private static extern bool SetForegroundWindow(IntPtr hWnd);
        [DllImport("user32.dll", EntryPoint = "ShowWindow", CharSet = CharSet.Auto)]
        public static extern int ShowWindow(IntPtr hwnd, int nCmdShow);
        public const int SW_HIDE = 0;
        public const int SW_SHOWNORMAL = 1;
        public const int SW_SHOW = 5;

        [DllImport("user32.dll")]
        private static extern bool IsIconic(IntPtr hWnd);
        #endregion
        static IntPtr m_ParentHwnd = IntPtr.Zero;
        static public void SetParentHandle(IntPtr hwnd)
        {
            m_ParentHwnd = hwnd;
        }
        static public string GetOmapDataErrMsg(int iRet)
        {
            string str = "";
            if (iRet >= 0 || iRet == OmapDef.OAPI_RET_ERR_ARGV_REQ)
            {
                return str;
            }

            switch (iRet)
            {
                case OmapDef.OAPI_RET_ERR_VIP_LEVEL:
                    str = "\n奥维VIP级别不够！";
                    break;
                case OmapDef.GET_MAP_FILE_RET_ERR_COORD_TYPE:
                    str = "\n坐标系设置错误(或位置偏差过大)！";
                    break;
                case OmapDef.GET_MAP_FILE_RET_ERR_IGNORE:
                    break;
                case OmapDef.GET_MAP_FILE_RET_ERR_SIZE_EXCEED:
                    str = "\n地图尺寸太大！";
                    break;
                case OmapDef.GET_MAP_FILE_RET_ERR_PIXEL_EXCEED:
                    str = "\n地图像素太高！";
                    break;
                case OmapDef.GET_MAP_FILE_RET_ERR_CREATE_IMG:
                    str = "\n创建地图失败！";
                    break;
                case OmapDef.OAPI_RET_ERR_LATLNG_INVALID:
                    str = "\n坐标系错误！";
                    break;
                case OmapDef.OAPI_RET_ERR_MEMORY_OUT:
                    str = "\n内存异常！";
                    break;
                case OmapDef.OAPI_RET_ERR_ARGV:
                    str = "\n参数错误！";
                    break;
                case OmapDef.GET_MAP_FILE_RET_ERR_RESIZE:
                    str = "\n地图扭曲太大！请纠正位置或重新设置平面坐标系。";
                    break;
                case OmapDef.OAPI_RET_ERR_VIP5_NEED:
                    str = "\n该功能需要升级到VIP5！";
                    break;
                default:
                    str = "\n其他错误！";
                    break;

            }
            return str;
        }
        
        static public void AlertErrSendOmapMsg(long iRet)
        {
            if (iRet >= 0)
                return;
            if (iRet == OmapDef.OMAP_API_ERR_WND)
            {
                MessageBox.Show("没有找到奥维地图程序窗口");
            }
            else if (iRet == OmapDef.OMAP_API_ERR_REGISTER)
            {
                MessageBox.Show("向奥维地图程序注册失败");
            }
            else if (iRet == OmapDef.OMAP_API_ERR_VER)
            {
                MessageBox.Show("奥维地图程序版本太低");
            }
            else if (iRet == OmapDef.OMAP_API_ERR_ARGV)
            {
                MessageBox.Show("参数非法");
            }
            else if (iRet == OmapDef.OMAP_API_ERR_NOT_VIP)
            {
                MessageBox.Show("当前奥维地图绑定用户不是VIP用户，不支持此API接口");
            }
            else if (iRet == OmapDef.OMAP_API_ERR_UNLOAD_OBJ)
            {
                MessageBox.Show("奥维对象未载入, 请稍候...");
            }
            else if (iRet == OmapDef.OMAP_API_ERR_DEAL)
            {
                MessageBox.Show("消息处理失败");
            }
            else
            {
                MessageBox.Show("未知错误");
            }
        }
        static public OmapWndCLI oform = new OmapWndCLI();
        static public COmapApiCLI g_omapApi = OmapWndCLI.g_omapCli;
        static GetLatlngEventHander g_ehGetLatlng;
        static GetGeoDecodeEventHander g_ehGeoDecode;
        static GetLatlngByTimeEventHander g_ehGetLatlngByTime;
        static GetObjListEventHander g_ehGetObjList;
        static GetObjSignEventHander g_ehGetSign;
        static GetObjTrackEventHander g_ehGetTrack;
        static GetObjShapeEventHander g_ehGetShape;
        static GetObjDirectionsEventHander g_ehGetDir;
        static GetObjGroupEventHander g_ehGetGroup;
        static GetObjSignArrayEventHander g_ehGetSigns;
        static GetObjTrackArrayEventHander g_ehGetTracks;
        static GetObjShapeArrayEventHander g_ehGetShapes;
        static GetObjDirectionsArrayEventHander g_ehGetDirs;
        static GetObjGroupArrayEventHander g_ehGetGroups;
        static NullParamEventHander g_ehNullParam;
        static GetObjChangeEventHander g_ehGetObjChange;
        static GetMapInfoEventHander g_ehGetMapInfo;
        static GetGooglePixelInfoEventHander g_ehGetPixelInfo;
        static GetSysCoorCenterEventHander g_ehGetSysCoorCenter;
        static GetSysCoorInfoEventHander g_ehGetSysCoorInfo;
        static GetObjTreeStructEventHander g_ehGetObjTree;
        static GetProgressRateEventHander g_ehGetProgRate;
        static GetOmapMapDataEventHander g_ehGetMapData;
        static GetOmapMapFileEventHander g_ehGetMapFile;
        static GetObjSrhResEventHander g_ehGetObjSrh;
        static GetContourEventHander g_ehGetContour;
        static SetObjTreeEventHander g_ehSetObjIds = null;
        static SetOmapBtnEventHander g_ehSetOmapBtn = null;
        static GetWebSocketConfEventHander g_ehGetWebSocketConf = null;
        static GetCustomMapEventHander g_ehGetCusMap = null;
        static GetSysCoordProjEventHander g_ehGetSysCoordProj = null;
        static GetOmapPluginVerEventHander g_ehGetOmapPluginVer = null;
        static GetOmapWndRectEventHander  g_ehGetOmapWndRect = null;
        static GetMapShapeDetailEventHander g_ehGetMapShapeDetail = null;
        static GetMapTrackDetailEventHander g_ehGetMapTrackDetail = null;
        static GetCusMainBtnEventHander g_ehGetMainBtn = null;
        static GetCusFavMenuEventHander g_ehGetFavMenu = null;
        static GetObjEventHander g_ehGetObjEvent = null;
        static GetCusMainMenuClickEventHander g_ehGetCusMainMenuClickEvent = null;
        static GetObjCloseWndEventHander g_ehGetObjCloseWnd = null;
        static GetObjEventTirggerEventHander g_ehGetObjEventTirgger = null;
        static public int iInferfaceVer = 220;
        
        static OmapOperation()
        {
            oform.Create();
            #region SetEventHander
            g_ehGetLatlng = new GetLatlngEventHander(OmapEventHander.GetLatlng);
            g_omapApi.SetEventHander(g_ehGetLatlng);
            g_ehGeoDecode = new GetGeoDecodeEventHander(OmapEventHander.GetGeoDecode);
            g_omapApi.SetEventHander(g_ehGeoDecode);
            g_ehGetLatlngByTime = new GetLatlngByTimeEventHander(OmapEventHander.GetLatlngByTime);
            g_omapApi.SetEventHander(g_ehGetLatlngByTime);
            g_ehGetObjList = new GetObjListEventHander(OmapEventHander.GetObjList);
            g_omapApi.SetEventHander(g_ehGetObjList);
            g_ehGetSign = new GetObjSignEventHander(OmapEventHander.GetObjSign);
            g_omapApi.SetEventHander(g_ehGetSign);
            g_ehGetTrack = new GetObjTrackEventHander(OmapEventHander.GetObjTrack);
            g_omapApi.SetEventHander(g_ehGetTrack);
            g_ehGetShape = new GetObjShapeEventHander(OmapEventHander.GetObjShape);
            g_omapApi.SetEventHander(g_ehGetShape);
            g_ehGetDir = new GetObjDirectionsEventHander(OmapEventHander.GetObjDirections);
            g_omapApi.SetEventHander(g_ehGetDir);
            g_ehGetGroup = new GetObjGroupEventHander(OmapEventHander.GetObjGroup);
            g_omapApi.SetEventHander(g_ehGetGroup);
            g_ehGetSigns = new GetObjSignArrayEventHander(OmapEventHander.GetObjSignArray);
            g_omapApi.SetEventHander(g_ehGetSigns);
            g_ehGetTracks = new GetObjTrackArrayEventHander(OmapEventHander.GetObjTrackArray);
            g_omapApi.SetEventHander(g_ehGetTracks);
            g_ehGetShapes = new GetObjShapeArrayEventHander(OmapEventHander.GetObjShapeArray);
            g_omapApi.SetEventHander(g_ehGetShapes);
            g_ehGetDirs = new GetObjDirectionsArrayEventHander(OmapEventHander.GetObjDirectionsArray);
            g_omapApi.SetEventHander(g_ehGetDirs);
            g_ehGetGroups = new GetObjGroupArrayEventHander(OmapEventHander.GetObjGroupArray);
            g_omapApi.SetEventHander(g_ehGetGroups);
            g_ehNullParam = new NullParamEventHander(OmapEventHander.NullParameh);
            g_omapApi.SetEventHander(g_ehNullParam);
            g_ehGetObjChange = new GetObjChangeEventHander(OmapEventHander.GetObjChange);
            g_omapApi.SetEventHander(g_ehGetObjChange);
            g_ehGetMapInfo = new GetMapInfoEventHander(OmapEventHander.GetWinMapInfo);
            g_omapApi.SetEventHander(g_ehGetMapInfo);
            g_ehGetPixelInfo = new GetGooglePixelInfoEventHander(OmapEventHander.GetGooglePixelInfo);
            g_omapApi.SetEventHander(g_ehGetPixelInfo);
            g_ehGetSysCoorCenter = new GetSysCoorCenterEventHander(OmapEventHander.GetSysCoorCenter);
            g_omapApi.SetEventHander(g_ehGetSysCoorCenter);
            g_ehGetSysCoorInfo = new GetSysCoorInfoEventHander(OmapEventHander.GetSysCoorInfo);
            g_omapApi.SetEventHander(g_ehGetSysCoorInfo);
            g_ehGetObjTree = new GetObjTreeStructEventHander(OmapEventHander.GetOmapObjTree);
            g_omapApi.SetEventHander(g_ehGetObjTree);
            g_ehGetProgRate = new GetProgressRateEventHander(OmapEventHander.GetProgressRate);
            g_omapApi.SetEventHander(g_ehGetProgRate);
            g_ehGetMapData = new GetOmapMapDataEventHander(OmapEventHander.GetOmapMapData);
            g_omapApi.SetEventHander(g_ehGetMapData);
            g_ehGetMapFile = new GetOmapMapFileEventHander(OmapEventHander.GetOmapMapFile);
            g_omapApi.SetEventHander(g_ehGetMapFile);
            g_ehGetObjSrh = new GetObjSrhResEventHander(OmapEventHander.GetObjSrh);
            g_omapApi.SetEventHander(g_ehGetObjSrh);
            g_ehGetContour = new GetContourEventHander(OmapEventHander.GetContour);
            g_omapApi.SetEventHander(g_ehGetContour);
            g_ehSetObjIds = new SetObjTreeEventHander(OmapEventHander.SetObjIds);
            g_omapApi.SetEventHander(g_ehSetObjIds);
            g_ehSetOmapBtn = new SetOmapBtnEventHander(OmapEventHander.SetOmapBtn);
            g_omapApi.SetEventHander(g_ehSetOmapBtn);
            g_ehGetWebSocketConf = new GetWebSocketConfEventHander(OmapEventHander.GetWebSocketConf);
            g_omapApi.SetEventHander(g_ehGetWebSocketConf);
            g_ehGetCusMap = new GetCustomMapEventHander(OmapEventHander.GetCusMapCfgList);
            g_omapApi.SetEventHander(g_ehGetCusMap);
            g_ehGetSysCoordProj = new GetSysCoordProjEventHander(OmapEventHander.GetSysCoordProj);
            g_omapApi.SetEventHander(g_ehGetSysCoordProj);
            g_ehGetOmapPluginVer = new GetOmapPluginVerEventHander(OmapEventHander.GetOmapPluginVer);
            g_omapApi.SetEventHander(g_ehGetOmapPluginVer);
            g_ehGetOmapWndRect = new GetOmapWndRectEventHander(OmapEventHander.GetOmapWndRect);
            g_omapApi.SetEventHander(g_ehGetOmapWndRect);
            g_ehGetMapShapeDetail = new GetMapShapeDetailEventHander(OmapEventHander.GetMapShapeDetai);
            g_omapApi.SetEventHander(g_ehGetMapShapeDetail);
            g_ehGetMapTrackDetail = new GetMapTrackDetailEventHander(OmapEventHander.GetMapTrackDetail);
            g_omapApi.SetEventHander(g_ehGetMapTrackDetail);
            g_ehGetMainBtn = new GetCusMainBtnEventHander(OmapEventHander.GetMainBtn);
            g_omapApi.SetEventHander(g_ehGetMainBtn);
            g_ehGetFavMenu = new GetCusFavMenuEventHander(OmapEventHander.GetFavMenu);
            g_omapApi.SetEventHander(g_ehGetFavMenu);
            g_ehGetObjEvent = new GetObjEventHander(OmapEventHander.GetObjEvent);
            g_omapApi.SetEventHander(g_ehGetObjEvent);
            g_ehGetCusMainMenuClickEvent = new GetCusMainMenuClickEventHander(OmapEventHander.GetCusMainMenuClick);
            g_omapApi.SetEventHander(g_ehGetCusMainMenuClickEvent);
            g_ehGetObjEventTirgger = new GetObjEventTirggerEventHander(OmapEventHander.GetObjEventTirgger);
            g_omapApi.SetEventHander(g_ehGetObjEventTirgger);
            g_ehGetObjCloseWnd = new GetObjCloseWndEventHander(OmapEventHander.GetObjCloseWnd);
            g_omapApi.SetEventHander(g_ehGetObjCloseWnd);
            #endregion
        }

        static public uint RGB(byte r, byte g, byte b)
        {
            return (uint)(((byte)(r) | ((ushort)((byte)(g)) << 8)) | (((ushort)(byte)(b)) << 16));
        }
        static public void SetOmapTmpSign(double lat, double lng, bool bGcj02 = false)
        {
            g_omapApi.SetOmapTmpSign(lat, lng, bGcj02);
        }
        static public void CleanOmapTmpObject()
        {
            g_omapApi.CleanOmapTmpObject();
        }
        static public long SetOmapObject(uint idObj, tagOApiObjGroup pGroup, uint idParent = 0, int iPosition = 0)
        {
            long iRet = g_omapApi.SetOmapObject(idObj, pGroup, idParent, iPosition);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public long SetOmapObject(uint idObj, tagOApiMapSign pSign, uint idParent = 0, int iPosition = 0)
        {
            long iRet = g_omapApi.SetOmapObject(idObj, pSign, idParent, iPosition);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public long SetOmapObject(uint idObj, tagOApiMapTrack pTrack, uint idParent = 0, int iPosition = 0)
        {
            long iRet = g_omapApi.SetOmapObject(idObj, pTrack, idParent, iPosition);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public long SetOmapObject(uint idObj, tagOApiMapShape pShape, uint idParent = 0, int iPosition = 0)
        {
            long iRet = g_omapApi.SetOmapObject(idObj, pShape, idParent, iPosition);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public long SetOmapObject(uint idObj, tagOApiMapDirections pDir, uint idParent = 0, int iPosition = 0)
        {
            long iRet = g_omapApi.SetOmapObject(idObj, pDir, idParent, iPosition);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int SetOmapLevelAndLocationExt(int iMapID, int iMapLevel, double x_lng, double y_lat, byte bActive, byte bReal, int iTimeoutMs = -1)
        {
            int iRet = g_omapApi.SetOmapLevelAndLocationExt(iMapID, iMapLevel, x_lng, y_lat, bActive, bReal, iTimeoutMs);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetLatlng()
        {
            int iRet = g_omapApi.GetLatlng();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int SetPicSignList(tagOphotoMapPicCli[] pOm)
        {
            int iRet = g_omapApi.SetPicSignList(pOm);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public void GeoDecodeLatlng(double lat, double lng, bool bGcj02 = false)
        {
            g_omapApi.GeoDecodeLatlng(lat, lng, bGcj02);
        }
        static public int GetLatlngByTime(tagOphotoMapPicCli[] pOmps)
        {
            int iRet = g_omapApi.GetLatlngByTime(pOmps);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetObjList(uint idParent)
        {
            int iRet = g_omapApi.GetOmapObjectList(idParent);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetObj(uint idObj, byte bLlType = 0)
        {
            int iRet = g_omapApi.GetOmapObject(idObj, bLlType);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int DelOmapObject(uint[] pidList, int nId, bool bNoGroup = false, bool bForceDel = false)
        {
            int iRet = g_omapApi.DelOmapObject(pidList, nId, bNoGroup, bForceDel);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public bool GetOmapVersion(ref int iVersion, ref string strAppPath)
        {
            RegistryKey key = Registry.CurrentUser;
            try
            {
                RegistryKey subKey = key.OpenSubKey("Software\\Ovital Software\\omap\\MainFrm");
                iVersion = 0;
                iVersion = (int)subKey.GetValue("LastVersion");
                strAppPath = (string)subKey.GetValue("LastRunPath");
                key.Close();
            }
            catch
            {
                MessageBox.Show("获取Omap版本号失败！");
                return false;
            }
            return true;


        }
        static public bool StartOmap(String strAppPath = null)
        {


            //IntPtr ParenthWnd = new IntPtr(0);
            IntPtr hwnd = FindWindow("omapWin", null);
            StringBuilder strInfo = new StringBuilder();
            if (hwnd == IntPtr.Zero)
            {
                if (strAppPath == null)
                {
                    int iVer = 0;
                    if (!GetOmapVersion(ref iVer, ref strAppPath))
                    {
                        return false;
                    }
                }
                try
                {
                    System.Diagnostics.Process.Start(strAppPath);
                }
                catch
                {
                    MessageBox.Show("注册表路径与实际路径不符");
                    return false;
                }
            }
            else
            {
                if (IsIconic(hwnd))
                {
                    ShowWindow(hwnd, SW_SHOW);
                }
                SetForegroundWindow(hwnd);
            }
            return true;

        }
        static public void BringWindowsToTop()
        {
            if (m_ParentHwnd != IntPtr.Zero)
            {
                if (IsIconic(m_ParentHwnd))
                {
                    ShowWindow(m_ParentHwnd, SW_SHOW);
                }
                SetForegroundWindow(m_ParentHwnd);
            }
            else
            {
                MessageBox.Show("请先调用函数[SetParentHandle]设置m_ParentHwnd！");
            }
        }
        static public int FollowObjChange(int iAppID = OmapDef.OAPI_APP_ID_ALL)
        {
            return g_omapApi.FollowObjChange(iAppID);
            // AlertErrSendOmapMsg(iRet);//iRet返回的可能是iAppID（负值）

        }
        static public int FollowWinMapInfo(int iFollowMs)
        {
            return g_omapApi.FollowWinMapInfo(iFollowMs);
        }
        static public void GetWinMapInfo(byte bRealLL)
        {
            g_omapApi.GetWinMapInfo(bRealLL);
        }
        static public void GetCoorPixelInfo(double lng_x, double lat_y)
        {
            g_omapApi.GetCoorPixelInfo(lng_x, lat_y);
        }
        static public void GetSysCoorCenter()
        {
            g_omapApi.GetSysCoorCenter();
        }
        static public void GetSysCoorInfo()
        {
            g_omapApi.GetSysCoorInfo();
        }
        static public void SetSysCoorPoint(int iCoorType, tagOApiRelatePoint[] pPoints)
        {
            g_omapApi.SetSysCoorPoint(iCoorType, pPoints);
        }
        static public void SetSysCoorPoint(int iCoorType, tagOApiRelatePoint pPoint)
        {
            g_omapApi.SetSysCoorPoint(iCoorType, pPoint);
        }
        static public int CheckInterfaceVer(int iType, int iVer, bool bSendReq)
        {
            int iRet = g_omapApi.CheckInterfaceVer(iType, iVer, bSendReq);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int ReqVip5Demo(bool bSend)
        {
            int iRet = g_omapApi.ReqVip5Demo(bSend);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetOmapStatusInfo()
        {
            int iRet = g_omapApi.GetOmapStatusInfo();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int SetOmapButton(int iAdd, String strTip, int iTimeoutMs = -1)
        {
            int iRet = g_omapApi.SetOmapButton(iAdd, strTip, iTimeoutMs);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetOmapMapData(double x_lng1, double y_lat1, double x_lng2, double y_lat2, long iMaxPixel, int iMaxLevel)
        {
            int iRet = g_omapApi.GetOmapMapData(x_lng1, y_lat1, x_lng2, y_lat2, iMaxPixel, iMaxLevel);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetOmapMapFile(tagOmapGetMapFileCli[] pReqs)
        {
            int iRet = g_omapApi.GetOmapMapFile(pReqs);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetOmapSelectList(int iFlag = 1)
        {
            int iRet = g_omapApi.GetOmapSelectList(iFlag);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int SetOmapSelectIdList(uint[] pidList)
        {

            int iRet = g_omapApi.SetOmapSelectIdList(pidList);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public uint GetPatItemId(string strPatName)
        {
            return g_omapApi.GetPatItemId(strPatName);
        }
        static public String GetPatItem(uint dwFillPattern)
        {
            return g_omapApi.GetPatItem(dwFillPattern);
        }
        static public tagOApiShapeFillCadPatItemCli GetPatItemDef(uint dwFillPattern)
        {
            return g_omapApi.GetPatItemDef(dwFillPattern);
        }
        /// <summary>
        /// 批量获取奥维中选中的所有对象
        /// </summary>
        /// <param name="bLlType"></param>
        /// <param name="bBatchGetObjTree">是否批量操作，0：每解析一条，调用一次EventHander;1:批量接收;2:返回树形结构
        /// <returns></returns>
        static public int GetOmapSelObjectTree(byte bLlType, byte bBatchGetObjTree = 0)
        {
            int iRet = g_omapApi.GetOmapSelObjectTree(bLlType, bBatchGetObjTree);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public void ReleaseRes()
        {
            g_omapApi.ReleaseRes();
        }
        //断点增加对象
        static public void PrePareSetObjTree(uint idParent)
        {
            g_omapApi.PrePareSetObjTree(idParent);
        }
        static public bool AddObjTree(tagOApiObjTree pObjTree, uint idParent)
        {
            return g_omapApi.AddObjTree(pObjTree, idParent);
        }
        static public int CommitObjTree()
        {
            int iRet = g_omapApi.CommitObjTree();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        //一次性增加
        static public int SetOmapSelObjectTree(tagOApiObjTree pObjTree, uint idParent)
        {
            return g_omapApi.SetOmapSelObjectTree(pObjTree, idParent);
        }
        static public int GetOmapContour(tagOmapReqContourCli pReq)
        {
            int iRet = g_omapApi.GetOmapContour(pReq);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        /// <summary>
        /// 此函数一般在第一次作为查询之后进行调用。
        /// </summary>
        /// <returns></returns>
        static public int ReGetContour()
        {
            int iRet = g_omapApi.ReGetOmapContour();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int SrhOmapObject(tagOApiObjectSrhReqCli pSrhReq)
        {
            int iRet = g_omapApi.SrhOmapObject(pSrhReq);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetWebSocketConf()
        {
            int iRet = g_omapApi.GetWebSocketConf();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int SetSysCoordProj(tagPrj prj)
        {

            int iRet = g_omapApi.SetSysCoordProj(prj);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetSysCoordProj()
        {
            int iRet = g_omapApi.GetSysCoordProj();
            AlertErrSendOmapMsg(iRet);
            return iRet;

        }

        static public int GetCusMapCfgList()
        {
            int iRet = g_omapApi.GetCusMapCfgList();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetOmapPluginVer()
        {
            int iRet = g_omapApi.GetOmapPluginVer();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetOmapWndRect()
        {
            int iRet = g_omapApi.GetOmapWndRect();
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetMapShapeDetail(uint idObj)
        {
            int iRet = g_omapApi.GetMapShapeDetail(idObj);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int GetMapTrackDetail(uint idObj)
        {
            int iRet = g_omapApi.GetMapTrackDetail(idObj);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static public int SetCmdCusWnd(tagCusShowWnd cusShowWnd)
        {
            int iRet = g_omapApi.SetCmdCusWnd(cusShowWnd);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int SetCusMainBtn(int size)
        {
            int iRet = g_omapApi.SetCusMainBtn(size);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int DelCusMainBtn(int[] ids, int nCnt)
        {
            int iRet = g_omapApi.DelCusMainBtn( ids,nCnt);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int QueryCusMainBtn(int[] ids, int nCnt)
        {
            int iRet = g_omapApi.QueryCusMainBtn(ids, nCnt);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int SetCusFavMenu(int size)
        {
            int iRet = g_omapApi.SetCusFavMenu(size);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int DelCusFavMenu(int[] ids, int nCnt)
        {
            int iRet = g_omapApi.DelCusFavMenu(ids, nCnt);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }

        static public int QueryCusFavMenu(int[] ids, int nCnt)
        {
            int iRet = g_omapApi.QueryCusFavMenu(ids, nCnt);
            AlertErrSendOmapMsg(iRet);
            return iRet;
        }
        static int a = 0;
        static public int SetObjEvent()
        {
            int iRet = 0;
            if (a % 3 == 0)
            {
                iRet = g_omapApi.SetObjEvent(OmapDef.OAPI_MAP_OBJ_EVENT_NONE);
            }
            else if (a % 3 == 1)
            {
                iRet = g_omapApi.SetObjEvent(OmapDef.OAPI_MAP_OBJ_EVENT_SEND_ONLY);
            }
            else if (a % 3 == 2)
            {
                iRet = g_omapApi.SetObjEvent(OmapDef.OAPI_MAP_OBJ_EVENT_SEND_EXT);
            }
            a++;

            return iRet;
        }

        static public int SetCumMainMenu()
        {
            int iRet = g_omapApi.SetCusMainMenu();
            if(iRet == 0)
            {
                Program.g_omapTest.m_edit_Result.Text = "成功";
            }
            return iRet;
        }

        static public int DelCusMainMenu()
        {
            int iRet = g_omapApi.DelCusMainMenu();
            return iRet;
        }

        static public int SetObjShowWnd(tagMapObjEvent pMoe, byte bCloseType, byte bCloseEvent)
        {
            tagMapObjShowWnd pMoss = new tagMapObjShowWnd();
            pMoss.ptMapWnd = pMoe.ptClickOfMap;
            pMoss.sizeObjWnd = new tagSIZECli();

            pMoss.sizeObjWnd.cx = 400;
            pMoss.sizeObjWnd.cy = 500;
            pMoss.idObj = pMoe.idObj;
            pMoss.bCloseEvent = bCloseEvent;
            pMoss.bCloseType = bCloseType;

            pMoss.pHtml = "<?ovital_ct name=\"ovital_sample\">{\"user\": \"Andy\",\"birthday\" : \"\",\"sex\" : \"man\",\"Marital_status\" : false,\"work_address\" : \"0\"}"; ;
            pMoss.nHtml = pMoss.pHtml.Length;

            int iRet = g_omapApi.SetObjShowWnd(pMoss);
            return iRet;
        }

        static public int QueryCusShowWnd(int idWnd)
        {
           int iRet =  g_omapApi.QueryCusShowWnd(idWnd);
            return iRet;
        }

        static public int DelCusShowWnd(int idWnd)
        {
            int iRet = g_omapApi.DelCusShowWnd(idWnd);
            return iRet;
           
        }

        static public int MoveOmapObject(int idParent, int nIndexInParent, int[] pidList, int nId)
        {
            int iRet = g_omapApi.MoveOmapObject(idParent, nIndexInParent, pidList, nId);
            AlertErrSendOmapMsg(iRet);//如果iRet = 0 表示移动成功
            return iRet;
        }
    }
    
}
