#include "StdAfx.h"
#include "PolygonClip.h"
// #include "CircleLib.h"
// #include "EllipseLib.h"

#include "opennurbs_nurbscurve.h"




std::vector<tagPointClip> MyGetCircleSample(std::vector<tagPointClip> tagCircle, double dStart, double dEnd,  bool isYAxixToDown,int iPer = 2)
{
	if (isYAxixToDown)
	{
		double temp = dStart;
		dStart = 360 - dEnd;
		dEnd = 360 - temp;
	}
	std::vector<tagPointClip> sv;
	if (tagCircle.size() == 2)
	{
		tagPointClip p1 = tagCircle.at(0);
		tagPointClip p2 = tagCircle.at(1);
		ON_Plane p(ON_3dPoint(p1.x, p1.y, 0), ON_3dVector(1, -0, 0), ON_3dVector(0, 1, 0));
		double dRadius = sqrt((p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y));
		ON_Circle c(p, dRadius);
		for (double i = dStart; i < dEnd; i += iPer)
		{
			ON_3dPoint p = c.PointAt(ON_PI*i / 180);
			tagPointClip tag;
			tag.x = p.x;
			tag.y = p.y;
			sv.push_back(tag);
		}
		if (!(dStart == 0 && dEnd == 360))
		{
			tagPointClip p;
			ON_3dPoint p3 = c.PointAt(ON_PI*dEnd / 180);
			p.x = p3.x;
			p.y = p3.y;
			sv.push_back(p);
			sv.push_back(p1);
		}
	}
	return sv;
}

void MyGetXyInEllipse(tagPointClip p1, tagPointClip p2, double dAngle, double& x, double &y)
{
	dAngle = dAngle*ON_PI / 180;
	double left = p1.x < p2.x ? p1.x : p2.x;
	double right = p1.x > p2.x ? p1.x : p2.x;
	double top = p1.y > p2.y ? p1.y : p2.y;
	double bottom = p1.y < p2.y ? p1.y : p2.y;
	double a = right - left;
	double b = top - bottom;
	a = a / 2;
	b = b / 2;
	if (a == 0 || b == 0)
	{
		x = left + a;
		y = top + b;
		return;
	}

	double ang = dAngle;
	while (ang < -ON_PI)
		ang += 2 * ON_PI;
	while (ang > ON_PI)
		ang -= 2 * ON_PI;

	if (fabs((fabs(ang) - ON_PI / 2)) < 1e-6)
	{
		x = 0;
		if (ang > 0)
			y = b;
		else
			y = -b;
	}
	else
	{
		double k = tan(ang);
		x = sqrt(1 / (1 / (a*a) + (k*k) / (b*b)));
		if (ang > ON_PI / 2 || ang < -ON_PI / 2)
			x = -x;
		y = k*x;
	}

	// y᷽෴
	//y = -y;

	double cx = (left + right) / 2;
	double cy = (top + bottom) / 2;
	x += cx;
	y += cy;
}
double convertAngle(double dOrg, double dToConvert)
{
	if (dOrg > 0 && dOrg<180)
	{
		return dToConvert;
	}
	else if (dOrg>180 && dOrg < 360)
	{
		return 360 - dToConvert;
	}
	else if (dOrg>360 && dOrg < 540)
	{
		return dToConvert + 360;
	}
	else
	{
		return dOrg;
	}
}

std::vector<tagPointClip> MyGetEllipseSample(std::vector<tagPointClip> tagEllipse, double dStart, double dEnd, bool isYAxixToDown, int iPer = 2)
{
	if (isYAxixToDown)
	{
		double temp = dStart;
		dStart  = 360-dEnd;
		dEnd = 360-temp;
	}
	ON_3dPoint pCenter;
	ON_3dVector vX, vY;
	double dA = 0, dB = 0;
	if (tagEllipse.size() == 2)
	{
		tagPointClip p1 = tagEllipse.at(0);
		tagPointClip p2 = tagEllipse.at(1);

		pCenter.x = (p1.x + p2.x) / 2;
		pCenter.y = (p1.y + p2.y) / 2;
		dA = fabs(p1.x - pCenter.x);
		dB = fabs(p1.y - pCenter.y);
		vX = ON_3dVector(dA, 0, 0);
		vY = ON_3dVector(0, dB, 0);

	}
	else if (tagEllipse.size() == 3)
	{
		tagPointClip p1 = tagEllipse.at(0);
		tagPointClip p2 = tagEllipse.at(1);
		tagPointClip p3 = tagEllipse.at(2);

		/*	p1.x = 0;
		p1.y = 1;
		p2.x = 3;
		p2.y = 0;
		p3.x = 1;
		p3.y = 1;
		*/
		pCenter.x = p1.x;
		pCenter.y = p1.y;
		dA = sqrt((p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y));
		dB = sqrt((p1.x - p3.x)*(p1.x - p3.x) + (p1.y - p3.y)*(p1.y - p3.y));
		vX = ON_3dVector(p2.x - p1.x, p2.y - p1.y, 0);
		ON_3dVector v = vX*dB / dA;
		vY = ON_3dVector(-v.y, v.x, 0);
		//vY.Rotate(ON_PI / 2, ON_3dVector(1, 0, 0));

	}
	ON_Plane plane(pCenter, vX, vY);
	ON_Ellipse e(plane, dA, dB);
	std::vector<tagPointClip> svPoints;
	tagPointClip tStart, tEnd;
	bool bPart = !(dStart == 0 && dEnd == 360) && tagEllipse.size() == 2;
	if (bPart)
	{

		MyGetXyInEllipse(tagEllipse.at(0), tagEllipse.at(1), dEnd, tEnd.x, tEnd.y);
		MyGetXyInEllipse(tagEllipse.at(0), tagEllipse.at(1), dStart, tStart.x, tStart.y);
		if ((int)dStart % 90 != 0)
		{
			double dtemp = acos((tStart.x - pCenter.x) / dA) * 180 / ON_PI;
			dStart = convertAngle(dStart, dtemp);
		}
		if ((int)dEnd % 90 != 0)
		{
			double dtemp = acos((tEnd.x - pCenter.x) / dA) * 180 / ON_PI;
			dEnd = convertAngle(dEnd, dtemp);

		}
		if (dEnd<dStart)
		{
			dEnd += 360;
		}
		svPoints.push_back(tEnd);
		tagPointClip p;
		p.x = pCenter.x;
		p.y = pCenter.y;
		svPoints.push_back(p);
		//svPoints.push_back(tStart);
	}
	for (double i = dStart; i < dEnd; i += iPer)
	{
		ON_3dPoint p = e.PointAt(ON_PI*i / 180);
		/*if (bPart)
		{
		double d = atan2((p.y - pCenter.y), (p.x - pCenter.x));
		double d2 = d / ON_PI * 180;
		if (d2<0)
		{
		d2 += 360;
		}
		if (d2<dStart)
		{
		continue;
		}
		else if (d2>dEnd)
		{
		break;
		}
		}*/
		tagPointClip tag;
		tag.x = p.x;
		tag.y = p.y;
		svPoints.push_back(tag);
	}
	return svPoints;
}


CLineClip::CLineClip(PointClip pStart, PointClip pEnd)
{
	this->pStart = pStart;
	this->pEnd = pEnd;
	a = pStart.m_Y - pEnd.m_Y;
	b = pEnd.m_X - pStart.m_X;
	c = pStart.m_X*pEnd.m_Y - pEnd.m_X*pStart.m_Y;
}
CLineClip::CLineClip()
{

}
void CLineClip::calculateABC()
{
	a = pStart.m_Y - pEnd.m_Y;
	b = pEnd.m_X - pStart.m_X;
	c = pStart.m_X*pEnd.m_Y - pEnd.m_X*pStart.m_Y;
}
CLineClip::~CLineClip()
{
}

double Maxdouble(double d1, double d2)
{
	return d1 > d2 ? d1 : d2;
}
double Mindouble(double d1, double d2)
{
	return d1 < d2 ? d1 : d2;
}


bool CLineClip::GetCrossPoint(CLineClip l1, CLineClip l2, PointClip& pCross)
{
	double D;
	D = l1.a*l2.b - l2.a*l1.b;
	if (D == 0)
		return false;
	//PointClip p;
	pCross.m_X = (l1.b*l2.c - l2.b*l1.c) / D;
	pCross.m_Y = (l1.c*l2.a - l2.c*l1.a) / D;
	double dxMax = 0;
	double dxMin = 0;
	double dyMax = 0;
	double dyMin = 0;
	dxMax = Mindouble(Maxdouble(l1.pStart.m_X, l1.pEnd.m_X), Maxdouble(l2.pStart.m_X, l2.pEnd.m_X));
	dyMax = Mindouble(Maxdouble(l1.pStart.m_Y, l1.pEnd.m_Y), Maxdouble(l2.pStart.m_Y, l2.pEnd.m_Y));
	dxMin = Maxdouble(Mindouble(l1.pStart.m_X, l1.pEnd.m_X), Mindouble(l2.pStart.m_X, l2.pEnd.m_X));
	dyMin = Maxdouble(Mindouble(l1.pStart.m_Y, l1.pEnd.m_Y), Mindouble(l2.pStart.m_Y, l2.pEnd.m_Y));
	double dTol = 1;
	if (pCross.m_X - dxMax >dTol || dxMin - pCross.m_X>dTol || pCross.m_Y - dyMax >dTol || dyMin - pCross.m_Y > dTol)
	{
		return false;
	}
	return true;
}
CPolygonClip::CPolygonClip()
{
}


CPolygonClip::~CPolygonClip()
{
}
std::vector<tagPointClip> CPolygonClip::getFirstPart(std::vector<tagPointClip> pPointsSrc,
	std::vector<tagPointCross> pCrosses, bool bSrcOrderd)
{
	std::vector<tagPointClip> vsPoints;
	tagPointCross pCross = pCrosses.at(bSrcOrderd ? 0 : 1);
	int iEnd = pCross.iNext;
	if (pCross.iNextType == LINE_START)
	{
		iEnd--;
	}
	for (int i = 0; i < iEnd;i++)
	{
		vsPoints.push_back(pPointsSrc.at(i));
	}
	return vsPoints;
}
std::vector<tagPointClip> CPolygonClip::getSecondPart(std::vector<tagPointClip> pPointsSrc,
	std::vector<tagPointCross> pCrosses, bool bSrcOrderd)
{
	std::vector<tagPointClip> vsPoints;
	
	
	tagPointCross pFirst = pCrosses.at(bSrcOrderd ? 0 : 1);
	tagPointCross pSecond = pCrosses.at(bSrcOrderd ? 1 : 0);
	int iStart = pFirst.iNext;
	if (pFirst.iNextType == LINE_END)
	{
		iStart++;
	}
	int iEnd = pSecond.iNext;
	if (pSecond.iNextType == LINE_START)
	{
		iEnd--;
	}
	for (int i = iEnd - 1; i > iStart - 1; i--)
	{
		vsPoints.push_back(pPointsSrc.at(i));
	}

	return vsPoints;
}
std::vector<tagPointClip> CPolygonClip::getThirdPart(std::vector<tagPointClip> pPointsSrc,
	std::vector<tagPointCross> pCrosses, bool bSrcOrderd)
{
	std::vector<tagPointClip> vsPoints;
	tagPointCross pCross = pCrosses.at(bSrcOrderd ? 1 : 0);
	int iStart = pCross.iNext;
	if (pCross.iNextType ==LINE_END)
	{
		iStart++;
	}
	for (int i = iStart; i < (int)pPointsSrc.size();i++)
	{
		vsPoints.push_back(pPointsSrc.at(i));
	}
	return vsPoints;
}
std::vector<tagPointClip> CPolygonClip::getForthPart(std::vector<tagPointClip> pPointsClip,
	std::vector<tagPointCross> pCrosses, bool bSrcOrderd, bool bClipOrderd)
{
	std::vector<tagPointClip> vsPoints;
	tagPointCross pFirst = pCrosses.at(0);
	tagPointCross pSecond = pCrosses.at(1);
	int iStart = 0, iEnd = 0;
	if (bSrcOrderd)
	{
		iStart = pFirst.iNextClipLine;
		if (pFirst.iNextClipType == LINE_END)
		{
			iStart++;
		}
		iEnd = pSecond.iNextClipLine;
		if (pSecond.iNextClipType == LINE_START)
		{
			iEnd--;
		}
		for (int i = iStart; i < iEnd;i++)
		{
			vsPoints.push_back(pPointsClip.at(i));
		}
	}
	else
	{
		iStart = pSecond.iNextClipLine-1;
		if (pSecond.iNextClipType == LINE_START)
		{
			iStart--;
		}
		iEnd = pFirst.iNextClipLine;
		if (pFirst.iNextClipType == LINE_END)
		{
			iEnd++;
		}
		for (int i = iStart; i > iEnd - 1;i--)
		{
			vsPoints.push_back(pPointsClip.at(i));
		}
	}
	return vsPoints;
}
void CPolygonClip::CombineClips(std::vector<tagPointClip> &clips1, std::vector<tagPointClip> &clips2,
	std::vector<tagPointClip> pPointsSrc, std::vector<tagPointClip> pPointsClip,
	std::vector<tagPointCross> pCrosses, bool bSrcOrderd, bool bClipOrderd)
{
	std::vector<tagPointClip> c1, c2, c3, c4;
	c1 = getFirstPart(pPointsSrc, pCrosses, bSrcOrderd);
	c2 = getSecondPart(pPointsSrc, pCrosses, bSrcOrderd);
	c3 = getThirdPart(pPointsSrc, pCrosses, bSrcOrderd);
	c4 = getForthPart(pPointsClip, pCrosses, bSrcOrderd, bClipOrderd);
	clips1.assign(c1.begin(), c1.end());
	tagPointCross pFirst = pCrosses.at(0);
	tagPointCross pSecond = pCrosses.at(1);
	tagPointClip p1,p2;
	if (bSrcOrderd)
	{
		p1.x = pFirst.x;
		p1.y = pFirst.y;
		p2.x = pSecond.x;
		p2.y = pSecond.y;
	}
	else
	{
		p2.x = pFirst.x;
		p2.y = pFirst.y;
		p1.x = pSecond.x;
		p1.y = pSecond.y;
	}
	clips1.push_back(p1);
	//clips1.assign(c4.begin(), c4.end());
	for (int i = 0; i <(int) c4.size();i++)
	{
		clips1.push_back(c4.at(i));
	}
	clips1.push_back(p2);
	//clips1.assign(c3.begin(), c3.end());
	for (int i = 0; i < (int)c3.size(); i++)
	{
		clips1.push_back(c3.at(i));
	}
	clips2.push_back(p1);
	//clips2.assign(c4.begin(), c4.end());
	for (int i = 0; i <(int)c4.size(); i++)
	{
		clips2.push_back(c4.at(i));
	}
	clips2.push_back(p2);
	//clips2.assign(c2.begin(), c2.end());
	for (int i = 0; i < (int)c2.size(); i++)
	{
		clips2.push_back(c2.at(i));
	}
}
bool CPolygonClip::PointInShape(std::vector<tagPointClip> pPointsSrc, tagPointClip PointTrg)
{
	int iSrc = (int)pPointsSrc.size();
	double yTrg = PointTrg.y;
	double xTrg = PointTrg.x;
	int iInter = 0;
	for (int j = 0; j < iSrc; j++)
	{
		tagPointClip p1 = pPointsSrc.at(j);
		tagPointClip p2 = pPointsSrc.at(j + 1 == iSrc ? 0 : j + 1);
		if (p1.x == p2.x&&p1.y == p2.y)
		{
			if (p1.y == yTrg&&p1.x >= xTrg)
			{
				return false;
			}

		}
		else if (p1.y == p2.y)
		{
			if (p1.y == yTrg)
			{

				double dmax = p1.x > p2.x ? p1.x : p2.x;
				double dmin = p1.x < p2.x ? p1.x : p2.x;
				if (dmin<=xTrg&&xTrg<=dmax)
				{
					return false;
				}
				if (xTrg<dmin)
				{
					iInter++;
					j++;
				}
			}

		}
		else if (p1.x == p2.x)
		{
			if (p1.x > xTrg)
			{
				double dmax = p1.y > p2.y ? p1.y : p2.y;
				double dmin = p1.y < p2.y ? p1.y : p2.y;
				if (dmin <= yTrg&&xTrg <= yTrg)
				{
					return false;
				}
				if (yTrg<dmax&&yTrg >= dmin)
				{
					iInter++;
				}
			}
		}
		else
		{
			double dmaxy = p1.y>p2.y ? p1.y : p2.y;
			double dminy = p1.y < p2.y ? p1.y : p2.y;
			if ((p1.x == xTrg&&p1.y == yTrg) || (p2.x ==xTrg&&p2.y == yTrg))
			{
				return false;
			}
			if (yTrg >= dminy&&yTrg<dmaxy)
			{

				double x = (yTrg - p1.y)*(p2.x - p1.x) / (p2.y - p1.y) + p1.x;
				if (x ==xTrg)
				{
					return false;
				}
				double dmaxx = p1.x>p2.x ? p1.x : p2.x;
				double dminx = p1.x < p2.x ? p1.x : p2.x;
				if (x > xTrg&&x >= dminx&&x < dmaxx)
				{
					iInter++;
				}
			}
		}
	}
	if (iInter % 2 == 0)
	{
		return false;
	}
	else
	{
		return true;
	}
}
void CPolygonClip::Get2ClosePoints(tagPointClip POrg, std::vector<tagPointCross> pCrossesSrc, std::vector<tagPointCross> &pCrossesTrg)
{
	pCrossesTrg.clear();

	std::vector<double> vlen;
	for (int j = 0; j <(int)pCrossesSrc.size(); j++)
	{
		double len = (pCrossesSrc.at(j).x - POrg.x)*(pCrossesSrc.at(j).x - POrg.x) + (pCrossesSrc.at(j).y - POrg.y)*(pCrossesSrc.at(j).y - POrg.y);
		vlen.push_back(len);
	}
	int Index1 = 0, Index2 = 1;
	if (vlen.at(Index1)>vlen.at(Index2))
	{
		Index1 = 1;
		Index2 = 0;
	}
	for (int i = 2; i < (int)vlen.size(); i++)
	{
		if (vlen.at(Index2)>vlen.at(i))
		{
			//Index1 = i;
			if (vlen.at(Index1) > vlen.at(i))
			{
				Index2 = Index1;
				Index1 = i;
			}
			else
			{
				Index2 = i;
			}
		}
	}
	pCrossesTrg.push_back(pCrossesSrc.at(Index1));
	pCrossesTrg.push_back(pCrossesSrc.at(Index2));
}
bool CPolygonClip::clipPolygon(std::vector<tagPointClip> pPointsSrc, std::vector<tagPointClip> pPointsClip, std::vector<tagPointClip>& vClip1, std::vector<tagPointClip>& vClip2)
{
	vClip1.empty();
	vClip2.empty();
	int iSize = (int)pPointsSrc.size();
	int iSizeClip = (int)pPointsClip.size();
	std::vector<tagPointCross> pCrosses;

	std::vector<tagPointCross> pCrossesSameSeg;
	//εıи󽻵㣬Ŀҵ㼴ֹͣ2018.7.15
	for (int i = 0; i < iSizeClip-1; i++)
	{
		pCrossesSameSeg.clear();
		double dx= pPointsClip.at(i).x;
		double dy = pPointsClip.at(i).y;
		CLineClip l2(PointClip(0, 0), PointClip(pPointsClip.at(i + 1).x-dx, pPointsClip.at(i + 1).y-dy));
		for (int j = 0; j < iSize;j++)
		{
			
			CLineClip l1;
			l1.pStart = PointClip(pPointsSrc.at(j).x-dx, pPointsSrc.at(j).y-dy);
			if (j < iSize - 1)
			{
				l1.pEnd = PointClip(pPointsSrc.at(j + 1).x - dx, pPointsSrc.at(j + 1).y - dy);
			}
			else
			{
				if (pPointsSrc.at(j).x == pPointsSrc.at(0).x&&pPointsSrc.at(j).y == pPointsSrc.at(0).y)
				{
					break;
				}
				l1.pEnd = PointClip(pPointsSrc.at(0).x - dx, pPointsSrc.at(0).y - dy);
			}
			l1.calculateABC();
			PointClip pCross;
			//󽻵
			bool br = CLineClip::GetCrossPoint(l1, l2, pCross);
			if (br == false)
			{
				continue;
			}
			pCross.m_X += dx;
			pCross.m_Y += dy;
			if (pCrosses.size() == 1)
			{
				if (pCrosses.at(0).x == pCross.m_X&&pCrosses.at(0).y == pCross.m_Y)
				{
					continue;
				}
			}
			if (br)
			{
				if (pCrosses.size() == 0)
				{
					bool bInShape = PointInShape(pPointsSrc, pPointsClip.at(i));
					if (bInShape)
					{
						continue;
					}
				}

				tagPointCross p;
				p.x = pCross.m_X;
				p.y = pCross.m_Y;
				//жϽиϵλ
				p.iNextClipLine = i + 1;
				if (p.x == pPointsClip.at(i).x&&p.y == pPointsClip.at(i).y)
				{
					//ڸöε
					p.iNextClipType = LINE_START;
				}
				else if (p.x == pPointsClip.at(i + 1).x && p.y == pPointsClip.at(i+1).y)
				{
					p.iNextClipType = LINE_END;
				}
				else
				{
					p.iNextClipType = LINE_MIDDLE;
					
				}
				p.iNext = j+1;
				if (p.x == pPointsSrc.at(j).x&&p.y == pPointsSrc.at(j).y)
				{
					p.iNextType = LINE_START;
					
				}
				else if (p.x-dx == l1.pEnd.m_X&&p.y-dy == l1.pEnd.m_Y)
				{
					p.iNextType = LINE_END;
					continue;
				}
				else
				{
					p.iNextType = LINE_MIDDLE;
				}/*
				if (pCrosses.size()==1)
				{
					if (pCrosses.at(0).iNext == p.iNext - 1 && pCrosses.at(0).iNextType==LINE_END&&
						p.iNextType ==LINE_START)
					{
						continue;
					}
				}*/
				pCrossesSameSeg.push_back(p);
			}
		}
		if (pCrosses.size() == 0)
		{
			if (pCrossesSameSeg.size() == 1)
			{
				pCrosses.push_back(pCrossesSameSeg.at(0));
			}
			else if (pCrossesSameSeg.size() > 1)
			{
				Get2ClosePoints(pPointsClip.at(i), pCrossesSameSeg, pCrosses);
				break;
			}
		}
		else if (pCrosses.size() == 1)
		{
			if (pCrossesSameSeg.size() == 1)
			{
				pCrosses.push_back(pCrossesSameSeg.at(0));
				break;
			}
			else if (pCrossesSameSeg.size() > 1)
			{
				std::vector<tagPointCross> vsPoint;
				Get2ClosePoints(pPointsClip.at(i), pCrossesSameSeg, vsPoint);
				pCrosses.push_back(vsPoint.at(0));
				break;
			}
		}
		if (pCrosses.size() == 2)
		{
			break;
		}
	}
	if (pCrosses.size() == 2)
	{
		tagPointCross pFirst,pSecond;
		
		pFirst = pCrosses.at(0);
		pSecond = pCrosses.at(1);
		
		bool bSrcOrderd = true;//жеǷ͹켣˳һ
		if (pFirst.iNext>pSecond.iNext)
		{
			bSrcOrderd = false;
		}
		else if (pFirst.iNext==pSecond.iNext)
		{
			double dis1 = (pFirst.x - pPointsSrc.at(pFirst.iNext - 1).x)*(pFirst.x - pPointsSrc.at(pFirst.iNext - 1).x) +
				(pFirst.y - pPointsSrc.at(pFirst.iNext - 1).y)*(pFirst.y - pPointsSrc.at(pFirst.iNext - 1).y);
			double dis2 = (pSecond.x - pPointsSrc.at(pFirst.iNext - 1).x)*(pSecond.x - pPointsSrc.at(pFirst.iNext - 1).x) +
				(pSecond.y - pPointsSrc.at(pFirst.iNext - 1).y)*(pSecond.y - pPointsSrc.at(pFirst.iNext - 1).y);
			if (dis1>dis2)
			{
				bSrcOrderd = false;
			}
		}
		bool bClipOrderd = true;//жϽϵ˳Ƿһ
		if (pFirst.iNextClipLine>pSecond.iNextClipLine)
		{
			bClipOrderd = false;
		}
		else if (pFirst.iNextClipLine==pSecond.iNextClipLine)
		{
			double dis1 = (pFirst.x - pPointsClip.at(pFirst.iNextClipLine - 1).x)* (pFirst.x - pPointsClip.at(pFirst.iNextClipLine - 1).x) +
				(pFirst.y - pPointsClip.at(pFirst.iNextClipLine - 1).y)* (pFirst.y - pPointsClip.at(pFirst.iNextClipLine - 1).y);
			double dis2 = (pSecond.x - pPointsClip.at(pFirst.iNextClipLine - 1).x)* (pSecond.x - pPointsClip.at(pFirst.iNextClipLine - 1).x) +
				(pSecond.y - pPointsClip.at(pFirst.iNextClipLine - 1).y)* (pSecond.y - pPointsClip.at(pFirst.iNextClipLine - 1).y);
			if (dis1 > dis2)
			{
				bClipOrderd = false;
			}
		}
		
		CombineClips(vClip1, vClip2, pPointsSrc, pPointsClip, pCrosses, bSrcOrderd, bClipOrderd);
		return true;
	}
	else
	{
		return false;
	}
}

#if 0
bool CPolygonClip::clipCADTrack(tagOApiMapTrackV1 *pTrackSrc, tagOApiMapTrackV1 *pTrackClip, tagOApiMapTrackV1* pTrackClip1, tagOApiMapTrackV1* pTrackClip2, bool isYAxixToDown)
{
	if (pTrackClip1 == NULL || pTrackClip2 == NULL)
	{
		return false;
	}


	std::vector<tagPointClip> pPointsSrc;
	std::vector<tagPointClip> pPointsClip;
	std::vector<tagPointClip> vClip1;
	std::vector<tagPointClip> vClip2;

	if (pTrackSrc->mtd.iShowType==9)//Բ
	{
		std::vector<tagPointClip> pPoints;
		for (int i = 0; i < pTrackSrc->nMtp;i++)
		{
			tagPointClip p;
			p.x = pTrackSrc->pMtp[i].lng;
			p.y = pTrackSrc->pMtp[i].lat;
			pPoints.push_back(p);
		}
		std::vector<tagPointClip> sv = MyGetEllipseSample(pPoints, pTrackSrc->pMtp[0].dCadBulge, pTrackSrc->pMtp[1].dCadBulge,isYAxixToDown);
		pPointsSrc.assign(sv.begin(), sv.end());

		/*char strUtf8[1000];
		strcpy(strUtf8, pTrackSrc->strName);
		strcat(strUtf8, "_1");
		tagOApiMapTrackV1* pTrack = g_omapApi.NewOmapTrack();;
		strncpy_s(pTrack->strName, strUtf8, strlen(strUtf8));
		pTrack->nMtp = sv.size();
		pTrack->pMtp = (tagOApiMapTrackPointV1*)OApiZeroMalloc(sizeof(tagOApiMapTrackPointV1)* pTrack->nMtp);
		for (int i = 0; i < pTrack->nMtp; i++)
		{
			pTrack->pMtp[i].lat = sv.at(i).y;
			pTrack->pMtp[i].lng = sv.at(i).x;
		}
		int r = g_omapApi.SetOmapObject(0, pTrack, 0, 0);
		g_omapApi.FreeOmapObject(pTrack, OMAP_OBJ_TYPE_TRACK);*/
		
	}
	else if (pTrackSrc->mtd.iShowType == 7)//Բ
	{
		std::vector<tagPointClip> pPoints;
		for (int i = 0; i < pTrackSrc->nMtp; i++)
		{
			tagPointClip p;
			p.x = pTrackSrc->pMtp[i].lng;
			p.y = pTrackSrc->pMtp[i].lat;
			pPoints.push_back(p);
		}
		std::vector<tagPointClip> sv = MyGetCircleSample(pPoints, pTrackSrc->pMtp[0].dCadBulge, pTrackSrc->pMtp[1].dCadBulge,isYAxixToDown);
		pPointsSrc.assign(sv.begin(), sv.end());

	}
	else
	{
		return false;
	}
	for (int i = 0; i < pTrackClip->nMtp; i++)
	{
		tagPointClip p;
		p.x = pTrackClip->pMtp[i].lng;
		p.y = pTrackClip->pMtp[i].lat;
		pPointsClip.push_back(p);
	}
	bool brc = clipPolygon(pPointsSrc, pPointsClip, vClip1, vClip2);
	if (brc)
	{
		char strUtf8[1000];
		strcpy(strUtf8, pTrackSrc->strName);
		strcat(strUtf8, "_1");
		char strUtf82[1000];
		strcpy(strUtf82, pTrackSrc->strName);
		strcat(strUtf82, "_2");
		tagOApiMapTrackV1* pTrack = pTrackClip1;
		strncpy_s(pTrack->strName, strUtf8, strlen(strUtf8));
		pTrack->nMtp = (int)vClip1.size();
		pTrack->pMtp = (tagOApiMapTrackPointV1*)OApiZeroMalloc(sizeof(tagOApiMapTrackPointV1)* pTrack->nMtp);
		for (int i = 0; i < pTrack->nMtp; i++)
		{
			pTrack->pMtp[i].lat = vClip1.at(i).y;
			pTrack->pMtp[i].lng = vClip1.at(i).x;
		}
		int r = g_omapApi.SetOmapObject(0, pTrack, 0, 0);
		//g_omapApi.FreeOmapObject(pTrack, OMAP_OBJ_TYPE_SHAPE);

		if (r != 0)
			return false;
		tagOApiMapTrackV1* pTrack2 = pTrackClip2;
		strncpy_s(pTrack2->strName, strUtf82, strlen(strUtf8));
		pTrack2->nMtp = (int)vClip2.size();
		pTrack2->pMtp = (tagOApiMapTrackPointV1*)OApiZeroMalloc(sizeof(tagOApiMapTrackPointV1)* pTrack2->nMtp);
		for (int i = 0; i < pTrack2->nMtp; i++)
		{
			pTrack2->pMtp[i].lat = vClip2.at(i).y;
			pTrack2->pMtp[i].lng = vClip2.at(i).x;
		}
		r = g_omapApi.SetOmapObject(0, pTrack2, 0, 0);
		//g_omapApi.FreeOmapObject(pTrack2, OMAP_OBJ_TYPE_SHAPE);

		if (r != 0)
			return false;
		return true;
	}
	return false;
	return false;
}
#endif

bool CPolygonClip::clipShape(tagOApiMapShapeV1 *pShapeSrc, tagOApiMapTrackV1 *pTrackClip, tagOApiMapShapeV1 *pShapeClip1, tagOApiMapShapeV1 *pShapeClip2, bool isYAxixToDown)
{
	
	if (pShapeClip1 == NULL || pShapeClip2 == NULL)
	{
		return false;
	}

	
	std::vector<tagPointClip> pPointsSrc;
	std::vector<tagPointClip> pPointsClip;
	std::vector<tagPointClip> vClip1;
	std::vector<tagPointClip> vClip2;
	
	
	if (pShapeSrc->nMtp == 2)
	{
		if (pShapeSrc->dStartAngle==0&&pShapeSrc->dEndAngle==0)
		{
			tagPointClip p1, p2, p3, p4;
			p1.x = pShapeSrc->pMtp[0].lng;
			p1.y = pShapeSrc->pMtp[0].lat;
			p2.x = pShapeSrc->pMtp[0].lng;
			p2.y = pShapeSrc->pMtp[1].lat;
			p3.x = pShapeSrc->pMtp[1].lng;
			p3.y = pShapeSrc->pMtp[1].lat;
			p4.x = pShapeSrc->pMtp[1].lng;
			p4.y = pShapeSrc->pMtp[0].lat;
			pPointsSrc.push_back(p1);
			pPointsSrc.push_back(p2);
			pPointsSrc.push_back(p3);
			pPointsSrc.push_back(p4);
		}
		else
		{
			for (int i = 0; i < pShapeSrc->nMtp; i++)
			{
				
				tagPointClip p;
				p.x = pShapeSrc->pMtp[i].lng;
				p.y = pShapeSrc->pMtp[i].lat;
				pPointsSrc.push_back(p);
			}
			std::vector<tagPointClip> sv = MyGetEllipseSample(pPointsSrc, pShapeSrc->dStartAngle, pShapeSrc->dEndAngle, isYAxixToDown);
			pPointsSrc.clear();
			pPointsSrc.assign(sv.begin(), sv.end());
		}
		
		//char strUtf8[1000];
		//strcpy(strUtf8, pShapeSrc->strName);
		//strcat(strUtf8, "_1");
		//tagOApiMapShapeV1* pShape = g_omapApi.NewOmapShape();;
		//strncpy_s(pShape->strName, strUtf8, strlen(strUtf8));
		//pShape->nMtp = pPointsSrc.size();
		//pShape->pMtp = (tagOApiMapTrackPointV1*)OApiZeroMalloc(sizeof(tagOApiMapTrackPointV1)* pShape->nMtp);
		//for (int i = 0; i < pShape->nMtp; i++)
		//{
		//	pShape->pMtp[i].lat = pPointsSrc.at(i).y;
		//	pShape->pMtp[i].lng = pPointsSrc.at(i).x;

		//	
		///*	char str[1000];
		//	sprintf_s(str, "p_%d",i);
		//	
		//	tagOApiMapSignV1* pSign = g_omapApi.NewOmapSign();
		//	strncpy_s(pSign->strName, str, sizeof(pSign->strName));
		//	pSign->lat = pPointsSrc.at(i).y;
		//	pSign->lng = pPointsSrc.at(i).x;
		//	pSign->iSignPic = 1;
		//	pSign->iTxtType = 1;
		//	 g_omapApi.SetOmapObject(0, pSign, 0, 0);
		//	g_omapApi.FreeOmapObject(pSign, OMAP_OBJ_TYPE_SIGN);*/

		//	
		//}
		//int r = g_omapApi.SetOmapObject(0, pShape, 0, 0);
		//g_omapApi.FreeOmapObject(pShape, OMAP_OBJ_TYPE_SHAPE);
		//return false;
	}
	else
	{
		for (int i = 0; i < pShapeSrc->nMtp; i++)
		{
			if (pShapeSrc->pMtp[i].iAltitude == 65536)
			{
				break;
			}
			tagPointClip p;
			p.x = pShapeSrc->pMtp[i].lng;
			p.y = pShapeSrc->pMtp[i].lat;
			pPointsSrc.push_back(p);
		}
	}
	if (pPointsSrc.size()<3)
	{
		return false;
	}
	for (int i = 0; i < pTrackClip->nMtp; i++)
	{
		tagPointClip p;
		p.x = pTrackClip->pMtp[i].lng;
		p.y = pTrackClip->pMtp[i].lat;
		pPointsClip.push_back(p);
	}
	bool brc = clipPolygon(pPointsSrc, pPointsClip, vClip1, vClip2);
	if (brc)
	{
		if (vClip1.size()<3||vClip2.size()<3)
		{
			return false;
		}
		//char strUtf8[1000];
		//strcpy(strUtf8, pShapeSrc->strName);
		//strcat(strUtf8, "_1");
		//char strUtf82[1000];
		//strcpy(strUtf82, pShapeSrc->strName);
		//strcat(strUtf82, "_2");
		tagOApiMapShapeV1* pShape = pShapeClip1;
		//pShape->bRealLl = 2;
		//strncpy_s(pShape->strName, strUtf8,strlen(strUtf8));
		pShape->nMtp = (int)vClip1.size();
		pShape->pMtp = (tagOApiMapTrackPointV1*)OApiZeroMalloc(sizeof(tagOApiMapTrackPointV1)* pShape->nMtp);
		for (int i = 0; i < pShape->nMtp; i++)
		{
			pShape->pMtp[i].lat = vClip1.at(i).y;
			pShape->pMtp[i].lng = vClip1.at(i).x;
		}
		//int r = g_omapApi.SetOmapObject(0, pShape, 0, 0);
		//g_omapApi.FreeOmapObject(pShape, OMAP_OBJ_TYPE_SHAPE);
		
		//if (r != 0)
		//	return false;
		tagOApiMapShapeV1* pShape2 = pShapeClip2;
		//pShape2->bRealLl = 2;
		//strncpy_s(pShape2->strName, strUtf82, strlen(strUtf8));
		pShape2->nMtp = (int)vClip2.size();
		pShape2->pMtp = (tagOApiMapTrackPointV1*)OApiZeroMalloc(sizeof(tagOApiMapTrackPointV1)* pShape2->nMtp);
		for (int i = 0; i < pShape2->nMtp; i++)
		{
			pShape2->pMtp[i].lat = vClip2.at(i).y;
			pShape2->pMtp[i].lng = vClip2.at(i).x;
		}
		//r = g_omapApi.SetOmapObject(0, pShape2, 0, 0);
		//g_omapApi.FreeOmapObject(pShape2, OMAP_OBJ_TYPE_SHAPE);

		//if (r != 0)
		//	return false;
		return true;
	}
	return false;
}
